#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ddns_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ddns_pwd(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_user_domain(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dyn_domain(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tl_domain(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ddns_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_ddns_name(const char *value);
static int t2r_ddns_pwd(const char *value);
static int t2r_user_domain(const char *value);
static int t2r_dyn_domain(const char *value);
static int t2r_tl_domain(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"poe_account_list",r2t_poe_account_list,NULL},
	{"ddns_name",r2t_ddns_name,t2r_ddns_name},
	{"ddns_pwd",r2t_ddns_pwd,t2r_ddns_pwd},
	{"user_domain",r2t_user_domain,t2r_user_domain},
	{"dyn_domain",r2t_dyn_domain,t2r_dyn_domain},
	{"tl_domain",r2t_tl_domain,t2r_tl_domain},
	{"ddns_message",r2t_ddns_message,NULL},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "ddns_cgi.c"

/*************************/
