#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_reboot(const char *value);
static int t2r_restore(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"reboot",NULL,t2r_reboot},
	{"restore",NULL,t2r_restore},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "diag_cgi.c"

/*************************/
