#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_serv_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_service(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_svc_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_port_start(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_port_finish(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_icmp_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_serv_list(const char *value);
static int t2r_delete(const char *value);
static int t2r_ud_service(const char *value);
static int t2r_svc_type(const char *value);
static int t2r_port_start(const char *value);
static int t2r_port_finish(const char *value);
static int t2r_icmp_type(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"serv_list",r2t_serv_list,t2r_serv_list},
	{"delete",NULL,t2r_delete},
	{"ud_service",r2t_ud_service,t2r_ud_service},
	{"svc_type",r2t_svc_type,t2r_svc_type},
	{"port_start",r2t_port_start,t2r_port_start},
	{"port_finish",r2t_port_finish,t2r_port_finish},
	{"icmp_type",r2t_icmp_type,t2r_icmp_type},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "fw_serv_cgi.c"

/*************************/
