#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_group_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_access_rights(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_access_sch(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_service_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_group_list(const char *value);
static int t2r_members(const char *value);
static int t2r_access_rights(const char *value);
static int t2r_access_sch(const char *value);
static int t2r_sch_def(const char *value);
static int t2r_service_name(const char *value);
static int t2r_help1(const char *value);
static int t2r_help2(const char *value);
static int t2r_clear_ac_log(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_todo(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"group_list",r2t_group_list,t2r_group_list},
	{"members",NULL,t2r_members},
	{"poe_account_list",r2t_poe_account_list,NULL},
	{"access_rights",r2t_access_rights,t2r_access_rights},
	{"access_sch",r2t_access_sch,t2r_access_sch},
	{"sch_def",NULL,t2r_sch_def},
	{"service_name",r2t_service_name,t2r_service_name},
	{"help1",NULL,t2r_help1},
	{"help2",NULL,t2r_help2},
	{"clear_ac_log",NULL,t2r_clear_ac_log},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"todo",r2t_todo,t2r_todo},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "groups_cgi.c"

/*************************/
