#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t__group_name_(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_group_pc_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_other_pc_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_group_pc_list(const char *value);
static int t2r_del(const char *value);
static int t2r_add(const char *value);
static int t2r_other_pc_list(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"_group_name_",r2t__group_name_,NULL},
	{"group_pc_list",r2t_group_pc_list,t2r_group_pc_list},
	{"del",NULL,t2r_del},
	{"add",NULL,t2r_add},
	{"other_pc_list",r2t_other_pc_list,t2r_other_pc_list},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "grp_mem_cgi.c"

/*************************/
