#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_url_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_u_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_url_list(const char *value);
static int t2r_u_delete(const char *value);
static int t2r_u_deleall(const char *value);
static int t2r_u_name(const char *value);
static int t2r_u_add(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"url_list",r2t_url_list,t2r_url_list},
	{"u_delete",NULL,t2r_u_delete},
	{"u_deleall",NULL,t2r_u_deleall},
	{"u_name",r2t_u_name,t2r_u_name},
	{"u_add",NULL,t2r_u_add},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "i_urlf_cgi.c"

/*************************/
