#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_r_dest_pclist(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sap_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sap_pc_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dmz(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pc_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sap_dest(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_sap_list(const char *value);
static int t2r_sap_pc_list(const char *value);
static int t2r_udsp(const char *value);
static int t2r_dmz(const char *value);
static int t2r_pc_list(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_sap_dest(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"r_dest_pclist",r2t_r_dest_pclist,NULL},
	{"sap_list",r2t_sap_list,t2r_sap_list},
	{"sap_pc_list",r2t_sap_pc_list,t2r_sap_pc_list},
	{"udsp",NULL,t2r_udsp},
	{"poe_account_list",r2t_poe_account_list,NULL},
	{"dmz",r2t_dmz,t2r_dmz},
	{"pc_list",r2t_pc_list,t2r_pc_list},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"sap_dest",r2t_sap_dest,t2r_sap_dest},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "internet_cgi.c"

/*************************/
