#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_lan_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dhcp(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_start_ip_addr(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_start_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_finish_ip_addr(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_finish_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_lan_ip_1(const char *value);
static int t2r_lan_ip_2(const char *value);
static int t2r_lan_ip_3(const char *value);
static int t2r_lan_ip_4(const char *value);
static int t2r_lan_mask_1(const char *value);
static int t2r_lan_mask_2(const char *value);
static int t2r_lan_mask_3(const char *value);
static int t2r_lan_mask_4(const char *value);
static int t2r_dhcp(const char *value);
static int t2r_start_ip_4(const char *value);
static int t2r_finish_ip_4(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"LAN_IP_1",r2t_lan_ip_1,t2r_lan_ip_1},
	{"LAN_IP_2",r2t_lan_ip_2,t2r_lan_ip_2},
	{"LAN_IP_3",r2t_lan_ip_3,t2r_lan_ip_3},
	{"LAN_IP_4",r2t_lan_ip_4,t2r_lan_ip_4},
	{"LAN_MASK_1",r2t_lan_mask_1,t2r_lan_mask_1},
	{"LAN_MASK_2",r2t_lan_mask_2,t2r_lan_mask_2},
	{"LAN_MASK_3",r2t_lan_mask_3,t2r_lan_mask_3},
	{"LAN_MASK_4",r2t_lan_mask_4,t2r_lan_mask_4},
	{"dhcp",r2t_dhcp,t2r_dhcp},
	{"start_ip_addr",r2t_start_ip_addr,NULL},
	{"START_IP_4",r2t_start_ip_4,t2r_start_ip_4},
	{"finish_ip_addr",r2t_finish_ip_addr,NULL},
	{"FINISH_IP_4",r2t_finish_ip_4,t2r_finish_ip_4},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "lan_cgi.c"

/*************************/
