#ifndef _LAN_CGI_C_
#define _LAN_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lan.h"
#include "dev_opt.h"

static int r2t_lan_ip_1(char buf[CGI_BUF_LEN],char **buf1){	
	sprintf(buf,"%u",*((unsigned char*)&(lan_conf.LanIPAddr)));
    return 0;
}
	
static int r2t_lan_ip_2(char buf[CGI_BUF_LEN],char **buf1){
	sprintf(buf,"%u",*(((unsigned char*)&(lan_conf.LanIPAddr))+1));
    return 0;
}
	
static int r2t_lan_ip_3(char buf[CGI_BUF_LEN],char **buf1){
	sprintf(buf,"%u",*(((unsigned char*)&(lan_conf.LanIPAddr))+2));
    return 0;
}
	
static int r2t_lan_ip_4(char buf[CGI_BUF_LEN],char **buf1){
	sprintf(buf,"%u",*(((unsigned char*)&(lan_conf.LanIPAddr))+3));
    return 0;
}
	
static int r2t_lan_mask_1(char buf[CGI_BUF_LEN],char **buf1){	
	sprintf(buf,"%u",*((unsigned char*)&(lan_conf.NetMaskIPAddr)));
    return 0;
}

static int r2t_lan_mask_2(char buf[CGI_BUF_LEN],char **buf1){
	sprintf(buf,"%u",*(((unsigned char*)&(lan_conf.NetMaskIPAddr))+1));
    return 0;
}
	
static int r2t_lan_mask_3(char buf[CGI_BUF_LEN],char **buf1){
	sprintf(buf,"%u",*(((unsigned char*)&(lan_conf.NetMaskIPAddr))+2));
    return 0;
}
	
static int r2t_lan_mask_4(char buf[CGI_BUF_LEN],char **buf1){
	sprintf(buf,"%u",*(((unsigned char*)&(lan_conf.NetMaskIPAddr))+3));
    return 0;
}
	
static int r2t_dhcp(char buf[CGI_BUF_LEN],char **buf1){ 
    if(lan_conf.DhcpEnable == DHCP_ENABLE){
        strcpy(buf,str_checked);
    }
    return 0;
} 
   
static int r2t_start_ip_addr(char buf[CGI_BUF_LEN],char **buf1){
     sprintf(buf,"%u.%u.%u.",
            *((unsigned char*)&(lan_conf.StartIp)),
            *(((unsigned char*)&(lan_conf.StartIp))+1),
            *(((unsigned char*)&(lan_conf.StartIp))+2));
     return 0;
}
	
static int r2t_start_ip_4(char buf[CGI_BUF_LEN],char **buf1){
     sprintf(buf,"%u",*(((unsigned char*)&(lan_conf.StartIp))+3));
     return 0;
}
	
static int r2t_finish_ip_addr(char buf[CGI_BUF_LEN],char **buf1){
     sprintf(buf,"%u.%u.%u.",
            *((unsigned char*)&(lan_conf.FinishIp)),
            *(((unsigned char*)&(lan_conf.FinishIp))+1),
            *(((unsigned char*)&(lan_conf.FinishIp))+2));
     return 0;
}
	
static int r2t_finish_ip_4(char buf[CGI_BUF_LEN],char **buf1){
     sprintf(buf,"%u",*(((unsigned char*)&(lan_conf.FinishIp))+3));
     return 0;
}
		
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1){     
     return 0;
}
	
static int t2r_lan_ip_1(const char *value){
    BYTE *p = (BYTE *)&lan_conf.LanIPAddr;
    
    *(p+0) = atoi(value);
    return 0;
}
	
static int t2r_lan_ip_2(const char *value){
    BYTE *p = (BYTE *)&lan_conf.LanIPAddr;
    
    *(p+1) = atoi(value);
    return 0;
}
	
static int t2r_lan_ip_3(const char *value){
    BYTE *p = (BYTE *)&lan_conf.LanIPAddr;
    
    *(p+2) = atoi(value);
    return 0;
}
	
static int t2r_lan_ip_4(const char *value){
    BYTE *p = (BYTE *)&lan_conf.LanIPAddr;
    
    *(p+3) = atoi(value);
    return 0;
}	

static int t2r_lan_mask_1(const char *value){
    BYTE *p = (BYTE *)&lan_conf.NetMaskIPAddr;
    
    *(p+0) = atoi(value);
    return 0;
}
	
static int t2r_lan_mask_2(const char *value){
    BYTE *p = (BYTE *)&lan_conf.NetMaskIPAddr;
    
    *(p+1) = atoi(value);
    return 0;
}
	
static int t2r_lan_mask_3(const char *value){
    BYTE *p = (BYTE *)&lan_conf.NetMaskIPAddr;
    
    *(p+2) = atoi(value);
    return 0;
}	
static int t2r_lan_mask_4(const char *value){
    BYTE *p = (BYTE *)&lan_conf.NetMaskIPAddr;
    
    *(p+3) = atoi(value);
    return 0;
}

static BYTE dhcp;
static int t2r_dhcp(const char *value){
	dhcp |= DHCP_ENABLE;
    return 0;
}	

static int t2r_start_ip_4(const char *value){
    BYTE *p = (BYTE *)&lan_conf.StartIp;

    *(p+3)=atoi(value);
    return 0;
}	

static int t2r_finish_ip_4(const char *value){
    BYTE *p = (BYTE *)&lan_conf.FinishIp;


    *(p+3)=atoi(value);
    return 0;
}	

static int t2r_save(const char *value){
	return 0;
}	

static int t2r_help(const char *value){
	return 0;
}
	
static int t2r_message(const char *value){
	return 0;
}	

int lan_main(void)
{
	
    LIST *hd=NULL;
    LAN_CONF *pConf=&lan_conf;
    int ccode;
    BYTE *pIP,*pStart,*pFinish;
	int i;
	
    dhcp = 0;
	
    ReadLanSettings(pConf);
	
    if (strcmp(REQUEST_METHOD,POST) == 0){
    	hd=cgi_input_parse();
    	if(!hd){
	        cgi_err("","");
	    }		
    	if(!do_cgi_t2r(hd,key_fun_tab)){
    	    pConf->DhcpEnable = dhcp;
    	    
    	    pIP = (BYTE *)&pConf->LanIPAddr;
    	    pStart = (BYTE *)&pConf->StartIp;
    	    pFinish = (BYTE *)&pConf->FinishIp;
    	    for(i=0; i<3; i++){
    	        *(pStart + i) = *(pFinish + i) = *(pIP + i);
    	    }
    	    ccode=SaveLanSettings(pConf);
			if(!ccode)
    	    WriteConfToFlash();
    	    if(fork()==0){
    	    	cgi_fork_do();
				StartLAN(0);
				exit(0);
			}
    	}
		list_clear(hd);
    }
    return html_parser("lan.htm",key_fun_tab);
    
}

#endif /* _LAN_CGI_C_ */

