#include "routing.h"

static rt_table *route_table;
static int route_num=0;

#define IP_STR_LEN 20
#define MT_STR_LEN 8

int r2t_dest_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	rt_table *p=route_table;
	if(route_num<0)
		return 0;
	*buf1=malloc(route_num*IP_STR_LEN);
	if(*buf1==NULL)
		return 1;
	memset(*buf1,0,route_num*IP_STR_LEN);
	for(i=0;p&&i<route_num;i++){
		strcat(*buf1,p->ipaddr);
		strcat(*buf1,str_brk);
		p=p->next;
	}
	return 0;
}

int r2t_mask_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	rt_table *p=route_table;
	if(route_num<0)
		return 0;
	*buf1=malloc(route_num*IP_STR_LEN);
	if(*buf1==NULL)
		return 1;
	memset(*buf1,0,route_num*IP_STR_LEN);
	for(i=0;p&&i<route_num;i++){
		strcat(*buf1,p->netmask);
		strcat(*buf1,str_brk);
		p=p->next;
	}
	return 0;
}

int r2t_gw_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	rt_table *p=route_table;
	if(route_num<0)
		return 0;
	*buf1=malloc(route_num*IP_STR_LEN);
	if(*buf1==NULL)
		return 1;
	memset(*buf1,0,route_num*IP_STR_LEN);
	for(i=0;p&&i<route_num;i++){
		strcat(*buf1,p->gateway);
		strcat(*buf1,str_brk);
		p=p->next;
	}
	return 0;
}

int r2t_mt_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	rt_table *p=route_table;
	char tmp[3];
	if(route_num<0)
		return 0;
	*buf1=malloc(route_num*MT_STR_LEN);
	if(*buf1==NULL)
		return 1;
	memset(*buf1,0,route_num*MT_STR_LEN);
	for(i=0;p&&i<route_num;i++){
		sprintf(tmp,"%d",p->metric);
		strcat(*buf1,tmp);
		strcat(*buf1,str_brk);
		p=p->next;
	}	
	return 0;
}

int list_rt_main()
{
	GetAllRoute(&route_table,&route_num);
	return html_parser("list_rt.htm",key_fun_tab);
}

