
#ifdef _BB_DEBUG_
extern char bb_buf[];
extern void bb_trace(char *pFormatString, ...);
#endif

#ifndef _LIST_WK_CGI_C_
#define _LIST_WK_CGI_C_
#include <stdio.h>
#include <string.h>

#include "lan.h"
#include "h_bmsg.h"

int r2t_name_list(char buf[CGI_BUF_LEN],char **buf1)
{
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    short len=0;

    *buf1 = malloc((WK_NAME_LEN + strlen(str_brk)) * p_pcdb_conf->number);
    
    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }

    for (i=0, p_entry=p_pcdb_conf->p_database; i<p_pcdb_conf->number && p_entry; i++)
    {
        len += sprintf(*buf1+len, "%s", p_entry->name);
        len += sprintf(*buf1+len, "%s", str_brk);
        p_entry = p_entry->next;
    }
    return (0);
}

int r2t_ip_add_list(char buf[CGI_BUF_LEN],char **buf1)
{
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    short len=0;

    *buf1 = malloc((sizeof("255.255.255.255") + strlen(str_brk)) * p_pcdb_conf->number);
    
    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }

    for (i=0, p_entry=p_pcdb_conf->p_database; i<p_pcdb_conf->number && p_entry; i++)
    {
        len += sprintf(*buf1+len, " (%u.%u.%u.%u) ", p_entry->ip_addr[0], p_entry->ip_addr[1], p_entry->ip_addr[2], p_entry->ip_addr[3]);
        len += sprintf(*buf1+len, "%s", str_brk);
        p_entry = p_entry->next;
    }
    return (0);
}

int r2t_ph_add_list(char buf[CGI_BUF_LEN],char **buf1)
{
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    unsigned char mac_addr[18];
    short len=0;

    *buf1 = malloc((sizeof("00-00-00-00-00-00") + strlen(str_brk)) * p_pcdb_conf->number);
    
    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }

    for (i=0, p_entry=p_pcdb_conf->p_database; i<p_pcdb_conf->number && p_entry; i++)
    {
	    printf_haddr(mac_addr, p_entry->mac_addr, '-');
        len += sprintf(*buf1+len, " (%s) ", mac_addr);
        len += sprintf(*buf1+len, "%s", str_brk);
        p_entry = p_entry->next;
    }
    return (0);
}

int r2t_port_list(char buf[CGI_BUF_LEN],char **buf1)
{
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    short len=0;

    *buf1 = malloc((20 + strlen(str_brk)) * p_pcdb_conf->number);
    
    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }

    for (i=0, p_entry=p_pcdb_conf->p_database; i<p_pcdb_conf->number && p_entry; i++)
    {
        len += sprintf(*buf1+len, " (%s) ", str_pctype_db(p_entry->iface));
        len += sprintf(*buf1+len, "%s", str_brk);
        p_entry = p_entry->next;
    }
    return (0);
}

int r2t_status_list(char buf[CGI_BUF_LEN],char **buf1)
{
    short i;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;
    short len=0;

    *buf1 = malloc((20 + strlen(str_brk)) * p_pcdb_conf->number);
    
    if(!*buf1){ /*fail to allocate memory. */
        return 0;
    }

    for (i=0, p_entry=p_pcdb_conf->p_database; i<p_pcdb_conf->number && p_entry; i++)
    {
        len += sprintf(*buf1+len, " (%s) ", str_pcreserve_db(p_entry->reserve));
        len += sprintf(*buf1+len, "%s", str_brk);
        p_entry = p_entry->next;
    }
    return (0);
}

static int t2r_refresh(const char *value){
    return (0);
}

static int t2r_close(const char *value){
    return (0);
}

int list_wk_main()
{
	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;

	ReadPCDBConf(p_pcdb_conf);

	return html_parser("list_wk.htm",key_fun_tab);
}
#endif
