#ifndef	_LOG_AC_CGI_C_
#define	_LOG_AC_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "logging.h"
#include "parser.h"

access_log *accesslog;
int accessnum=0;

static int r2t_date_list(char buf[CGI_BUF_LEN],char **buf1)
{
	access_log *list;
	
	if(accessnum==0)
		return 0;
	list=accesslog;
	*buf1=malloc(accessnum*12);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,accessnum*12);
	while(list){
		strcat(*buf1,list->date);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_time_list(char buf[CGI_BUF_LEN],char **buf1)
{
	access_log *list;
	
	if(accessnum==0)
		return 0;
	list=accesslog;
	*buf1=malloc(accessnum*12);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,accessnum*12);
	while(list){
		strcat(*buf1,list->time);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_name_list(char buf[CGI_BUF_LEN],char **buf1)
{
	access_log *list;
	
	if(accessnum==0)
		return 0;
	list=accesslog;
	*buf1=malloc(accessnum*22);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,accessnum*22);
	while(list){
		strcat(*buf1,list->pcname);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_ip_add_list(char buf[CGI_BUF_LEN],char **buf1)
{
	access_log *list;
	
	if(accessnum==0)
		return 0;
	list=accesslog;
	*buf1=malloc(accessnum*20);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,accessnum*20);
	while(list){
		strcat(*buf1,list->saddr);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_ph_add_list(char buf[CGI_BUF_LEN],char **buf1)
{
	access_log *list;
	
	if(accessnum==0)
		return 0;
	list=accesslog;
	*buf1=malloc(accessnum*22);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,accessnum*22);
	while(list){
		strcat(*buf1,list->mac);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_dest_list(char buf[CGI_BUF_LEN],char **buf1)
{
	access_log *list;
	
	if(accessnum==0)
		return 0;
	list=accesslog;
	*buf1=malloc(accessnum*20);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,accessnum*20);
	while(list){
		strcat(*buf1,list->dst);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_port_list(char buf[CGI_BUF_LEN],char **buf1)
{
	access_log *list;
	char port[6];
	
	if(accessnum==0)
		return 0;
	list=accesslog;
	*buf1=malloc(accessnum*12);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,accessnum*12);
	while(list){
		sprintf(port,"%d",list->port);
		strcat(*buf1,port);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}


static int t2r_back(const char *value)
{
	return 0;
}

static int t2r_close(const char *value)
{
	return 0;
}

int log_ac_main(void)
{
    
	int ccode;
	
	ccode=GetAccessLog(&accesslog,&accessnum);
   	ccode=html_parser("log_ac.htm",key_fun_tab);
	if(accesslog)
		FreeAccessLog(accesslog);
		
   	return ccode;
}


#endif
