#ifndef _LOG_FW_CGI_C_
#define _LOG_FW_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "logging.h"
#include "parser.h"

dos_log *doslog;
int dosnum=0;

static int r2t__date_(char buf[CGI_BUF_LEN],char **buf1)
{
	struct tm *tm;
	time_t timep;
	
	time(&timep);
	tm = localtime(&timep);
	strftime(buf, 12, "%Y-%m-%d", tm);
	
	return 0;
}

static int r2t_time_list(char buf[CGI_BUF_LEN],char **buf1)
{	
	dos_log *list;
	
	if(dosnum==0)
		return 0;
	list=doslog;
	*buf1=malloc(dosnum*12);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,dosnum*12);
	while(list){
		strcat(*buf1,list->time);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_inout_list(char buf[CGI_BUF_LEN],char **buf1)
{
	dos_log *list;
	
	if(dosnum==0)
		return 0;
	list=doslog;
	*buf1=malloc(dosnum*16);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,dosnum*16);
	while(list){
		strcat(*buf1,list->direction);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_pk_list(char buf[CGI_BUF_LEN],char **buf1)
{
	dos_log *list;
	
	if(dosnum==0)
		return 0;
	list=doslog;
	*buf1=malloc(dosnum*48);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,dosnum*48);
	while(list){
		strcat(*buf1,list->information);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_act_list(char buf[CGI_BUF_LEN],char **buf1)
{
	dos_log *list;
	
	if(dosnum==0)
		return 0;
	list=doslog;
	*buf1=malloc(dosnum*12);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,dosnum*12);
	while(list){
		strcat(*buf1,list->action);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int r2t_reason_list(char buf[CGI_BUF_LEN],char **buf1)
{
	dos_log *list;
	
	if(dosnum==0)
		return 0;
	list=doslog;
	*buf1=malloc(dosnum*16);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,dosnum*16);
	while(list){
		strcat(*buf1,list->reason);
		strcat(*buf1,str_brk);
		list=list->next;
	}
	return 0;
}

static int t2r_back(const char *value)
{
	return 0;
}

static int t2r_close(const char *value)
{
	return 0;
}

int log_fw_main(void)
{
	int ccode;
	
	ccode=GetDosLog(&doslog,&dosnum);
   	ccode=html_parser("log_fw.htm",key_fun_tab);
	if(doslog)
		FreeDosLog(doslog);
		
   	return ccode;
}
#endif
