#ifndef _LOGGING_CGI_C_
#define _LOGGING_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "logging.h"
#include "parser.h"
#include "fw.h"
#include "wan.h"         //ada
#include "system.h"          //ada

static log_conf conf;  //ada
static int wan_type;  //ada
static int logging_poe_session_index;  //ada
static enum{
        CHANGE_SESSION,
	CLEAR_OUT,
	CLEAR_AC,
	CLEAR_FW,
	LOG_SAVE,
	ALL_ITEM
}which_submit;

static int r2t_out_log(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	if(conf.outlog_en)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_ac_log(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	if(conf.inlog_en)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_fw_log(char buf[CGI_BUF_LEN],char **buf1)
{
	buf[0]='\0';
	if(conf.fwlog_en)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
	return 0;
}

static int r2t_poe_session_value(char buf[CGI_BUF_LEN],char **buf1)
{	
        strcpy(buf,session_db[logging_poe_session_index+1]);       //ada  		
	return 0;
}

static int r2t_poe_session_list(char buf[CGI_BUF_LEN],char **buf1)
{
	//ada
	INT16 i;
    
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){
	        strcpy(buf,"<caption> ڑw: <select name=\"poe_session_list\" size=\"1\" onChange=\"changeSession()\"> ");
	        for(i=0;i<MAX_PPPOE_SESSION;i++){
	            if(i == logging_poe_session_index){
	                strcat(buf,option_sl);
	            }
	            else{
	                strcat(buf,option_s);
	            }
 	           strcat(buf,session_db[i+1]);
	           strcat(buf,option_e);
 	       }
	       strcat(buf,"</select></caption>");
	}//ada    	
	return 0;
}

static int t2r_out_log(const char *value)
{
	conf.outlog_en=1;
	return 0;
}
static int t2r_view_out_log(const char *value)
{
	return 0;
}

static int t2r_clear_out_log(const char *value)
{
	which_submit=CLEAR_OUT;
	return 0;
}

static int t2r_ac_log(const char *value)
{
	conf.inlog_en=1;
	return 0;
}

static int t2r_view_ac_log(const char *value)
{
	return 0;
}

static int t2r_clear_ac_log(const char *value)
{
	which_submit=CLEAR_AC;
	return 0;
}

static int t2r_fw_log(const char *value)
{
	conf.fwlog_en=1;
	return 0;
}

static int t2r_view_fw_log(const char *value)
{
	return 0;
}

static int t2r_clear_fw_log(const char *value)
{
	which_submit=CLEAR_FW;
	return 0;
}

static int t2r_save(const char *value)
{
	which_submit=LOG_SAVE;
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_close(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}


static int t2r_poe_session_value(const char *value)
{
	//ada
	int i;
	if(*value){
	    for(i=0;*value&&i<MAX_PPPOE_SESSION;i++){
	        if(!strcmp(value,session_db[i+1])){
	            logging_poe_session_index = i;  
	            break;
	        }
	    }	
	} //ada    
	return 0;
}

int logging_main(void)
{
	LIST *hd=NULL;
	char buf[32];
	int ccode;
	
	//ada
	memset(glb_errlog,0,sizeof(glb_errlog));	
	which_submit = CHANGE_SESSION;  			
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){
		logging_poe_session_index=0;		
	}
	else
	{
		logging_poe_session_index=-1;		
	}
	memset(&conf,0,sizeof(log_conf));		
	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!hd)
			cgi_err("","");
		if(!do_cgi_t2r(hd,key_fun_tab)){
			switch(which_submit){
				case CLEAR_OUT:
					sprintf(buf,"/bin/rm -f %s",FILTERLOG);
					system(buf);
					break;
				case CLEAR_AC:
					sprintf(buf,"/bin/rm -f %s",ACCESSLOG);
					system(buf);
					break;
				case CLEAR_FW:	
					sprintf(buf,"/bin/rm -f %s",DOSLOG);
					system(buf);
					break;
				case LOG_SAVE:
					ccode=SaveLogging(&conf,logging_poe_session_index);
					break;
				case CHANGE_SESSION:      //ada
					ReadLogging(&conf,logging_poe_session_index);   //ada
					break;   //ada
				default:
					break;
			}
			WriteConfToFlash();
		}
		list_clear(hd);
	}
	else
		ReadLogging(&conf,logging_poe_session_index);  //ada
	ccode=html_parser("logging.htm",key_fun_tab);
	return ccode;
}
#endif

