#ifndef _ALL_MK_H_
#define _ALL_MK_H_
/* This file shoule be include by all mk*.h */

#define LAN_IP_DEFAULT                  "192.168.1.1"
#define LAN_MASK_DEFAULT                "255.255.255.0"
#define LAN_IP2_DEFAULT                 "0.0.0.0"
#define LAN_MASK2_DEFAULT               "0.0.0.0"
#define LAN_BROADCAST_DEFAULT           "192.168.1.255"
#define LAN_START_IP_DEFAULT            "192.168.1.11"
#define LAN_END_IP_DEFAULT              "192.168.1.60"
#define LAN_DHCPD_ENABLE_DEFAULT        "yes"
#define WAN_CONNECTION_DEFAULT          "DHCP"
#define WAN_DHCPC_TYPE_DEFAULT          "Dynamic"
#define WAN_IP_DEFAULT                  "0.0.0.0"
#define WAN_MASK_DEFAULT                "0.0.0.0"
#define WAN_BROADCAST_DEFAULT           "0.0.0.0"
#define WAN_GATEWAY_DEFAULT             "0.0.0.0"
#define WAN_DNS_DEFAULT                 "0.0.0.0"
#define WAN_SPPPoE_DEMAND_DEFAULT       "900"
#define WAN_SPPPoE_IDLE_TIME_DEFAULT    "0"



#define MDM_TELEPHONE_DEFAULT           ""
#define MDM_SPEED_DEFAULT               "57600"
#define MDM_RETRY_DEFAULT               "no"
#define MDM_IDLETIME_DEFAULT            "15"
#define MDM_FIXDNS_DEFAULT              "no"
#define MDM_DNS1_DEFAULT                "0.0.0.0"
#define MDM_DNS2_DEFAULT                "0.0.0.0"
#define MDM_DEMAND_DEFAULT              "15"
#define MDM_IDLE_TIME_DEFAULT           "0"


enum{
    IFACE_ETH0,
    IFACE_ETH1
};

enum{
    YESNO_YES,
    YESNO_NO
};

enum{
    DNSTYPE_NOCHANGE,
    DNSTYPE_SPECIFY,
    DNSTYPE_SERVER
};

enum{
    FIREWALL_NONE,
    FIREWALL_ALONE,
    FIREWALL_MASQ
};


extern char *interface_str[];
extern char *yes_no[];
extern char *dnsType[];
extern char *firewall[];


#endif /* _ALL_MK_H_ */
