#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_poe_ac_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_user_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_password(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_telephone(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_at_cmd(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_connect_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_idle_time(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ser_speed(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pppd_retry_sw(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pppd_retry_sw_disable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns_type_fixed(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dns1_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_poe_ac_name(const char *value);
static int t2r_user_name(const char *value);
static int t2r_password(const char *value);
static int t2r_telephone(const char *value);
static int t2r_at_cmd(const char *value);
static int t2r_connect_type(const char *value);
static int t2r_idle_time(const char *value);
static int t2r_ser_speed(const char *value);
static int t2r_pppd_retry_sw(const char *value);
static int t2r_dns_type(const char *value);
static int t2r_dns1_ip_1(const char *value);
static int t2r_dns1_ip_2(const char *value);
static int t2r_dns1_ip_3(const char *value);
static int t2r_dns1_ip_4(const char *value);
static int t2r_back(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"poe_ac_name",r2t_poe_ac_name,t2r_poe_ac_name},
	{"user_name",r2t_user_name,t2r_user_name},
	{"password",r2t_password,t2r_password},
	{"telephone",r2t_telephone,t2r_telephone},
	{"at_cmd",r2t_at_cmd,t2r_at_cmd},
	{"connect_type",r2t_connect_type,t2r_connect_type},
	{"idle_time",r2t_idle_time,t2r_idle_time},
	{"ser_speed",r2t_ser_speed,t2r_ser_speed},
	{"PPPD_RETRY_SW",r2t_pppd_retry_sw,t2r_pppd_retry_sw},
	{"PPPD_RETRY_SW_Disable",r2t_pppd_retry_sw_disable,NULL},
	{"dns_type",r2t_dns_type,t2r_dns_type},
	{"dns_type_fixed",r2t_dns_type_fixed,NULL},
	{"DNS1_IP_1",r2t_dns1_ip_1,t2r_dns1_ip_1},
	{"DNS1_IP_2",r2t_dns1_ip_2,t2r_dns1_ip_2},
	{"DNS1_IP_3",r2t_dns1_ip_3,t2r_dns1_ip_3},
	{"DNS1_IP_4",r2t_dns1_ip_4,t2r_dns1_ip_4},
	{"back",NULL,t2r_back},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "modem_cgi.c"

/*************************/
