#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_login_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_password(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_password_v(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_login_name(const char *value);
static int t2r_password(const char *value);
static int t2r_password_v(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"login_name",r2t_login_name,t2r_login_name},
	{"password",r2t_password,t2r_password},
	{"password_v",r2t_password_v,t2r_password_v},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "pass_wd_cgi.c"

/*************************/
