#ifndef _PASS_WD_CGI_C_
#define _PASS_WD_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "system.h"


enum{
    NO_ERROR,
    PASSWD_ERROR,
    USER_NAME_ERROR
};

char errlog[1];
static int r2t_login_name(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,system_conf.UserName);
    return 0;
}
 
static int r2t_password(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,"0123456789123");
    return 0;
}

static int r2t_password_v(char buf[CGI_BUF_LEN],char **buf1){
    strcpy(buf,"0123456789123");
    return 0;
}
    
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    return 0;
}
static char user[SYS_USER_LEN];
static int t2r_login_name(const char *value){
    if(strlen(value) >= SYS_USER_LEN){
        setbit(errlog,USER_NAME_ERROR);
        return 0;
    }    
    strcpy(user,value);
    return 0;
}
static char pass[SYS_PASSWD_LEN];
static char pass_v[SYS_PASSWD_LEN];
static int t2r_password(const char *value){
    if(strlen(value) >= SYS_CRYPT_LEN){
        setbit(errlog,PASSWD_ERROR);
        return 0;
    }    
    strcpy(pass,value);
    return 0;
}

static int t2r_password_v(const char *value){
    if(strlen(value) >= SYS_CRYPT_LEN){
        setbit(errlog,PASSWD_ERROR);
        return 0;
    }    
    strcpy(pass_v,value);
    return 0;
}

static int t2r_save(const char *value){
    return 0;
}

static int t2r_help(const char *value){
    return 0;
}

static int t2r_message(const char *value){
    return 0;
}

int pass_wd_main(void){
    
	LIST *hd=NULL;
	SYSTEM_CONF *pConf=&system_conf;
	int ccode;

	ReadSystemSettings(pConf);
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){
            if(errlog[0]){
    		    if(isset(errlog,USER_NAME_ERROR)){
                    char *msg = get_err_msg(MSG9_DEV_OPT);
                    fmt_err_msg(msg,SYS_USER_LEN-1);
                }
    		    if(isset(errlog,PASSWD_ERROR)){
                    char *msg = get_err_msg(MSG1_DEV_OPT);
                    fmt_err_msg(msg,SYS_PASSWD_LEN-1);
                }
                else{
                    if(strcmp(pass,pass_v)){
                        char *msg = get_err_msg(MSG2_DEV_OPT);
                        fmt_err_msg(msg);
                    }
                }
                return html_parser("pass_wd.htm",key_fun_tab);
            }
            strcpy(pConf->UserName,user);
            strcpy(pConf->Password,crypt_password(pass));
            ccode=SaveSystemSettings(pConf);
            if(System_OK == ccode){
                ccode=ChangePasswd(pConf);
                WriteConfToFlash();
            }            
        }
        list_clear(hd);
    }
    return html_parser("pass_wd.htm",key_fun_tab);
}

            
                
		        


#endif /* _PASS_WD_CGI_C_ */
