#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_pc_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_add_pc_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ip_prefix(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_add_ip_4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_pc_list(const char *value);
static int t2r_add_new_pc(const char *value);
static int t2r_add_pc_name(const char *value);
static int t2r_add_ip_4(const char *value);
static int t2r_delete_pc(const char *value);
static int t2r_refresh(const char *value);
static int t2r_list_pcs(const char *value);
static int t2r_adv_pcdb(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_todo(const char *value);


static keyfun_tab key_fun_tab[]={
	{"pc_list",r2t_pc_list,t2r_pc_list},
	{"add_new_pc",NULL,t2r_add_new_pc},
	{"add_pc_name",r2t_add_pc_name,t2r_add_pc_name},
	{"lan_ip_prefix",r2t_lan_ip_prefix,NULL},
	{"add_IP_4",r2t_add_ip_4,t2r_add_ip_4},
	{"delete_pc",NULL,t2r_delete_pc},
	{"refresh",NULL,t2r_refresh},
	{"list_pcs",NULL,t2r_list_pcs},
	{"adv_pcdb",NULL,t2r_adv_pcdb},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"todo",r2t_todo,t2r_todo},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "pc_db_cgi.c"

/*************************/
