#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_port_e(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_port_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_list_set(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_port(const char *value);
static int t2r_port_e(const char *value);
static int t2r_add(const char *value);
static int t2r_port_list(const char *value);
static int t2r_sel_all(const char *value);
static int t2r_sel_none(const char *value);
static int t2r_del(const char *value);
static int t2r_del_all(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);
static int t2r_poe_list_set(const char *value);


static keyfun_tab key_fun_tab[]={
	{"port",r2t_port,t2r_port},
	{"port_e",r2t_port_e,t2r_port_e},
	{"add",NULL,t2r_add},
	{"port_list",r2t_port_list,t2r_port_list},
	{"sel_all",NULL,t2r_sel_all},
	{"sel_none",NULL,t2r_sel_none},
	{"del",NULL,t2r_del},
	{"del_all",NULL,t2r_del_all},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{"poe_list_set",r2t_poe_list_set,t2r_poe_list_set},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "port_def_cgi.c"

/*************************/
