#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_account0(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_account1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_account2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_account3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_account4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session1_ac2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session1_ac3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session1_ac4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session1_ac5(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session2_ac2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session2_ac3(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session2_ac4(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session2_ac5(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_poe_ac_name0(const char *value);
static int t2r_poe_ac_name1(const char *value);
static int t2r_poe_ac_name2(const char *value);
static int t2r_poe_ac_name3(const char *value);
static int t2r_poe_ac_name4(const char *value);
static int t2r_poe_session1(const char *value);
static int t2r_poe_session2(const char *value);
static int t2r_back(const char *value);
static int t2r_next(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_todo(const char *value);


static keyfun_tab key_fun_tab[]={
	{"poe_ac_name0",NULL,t2r_poe_ac_name0},
	{"Account0",r2t_account0,NULL},
	{"poe_ac_name1",NULL,t2r_poe_ac_name1},
	{"Account1",r2t_account1,NULL},
	{"poe_ac_name2",NULL,t2r_poe_ac_name2},
	{"Account2",r2t_account2,NULL},
	{"poe_ac_name3",NULL,t2r_poe_ac_name3},
	{"Account3",r2t_account3,NULL},
	{"poe_ac_name4",NULL,t2r_poe_ac_name4},
	{"Account4",r2t_account4,NULL},
	{"poe_session1",r2t_poe_session1,t2r_poe_session1},
	{"poe_session1_ac2",r2t_poe_session1_ac2,NULL},
	{"poe_session1_ac3",r2t_poe_session1_ac3,NULL},
	{"poe_session1_ac4",r2t_poe_session1_ac4,NULL},
	{"poe_session1_ac5",r2t_poe_session1_ac5,NULL},
	{"poe_session2",r2t_poe_session2,t2r_poe_session2},
	{"poe_session2_ac2",r2t_poe_session2_ac2,NULL},
	{"poe_session2_ac3",r2t_poe_session2_ac3,NULL},
	{"poe_session2_ac4",r2t_poe_session2_ac4,NULL},
	{"poe_session2_ac5",r2t_poe_session2_ac5,NULL},
	{"back",NULL,t2r_back},
	{"next",NULL,t2r_next},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"todo",r2t_todo,t2r_todo},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "pppoe_ss_cgi.c"

/*************************/
