#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_remote_mg(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_remote_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dport_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_remote_mg(const char *value);
static int t2r_remote_port(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"poe_account_list",r2t_poe_account_list,NULL},
	{"remote_mg",r2t_remote_mg,t2r_remote_mg},
	{"remote_port",r2t_remote_port,t2r_remote_port},
	{"dport_ip",r2t_dport_ip,NULL},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "remotemg_cgi.c"

/*************************/
