#ifndef _ROUTING_CGI_C_
#define _ROURING_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "routing.h"
#include "parser.h"
#include "system.h"

static int which_submit;

enum{
	RT_DEL,
	RT_UPDATE,
	RT_ADD,
	SAVE,
	RT_ENUM_SIZE
};
static rt_table *table;
static int num=0;
int rip_enable,metric;
unsigned char ip[4];
static char newaddr[MaxIPLen],newmask[MaxIPLen],newgw[MaxIPLen];
static char *str_tododb[]={"del_item","update_item","add_item","save_item",0};

static int r2t_r_dest_ip1(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int ret,i;
	rt_table *ip_table;

	ret=GetRtList(&table,&num);
	if(ret)
		return GetRtListErr;
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->ipaddr,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[0]);
		else
			sprintf(tmp,"\"%d\",",ip[0]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	return 0;
}

static int r2t_r_dest_ip2(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->ipaddr,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[1]);
		else
			sprintf(tmp,"\"%d\",",ip[1]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_dest_ip3(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->ipaddr,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[2]);
		else
			sprintf(tmp,"\"%d\",",ip[2]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}
	
static int r2t_r_dest_ip4(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->ipaddr,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[3]);
		else
			sprintf(tmp,"\"%d\",",ip[3]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_mask_ip1(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->netmask,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[0]);
		else
			sprintf(tmp,"\"%d\",",ip[0]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_mask_ip2(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->netmask,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[1]);
		else
			sprintf(tmp,"\"%d\",",ip[1]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_mask_ip3(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->netmask,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[2]);
		else
			sprintf(tmp,"\"%d\",",ip[2]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_mask_ip4(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->netmask,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[3]);
		else
			sprintf(tmp,"\"%d\",",ip[3]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_gw_ip1(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->gateway,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[0]);
		else
			sprintf(tmp,"\"%d\",",ip[0]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_gw_ip2(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->gateway,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[1]);
		else
			sprintf(tmp,"\"%d\",",ip[1]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_gw_ip3(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->gateway,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[2]);
		else
			sprintf(tmp,"\"%d\",",ip[2]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_gw_ip4(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		extract_ip(ip_table->gateway,ip);
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip[3]);
		else
			sprintf(tmp,"\"%d\",",ip[3]);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_r_metric(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[8]={0};
	int i;
	rt_table *ip_table;
	
	if(num==0)
		return 0;
	*buf1=malloc(num*6);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*6);
	ip_table=table;
	for(i=0;i<num;i++){
		if(i+1==num)
			sprintf(tmp,"\"%d\"",ip_table->metric);
		else
			sprintf(tmp,"\"%d\",",ip_table->metric);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_rt_list(char buf[CGI_BUF_LEN],char **buf1)
{
	char tmp[28]={0};
	int i;
	rt_table *ip_table;

	if(num==0)
		return 0;
	*buf1=malloc(num*28);
	if(*buf1==NULL)
		return GetRtListErr;
	memset(*buf1,0,num*28);
	ip_table=table;
	for(i=1;i<=num;i++){
		sprintf(tmp,"%s%d)%s\n",option_s,i,ip_table->ipaddr);
		strcat(*buf1,tmp);
		ip_table=ip_table->next;
	}
	
	return 0;
}

static int r2t_dest_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{

	return 0;
}

static int r2t_dest_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_dest_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_dest_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_lan_mask_1(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_lan_mask_2(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_lan_mask_3(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_lan_mask_4(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_gw_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_gw_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_gw_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_gw_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_metric(char buf[CGI_BUF_LEN],char **buf1)
{	
				
	return 0;
}

static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{	
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
	return 0;
}

static int r2t_value(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_rip_list(char buf[CGI_BUF_LEN],char **buf1)
{

	if(CONNECTION_LOCAL_OFFICE != get_wan_type()){
		sprintf(buf,
			"<th nowrap align=\"right\" valign=\"top\" width=\"140\">_Ci~bN<br>[eBO</th> \
			<td width=\"480\"> \
			<TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"4\"> \
			<tr> \
				<td nowrap><input type=\"checkbox\" name=\"enable_rip\" value=\"rip\" ");
		if(rip_enable)
			strcat(buf,str_checked);	
			
		strcat(buf,
				"> RIP V1gp</td> \
			    <td  align=\"right\"> &nbsp; <input type=\"button\" name=\"save\" value=\"ۑ\" onClick=\"save_entry();\"></td> \
			</tr> \
			</table> \
			</td>");
	}else{
		sprintf(buf,"<th></th>");
	}
	return 0;
}

static int r2t_r_iface(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_if_list(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}
#if 0
static int t2r_save(const char *value)
{
	return 0;
}
#endif
static int t2r_rt_list(const char *value)
{
	return 0;
}

static int t2r_dest_ip_1(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>254){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		sprintf(newaddr,"%s.",value);
	}
	return 0;
}

static int t2r_dest_ip_2(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>255)
		setbit(glb_errlog,MSG2_ROUTING);
	else{
		strcat(newaddr,value);
		strcat(newaddr,".");
	}
	return 0;
}

static int t2r_dest_ip_3(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>255){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		strcat(newaddr,value);
		strcat(newaddr,".");
	}
	return 0;
}

static int t2r_dest_ip_4(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>254){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		strcat(newaddr,value);
	}
	return 0;
}

static int t2r_lan_mask_1(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>255){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		sprintf(newmask,"%s.",value);
	}
	return 0;
}

static int t2r_lan_mask_2(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>255){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		strcat(newmask,value);
		strcat(newmask,".");
	}
	return 0;
}

static int t2r_lan_mask_3(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>255){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		strcat(newmask,value);
		strcat(newmask,".");
	}
	return 0;
}

static int t2r_lan_mask_4(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>255){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		strcat(newmask,value);
	}
	return 0;
}

static int t2r_gw_ip_1(const char *value)
{
	int i = atoi(value);
	if(i<1 || i>254){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		sprintf(newgw,"%s.",value);
	}
	return 0;
}

static int t2r_gw_ip_2(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>255){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		strcat(newgw,value);
		strcat(newgw,".");
	}
	return 0;
}

static int t2r_gw_ip_3(const char *value)
{
	int i = atoi(value);
	if(i<0 || i>255){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		strcat(newgw,value);
		strcat(newgw,".");
	}
	return 0;
}

static int t2r_gw_ip_4(const char *value)
{
	int i = atoi(value);
	if(i<1 || i>254){
		setbit(glb_errlog,MSG2_ROUTING);
	}
	else{
		strcat(newgw,value);
	}
	return 0;
}

static int t2r_metric(const char *value)
{
	int i = atoi(value);
	if(i<2 || i>15){
		setbit(glb_errlog,MSG3_ROUTING);
	}
	else{
		metric=i;
	}
	return 0;
}

static int t2r_clear(const char *value)
{
	return 0;
}

static int t2r_add(const char *value)
{
	return 0;
}

static int t2r_update(const char *value)
{
	return 0;
}

static int t2r_delete(const char *value)
{
	return 0;
}

static int t2r_list_all(const char *value)
{
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_todo(const char *value)
{
	which_submit=str_db_search(str_tododb,value);
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

static int t2r_value(const char *value)
{
	rip_enable=atoi(value);
	return 0;
}

int routing_main(void)
{
	LIST *hd=NULL;
	char *val,*p;
	int ccode,n;
	char *msg;
	
	rip_enable=0;
	memset(glb_errlog,0,sizeof(glb_errlog));
	which_submit=SAVE;
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){
			switch(which_submit){
				case RT_ADD:
					if(ErrlogIsSetted()){
		    			if(isset(glb_errlog,MSG1_ROUTING)){
		        			msg=get_err_msg(MSG1_ROUTING);
		        			fmt_err_msg(msg);
		    			}
		    			if(isset(glb_errlog,MSG2_ROUTING)){
		        			msg=get_err_msg(MSG2_ROUTING);
		        			fmt_err_msg(msg);
		    			}
		    			if(isset(glb_errlog,MSG3_ROUTING)){
		        			msg=get_err_msg(MSG3_ROUTING);
		        			fmt_err_msg(msg);
		    			}
					}
					else{    		
						n=0;
						if(num>=MAX_ROUTE_NUM)
							break;	
												
						ccode=AddRtList(newaddr,newmask,newgw,metric,n);
						if(ccode){
							msg=get_err_msg(MSG5_ROUTING);
							fmt_err_msg(msg);
						}					
					}
					break;
				case RT_DEL:
					ccode=DelRtList(newaddr,newmask,newgw,metric);
					break;
				case RT_UPDATE:
					val=find_val(hd,"RT_LIST");
					p=strchr(val,')');
					*p=0;
					n=atoi(val);
					ccode=AddRtList(newaddr,newmask,newgw,metric,n);
					break;
				case SAVE:
				default:
					SaveRipEnable(rip_enable);
					break;

			}
		}
		if(!ErrlogIsSetted()){
		    WriteConfToFlash();
		}		
		list_clear(hd);
	}
	else
		ReadRipEnable(&rip_enable);
	
	ccode=html_parser("routing.htm",key_fun_tab);

	if(table)
		FreeRtList(table);

	return ccode;
}
#endif /* _ROUTING_CGI_C_ */
