#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_mon_hrs_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mon_min_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mon_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mon_min_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mon_hrs_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mon_min_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mon_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mon_min_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tue_hrs_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tue_min_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tue_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tue_min_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tue_hrs_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tue_min_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tue_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_tue_min_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wed_hrs_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wed_min_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wed_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wed_min_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wed_hrs_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wed_min_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wed_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wed_min_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_thu_hrs_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_thu_min_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_thu_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_thu_min_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_thu_hrs_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_thu_min_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_thu_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_thu_min_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fri_hrs_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fri_min_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fri_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fri_min_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fri_hrs_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fri_min_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fri_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fri_min_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sat_hrs_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sat_min_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sat_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sat_min_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sat_hrs_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sat_min_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sat_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sat_min_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sun_hrs_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sun_min_start1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sun_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sun_min_finish1(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sun_hrs_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sun_min_start2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sun_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sun_min_finish2(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_mon_hrs_start1(const char *value);
static int t2r_mon_min_start1(const char *value);
static int t2r_mon_hrs_finish1(const char *value);
static int t2r_mon_min_finish1(const char *value);
static int t2r_mon_hrs_start2(const char *value);
static int t2r_mon_min_start2(const char *value);
static int t2r_mon_hrs_finish2(const char *value);
static int t2r_mon_min_finish2(const char *value);
static int t2r_tue_hrs_start1(const char *value);
static int t2r_tue_min_start1(const char *value);
static int t2r_tue_hrs_finish1(const char *value);
static int t2r_tue_min_finish1(const char *value);
static int t2r_tue_hrs_start2(const char *value);
static int t2r_tue_min_start2(const char *value);
static int t2r_tue_hrs_finish2(const char *value);
static int t2r_tue_min_finish2(const char *value);
static int t2r_wed_hrs_start1(const char *value);
static int t2r_wed_min_start1(const char *value);
static int t2r_wed_hrs_finish1(const char *value);
static int t2r_wed_min_finish1(const char *value);
static int t2r_wed_hrs_start2(const char *value);
static int t2r_wed_min_start2(const char *value);
static int t2r_wed_hrs_finish2(const char *value);
static int t2r_wed_min_finish2(const char *value);
static int t2r_thu_hrs_start1(const char *value);
static int t2r_thu_min_start1(const char *value);
static int t2r_thu_hrs_finish1(const char *value);
static int t2r_thu_min_finish1(const char *value);
static int t2r_thu_hrs_start2(const char *value);
static int t2r_thu_min_start2(const char *value);
static int t2r_thu_hrs_finish2(const char *value);
static int t2r_thu_min_finish2(const char *value);
static int t2r_fri_hrs_start1(const char *value);
static int t2r_fri_min_start1(const char *value);
static int t2r_fri_hrs_finish1(const char *value);
static int t2r_fri_min_finish1(const char *value);
static int t2r_fri_hrs_start2(const char *value);
static int t2r_fri_min_start2(const char *value);
static int t2r_fri_hrs_finish2(const char *value);
static int t2r_fri_min_finish2(const char *value);
static int t2r_sat_hrs_start1(const char *value);
static int t2r_sat_min_start1(const char *value);
static int t2r_sat_hrs_finish1(const char *value);
static int t2r_sat_min_finish1(const char *value);
static int t2r_sat_hrs_start2(const char *value);
static int t2r_sat_min_start2(const char *value);
static int t2r_sat_hrs_finish2(const char *value);
static int t2r_sat_min_finish2(const char *value);
static int t2r_sun_hrs_start1(const char *value);
static int t2r_sun_min_start1(const char *value);
static int t2r_sun_hrs_finish1(const char *value);
static int t2r_sun_min_finish1(const char *value);
static int t2r_sun_hrs_start2(const char *value);
static int t2r_sun_min_start2(const char *value);
static int t2r_sun_hrs_finish2(const char *value);
static int t2r_sun_min_finish2(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"mon_hrs_start1",r2t_mon_hrs_start1,t2r_mon_hrs_start1},
	{"mon_min_start1",r2t_mon_min_start1,t2r_mon_min_start1},
	{"mon_hrs_finish1",r2t_mon_hrs_finish1,t2r_mon_hrs_finish1},
	{"mon_min_finish1",r2t_mon_min_finish1,t2r_mon_min_finish1},
	{"mon_hrs_start2",r2t_mon_hrs_start2,t2r_mon_hrs_start2},
	{"mon_min_start2",r2t_mon_min_start2,t2r_mon_min_start2},
	{"mon_hrs_finish2",r2t_mon_hrs_finish2,t2r_mon_hrs_finish2},
	{"mon_min_finish2",r2t_mon_min_finish2,t2r_mon_min_finish2},
	{"tue_hrs_start1",r2t_tue_hrs_start1,t2r_tue_hrs_start1},
	{"tue_min_start1",r2t_tue_min_start1,t2r_tue_min_start1},
	{"tue_hrs_finish1",r2t_tue_hrs_finish1,t2r_tue_hrs_finish1},
	{"tue_min_finish1",r2t_tue_min_finish1,t2r_tue_min_finish1},
	{"tue_hrs_start2",r2t_tue_hrs_start2,t2r_tue_hrs_start2},
	{"tue_min_start2",r2t_tue_min_start2,t2r_tue_min_start2},
	{"tue_hrs_finish2",r2t_tue_hrs_finish2,t2r_tue_hrs_finish2},
	{"tue_min_finish2",r2t_tue_min_finish2,t2r_tue_min_finish2},
	{"wed_hrs_start1",r2t_wed_hrs_start1,t2r_wed_hrs_start1},
	{"wed_min_start1",r2t_wed_min_start1,t2r_wed_min_start1},
	{"wed_hrs_finish1",r2t_wed_hrs_finish1,t2r_wed_hrs_finish1},
	{"wed_min_finish1",r2t_wed_min_finish1,t2r_wed_min_finish1},
	{"wed_hrs_start2",r2t_wed_hrs_start2,t2r_wed_hrs_start2},
	{"wed_min_start2",r2t_wed_min_start2,t2r_wed_min_start2},
	{"wed_hrs_finish2",r2t_wed_hrs_finish2,t2r_wed_hrs_finish2},
	{"wed_min_finish2",r2t_wed_min_finish2,t2r_wed_min_finish2},
	{"thu_hrs_start1",r2t_thu_hrs_start1,t2r_thu_hrs_start1},
	{"thu_min_start1",r2t_thu_min_start1,t2r_thu_min_start1},
	{"thu_hrs_finish1",r2t_thu_hrs_finish1,t2r_thu_hrs_finish1},
	{"thu_min_finish1",r2t_thu_min_finish1,t2r_thu_min_finish1},
	{"thu_hrs_start2",r2t_thu_hrs_start2,t2r_thu_hrs_start2},
	{"thu_min_start2",r2t_thu_min_start2,t2r_thu_min_start2},
	{"thu_hrs_finish2",r2t_thu_hrs_finish2,t2r_thu_hrs_finish2},
	{"thu_min_finish2",r2t_thu_min_finish2,t2r_thu_min_finish2},
	{"fri_hrs_start1",r2t_fri_hrs_start1,t2r_fri_hrs_start1},
	{"fri_min_start1",r2t_fri_min_start1,t2r_fri_min_start1},
	{"fri_hrs_finish1",r2t_fri_hrs_finish1,t2r_fri_hrs_finish1},
	{"fri_min_finish1",r2t_fri_min_finish1,t2r_fri_min_finish1},
	{"fri_hrs_start2",r2t_fri_hrs_start2,t2r_fri_hrs_start2},
	{"fri_min_start2",r2t_fri_min_start2,t2r_fri_min_start2},
	{"fri_hrs_finish2",r2t_fri_hrs_finish2,t2r_fri_hrs_finish2},
	{"fri_min_finish2",r2t_fri_min_finish2,t2r_fri_min_finish2},
	{"sat_hrs_start1",r2t_sat_hrs_start1,t2r_sat_hrs_start1},
	{"sat_min_start1",r2t_sat_min_start1,t2r_sat_min_start1},
	{"sat_hrs_finish1",r2t_sat_hrs_finish1,t2r_sat_hrs_finish1},
	{"sat_min_finish1",r2t_sat_min_finish1,t2r_sat_min_finish1},
	{"sat_hrs_start2",r2t_sat_hrs_start2,t2r_sat_hrs_start2},
	{"sat_min_start2",r2t_sat_min_start2,t2r_sat_min_start2},
	{"sat_hrs_finish2",r2t_sat_hrs_finish2,t2r_sat_hrs_finish2},
	{"sat_min_finish2",r2t_sat_min_finish2,t2r_sat_min_finish2},
	{"sun_hrs_start1",r2t_sun_hrs_start1,t2r_sun_hrs_start1},
	{"sun_min_start1",r2t_sun_min_start1,t2r_sun_min_start1},
	{"sun_hrs_finish1",r2t_sun_hrs_finish1,t2r_sun_hrs_finish1},
	{"sun_min_finish1",r2t_sun_min_finish1,t2r_sun_min_finish1},
	{"sun_hrs_start2",r2t_sun_hrs_start2,t2r_sun_hrs_start2},
	{"sun_min_start2",r2t_sun_min_start2,t2r_sun_min_start2},
	{"sun_hrs_finish2",r2t_sun_hrs_finish2,t2r_sun_hrs_finish2},
	{"sun_min_finish2",r2t_sun_min_finish2,t2r_sun_min_finish2},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "sch_def_cgi.c"

/*************************/
