#include <stdio.h>

extern int iptables(char *arg);

int sh_chain_init_main(int argc, char *argv[])
{
	char arg[100];
	
	sprintf(arg, "-F");
	iptables(arg);
	sprintf(arg, "-F -t nat");
	iptables(arg);	
	sprintf(arg, "-P INPUT DROP");
	iptables(arg);
	sprintf(arg, "-P FORWARD DROP");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j DROP");
	iptables(arg);	
	sprintf(arg, "-N group0");
	iptables(arg);	
	sprintf(arg, "-N group1");
	iptables(arg);	
	sprintf(arg, "-N group2");
	iptables(arg);	
	sprintf(arg, "-N group3");
	iptables(arg);
	sprintf(arg, "-N group4");
	iptables(arg);	
	sprintf(arg, "-N sp_app");
	iptables(arg);
	sprintf(arg, "-N vpn_pass");
	iptables(arg);	
	sprintf(arg, "-N url_filter");
	iptables(arg);	
	sprintf(arg, "-N static_forward");
	iptables(arg);	
	sprintf(arg, "-N bottom_forward");
	iptables(arg);	
	sprintf(arg, "-N vs_forward");
	iptables(arg);
	sprintf(arg, "-N dmz_forward");
	iptables(arg);
	sprintf(arg, "-N dos_forward");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j vs_forward");
	iptables(arg);
	sprintf(arg, "-A FORWARD -j dmz_forward");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j group1");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j group2");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j group3");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j group4");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j group0");
	iptables(arg);
	sprintf(arg, "-A FORWARD -j vpn_pass");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j static_forward");
	iptables(arg);
	sprintf(arg, "-A FORWARD -j url_filter");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j sp_app");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j dos_forward");
	iptables(arg);	
	sprintf(arg, "-A FORWARD -j bottom_forward");
	iptables(arg);	
	sprintf(arg, "-N icmp_echo");
	iptables(arg);
	sprintf(arg, "-N static_input");
	iptables(arg);
	sprintf(arg, "-N bottom_input");
	iptables(arg);	
	sprintf(arg, "-A INPUT -j icmp_echo");
	iptables(arg);
	sprintf(arg, "-A INPUT -j static_input");
	iptables(arg);	
	sprintf(arg, "-A INPUT -j bottom_input");
	iptables(arg);	
	sprintf(arg, "-t nat -N NAT_VS_DNAT_CHAIN");
	iptables(arg);	
	sprintf(arg, "-t nat -N REMOTE_CHAIN");
	iptables(arg);	
	sprintf(arg, "-t nat -N DMZ_CHAIN");
	iptables(arg);	
	sprintf(arg, "-t nat -A PREROUTING -j NAT_VS_DNAT_CHAIN");
	iptables(arg);				
	sprintf(arg, "-t nat -A PREROUTING -j REMOTE_CHAIN");
	iptables(arg);
	sprintf(arg, "-t nat -A PREROUTING -j DMZ_CHAIN");
	iptables(arg);	
	sprintf(arg, "-t nat -N NAT_VS_SNAT_CHAIN");
	iptables(arg);
	sprintf(arg, "-t nat -N NAT_CHAIN");
	iptables(arg);	
	sprintf(arg, "-t nat -A POSTROUTING -j NAT_VS_SNAT_CHAIN");
	iptables(arg);	
	sprintf(arg, "-t nat -A POSTROUTING -j NAT_CHAIN");
	iptables(arg);
	return 0;
}
