#include <stdio.h>
#include <arpa/inet.h>
#include "h_const.h"
#include "internet.h"  


#define CHAIN          "DMZ_CHAIN"
#define F_CHAIN        "dmz_forward"

extern int iptables(char *arg);

int sh_dmz_main(int argc, char *argv[])
{ 
	char arg[200];
	
	sprintf(arg, "-t nat -F %s", CHAIN);
	iptables(arg);
	sprintf(arg, "-F %s", F_CHAIN);
	iptables(arg);	
	if(!strcmp(argv[1],"enable")){
		sprintf(arg, "-t nat -A %s -i ! %s -j DNAT --to %s", CHAIN, LAN_ITF, argv[2]);
		iptables(arg);
                sprintf(arg, "-A %s -i ! %s -d %s -j ACCEPT", F_CHAIN, LAN_ITF, argv[2]);
		iptables(arg);
	}
	return 0;
}
