#include <stdio.h>
#include <arpa/inet.h>
#include "lan.h"
#include "system.h"
#include "wan.h"
#include <string.h>
#define CHAIN        "NAT_CHAIN"


extern int iptables(char *arg);

int sh_nat_main(int argc, char *argv[])
{
	char ip[32],mask[32];   
	char arg[200];
	LAN_CONF conf;
	struct in_addr ina;
	
	ReadLanSettings(&conf);
	ina.s_addr = conf.LanIPAddr;
	sprintf(ip, "%s", inet_ntoa(ina));
	ina.s_addr = conf.NetMaskIPAddr;
	sprintf(mask, "%s", inet_ntoa(ina));

	sprintf(arg, "-t nat -F %s", CHAIN);
	iptables(arg);
	
	if((argc>1)&&(!strcmp(argv[1],"enable"))){
		sprintf(arg, "-t nat -A %s -o ! %s -s %s/%s -j MASQUERADE", CHAIN, LAN_ITF, ip, mask);
		iptables(arg);
	}
	return 0;
}
