#include <stdio.h>
#include <string.h>
#include "h_const.h"
#include "system.h"
#include "h_var.h"

#define INSIDE_IF        LAN_ITF

extern int iptables(char *arg);

int sh_reaim_main(int argc, char *argv[])
{   
	char arg[200];
	char OUTSIDE_IF[10]="eth1";
	SYSTEM_CONF conf; 

	ReadSystemSettings(&conf); 
	if(strcmp(Connection_db[(BYTE)conf.Connection],"Single_PPPoE")){
		strcpy(OUTSIDE_IF,"ppp0");
	}

        iptables("-F REAIM_IN");
        iptables("-t nat -F REAIM_PRE");	
	sprintf(arg, "-X %s", "REAIM_IN");
	iptables(arg);	
	sprintf(arg, "-N %s", "REAIM_IN");
	iptables(arg);
	sprintf(arg, "-t nat -X %s", "REAIM_PRE");
	iptables(arg);	
	sprintf(arg, "-t nat -N %s", "REAIM_PRE");
	iptables(arg);	
	
	sprintf(arg, "-I REAIM_IN 1  -i %s -p tcp --dport 4443 -j ACCEPT", OUTSIDE_IF);
	iptables(arg);	
	sprintf(arg, "-I REAIM_IN 1  -i %s -p tcp --dport 5190 -j ACCEPT", OUTSIDE_IF);
	iptables(arg);
	sprintf(arg, "-I REAIM_IN 1  -i %s -p tcp --dport 5566 -j ACCEPT", OUTSIDE_IF);
	iptables(arg);		
	sprintf(arg, "-I REAIM_IN 1  -i %s -p tcp --dport 1864 -j ACCEPT", OUTSIDE_IF);
	iptables(arg);
	sprintf(arg, "-I REAIM_IN 1  -i %s -p tcp --dport 40000:40099 -j ACCEPT", OUTSIDE_IF);
	iptables(arg);
	
	sprintf(arg, "-I REAIM_PRE 1 -t nat  -i %s -p tcp --dport 5190 -j REDIRECT --to-port 5190", INSIDE_IF);
	iptables(arg);
	sprintf(arg, "-I REAIM_IN 1  -i %s -p tcp --dport 4443 -j ACCEPT", INSIDE_IF);
	iptables(arg);	
	sprintf(arg, "-I REAIM_IN 1  -i %s -p tcp --dport 5190 -j ACCEPT", INSIDE_IF);
	iptables(arg);
	sprintf(arg, "-I REAIM_IN 1  -i %s -p tcp --dport 5566 -j ACCEPT", INSIDE_IF);
	iptables(arg);
	sprintf(arg, "-I REAIM_PRE 1 -t nat  -i %s -p tcp --dport 1863 -j REDIRECT --to-port 1863", INSIDE_IF);
	iptables(arg);
	sprintf(arg, "-I REAIM_IN 1 -i %s -p tcp --dport 1863:1864 -j ACCEPT", INSIDE_IF);
	iptables(arg);

	sprintf(arg, "-D INPUT -j REAIM_IN");
	iptables(arg);	
	sprintf(arg, "-I INPUT 1 -j REAIM_IN");
	iptables(arg);	
	sprintf(arg, "-D PREROUTING -t nat -j REAIM_PRE");
	iptables(arg);	
	sprintf(arg, "-I PREROUTING 1 -t nat -j REAIM_PRE");
	iptables(arg);				
	return 0;
}
