#include <arpa/inet.h>
#include <string.h>
#include "h_const.h"
#include "lan.h"
#define CHAIN	       "sp_app"

int sh_spec_app_main(int argc, char *argv[])
{
	char arg[200];
	char ACTION[10],ip[32],mask[32];
	char *protocol;
	int i=1;
	LAN_CONF conf;
	struct in_addr ina;   
	
	ReadLanSettings(&conf);
	ina.s_addr = conf.LanIPAddr;
	sprintf(ip, "%s", inet_ntoa(ina));
	ina.s_addr = conf.NetMaskIPAddr;
	sprintf(mask, "%s", inet_ntoa(ina));		
	
	while(argc>1){
		if(!strcmp(argv[i],"add"))
			strcpy(ACTION, "-A");
		else if(!strcmp(argv[i],"del"))
			strcpy(ACTION, "-D");
		else{		
			return 1;
		}
        	protocol=strtok(argv[i+1]," ");
        	while(protocol){
	        	sprintf(arg, "%s %s -i %s -p %s -s %s/%s --dport %s -j QUEUE", ACTION, CHAIN, LAN_ITF, protocol, ip, mask, argv[i+2]);
			iptables(arg);				        	        	
			protocol =  strtok(NULL," ");
		}
		i=i+3;
		argc=argc-3;
	}							
	return 0;
}
