#ifndef _ST_MODEM_CGI_C_
#define _ST_MODEM_CGI_C_
#include "wan.h"
#include "system.h"
#include <net/if.h>

static char cmd[10];

int r2t_dport_ip(char buf[CGI_BUF_LEN],char **buf1){
    sprintf(buf,"%s",inet_ntoa(if_status.ip));
    if( !strcmp(buf,DOD_IP) ){
        *buf = '\0';
    }
    return 0;
}

/*
int r2t_dport_mask(char buf[CGI_BUF_LEN],char **buf1){
    sprintf(buf,"%s",inet_ntoa(if_status.mask));
    if( !strcmp(buf,DOD_IP) ){
        *buf = '\0';
    }
    return 0;
}
*/

int r2t_modem_link(char buf[CGI_BUF_LEN],char **buf1){
    if(if_status.flag&IFF_UP){
        sprintf(buf,"%s",dhcp_server_status_db[IF_UP]);
    }
    else{
        sprintf(buf,"%s",dhcp_server_status_db[IF_DOWN]);
    }

    if( !strcmp(inet_ntoa(if_status.ip), DOD_IP) ){
        sprintf(buf,"%s",dhcp_server_status_db[IF_DOWN]);
    }
    return 0;
}

int r2t_modem_log(char buf[CGI_BUF_LEN],char **buf1){
    *buf1 = malloc(5000);
    if(! *buf1){
        return 0;
    }
    GetPPPoELog(*buf1);
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
    set_err_msg(buf,buf1);
	return 0;
}

int r2t_todo(char buf[CGI_BUF_LEN],char **buf1){

	return 0;
}

int t2r_modem_log(const char *value){
	return 0;
}

int t2r_clr_log(const char *value){
    ClearPPPoELog();
    return 0;
}

int t2r_dial(const char *value){
    sprintf(cmd,"%s","start");
    return 0;
}

int t2r_hang_up(const char *value){
    sprintf(cmd,"%s","stop");
    return 0;
}

int t2r_refresh(const char *value){
	return 0;
}

int t2r_help(const char *value){
	return 0;
}

int t2r_close(const char *value){
	return 0;
}

int t2r_message(const char *value){
	return 0;
}

int t2r_todo(const char *value){
	return 0;
}

int st_modem_main(){
	LIST *hd=NULL;
	char sys_cmd[50];

	ReadModemSettings(&mdm_conf);

	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		    /* success */
		    if(mdm_conf.mdm_dialMode == DOD ){
		        int pppIsUp;
                GetIfaceStatus("ppp0",&if_status);
                if(if_status.flag&IFF_UP && strcmp(inet_ntoa(if_status.ip), DOD_IP) ){
                    pppIsUp = 1;
                }
                else{
                    pppIsUp = 0;
                }
                if( !strcmp(cmd,"stop") ){
                    if(!pppIsUp){
                        char *msg=get_err_msg(MSG5_ST_POE);
                        fmt_err_msg(msg);
                    }
                    else{
                        system("/usr/sbin/adsl-user-sig >/dev/null 2>&1");
                    }
                }
                else{
                    if(pppIsUp){
                        char *msg=get_err_msg(MSG7_ST_POE);
                        fmt_err_msg(msg);
                    }
                    else{
                        system("/usr/sbin/adsl-user-sig >/dev/null 2>&1");
                    }
                }
            }
            else{
                /* Not DOD mode. */
    		    sprintf(sys_cmd,"/sbin/modem-ppp-%s",cmd);
    		    system(sys_cmd);
    		}
		} /* if(!do_cgi_t2r(hd,key_fun_tab)) */
	} /* if(strcmp(REQUEST_METHOD,POST)==0) */
	GetIfaceStatus("ppp0",&if_status);

	return html_parser("st_modem.htm",key_fun_tab);
}

#endif /* _ST_MODEM_CGI_C_ */
