#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_connection_method(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_broadband_modem(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_internet_connection(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sec_wan_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sec_wan_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dhcp_status(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_device_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fw_version(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_refresh(const char *value);
static int t2r_conn_log(const char *value);
static int t2r_upgrade(const char *value);
static int t2r_cfg_save(const char *value);
static int t2r_sys_data(const char *value);
static int t2r_sys_diag(const char *value);
static int t2r_logs(const char *value);
static int t2r_email(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"connection_method",r2t_connection_method,NULL},
	{"broadband_modem",r2t_broadband_modem,NULL},
	{"internet_connection",r2t_internet_connection,NULL},
	{"wan_ip",r2t_wan_ip,NULL},
	{"sec_wan_name",r2t_sec_wan_name,NULL},
	{"sec_wan_ip",r2t_sec_wan_ip,NULL},
	{"refresh",NULL,t2r_refresh},
	{"conn_log",NULL,t2r_conn_log},
	{"lan_ip",r2t_lan_ip,NULL},
	{"lan_mask",r2t_lan_mask,NULL},
	{"dhcp_status",r2t_dhcp_status,NULL},
	{"device_name",r2t_device_name,NULL},
	{"fw_version",r2t_fw_version,NULL},
	{"upgrade",NULL,t2r_upgrade},
	{"cfg_save",NULL,t2r_cfg_save},
	{"sys_data",NULL,t2r_sys_data},
	{"sys_diag",NULL,t2r_sys_diag},
	{"logs",NULL,t2r_logs},
	{"email",NULL,t2r_email},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "status_cgi.c"

/*************************/
