#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_device_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_connection_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dhcp_status(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_title_year(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_title_month(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_title_day(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_title_hour(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_title_minute(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_title_second(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_todo(const char *value);
static int t2r_title_year(const char *value);
static int t2r_title_month(const char *value);
static int t2r_title_day(const char *value);
static int t2r_title_hour(const char *value);
static int t2r_title_minute(const char *value);
static int t2r_title_second(const char *value);


static keyfun_tab key_fun_tab[]={
	{"device_name",r2t_device_name,NULL},
	{"wan_ip",r2t_wan_ip,NULL},
	{"connection_type",r2t_connection_type,NULL},
	{"lan_ip",r2t_lan_ip,NULL},
	{"dhcp_status",r2t_dhcp_status,NULL},
	{"todo",r2t_todo,t2r_todo},
	{"title_year",r2t_title_year,t2r_title_year},
	{"title_month",r2t_title_month,t2r_title_month},
	{"title_day",r2t_title_day,t2r_title_day},
	{"title_hour",r2t_title_hour,t2r_title_hour},
	{"title_minute",r2t_title_minute,t2r_title_minute},
	{"title_second",r2t_title_second,t2r_title_second},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "title_cgi.c"

/*************************/
