#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_d_pass(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_upgrade_file(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_d_pass(const char *value);
static int t2r_upgrade_file(const char *value);
static int t2r_back(const char *value);
static int t2r_start(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"d_pass",r2t_d_pass,t2r_d_pass},
	{"upgrade_file",r2t_upgrade_file,t2r_upgrade_file},
	{"back",NULL,t2r_back},
	{"start",NULL,t2r_start},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "upg_fw_cgi.c"

/*************************/
