#ifndef _UPG_FW_CGI_C_
#define _UPG_FW_CGI_C_
#include "system.h"
#include "upgrade.h"
#include "unzip.h"
#include "flash.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>


#define SYS_CONF_TITLE      "[System Config]"
int r2t_d_pass(char buf[CGI_BUF_LEN],char **buf1){
    
	return 0;
}

int r2t_upgrade_file(char buf[CGI_BUF_LEN],char **buf1){
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
	set_err_msg(buf,buf1);	
	return 0;
}

int r2t_progress(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int t2r_d_pass(const char *value){
   
    if(CheckPasswd(value+VALUE_LEN_LEN,system_conf.Password)){
        /* Password not match. */
        fmt_err_msg("Password not match.\n");
        return 1;
    }    
	return 0;
}

int t2r_upgrade_file(const char *value)
{
	const unsigned long *val_len;	
	const char *write_buf[MEM_NUM];
	int i,fd;
//	int r;
//	char err[100];
	val_len=(const unsigned long *)value;
//	sprintf(err,"val_len=%ld\n",*val_len);
//	cgi_err("t2r_upgrade_file",err);
	
	
	for(i=0;i<MEM_NUM;i++)
		write_buf[i]=&value[VALUE_LEN_LEN + i*MEM_SIZE];
	
    if( !strncmp(write_buf[0],SYS_CONF_TITLE,strlen(SYS_CONF_TITLE)) ){
        /* This is config file. */
		if(fork()==0){
			cgi_fork_do();	
        flash_write_buf(value,(ssize_t)*val_len,MTD_CONFIG); 
			execl("/bin/reboot","reboot",NULL);	
			exit(0);
		}
    }
    else{
    	if(check_updata(write_buf,THTTP_UPGRADE)){
    		fmt_err_msg("error img file\n");
    		return 1;
    	}
		if((fd=fork())==0){
			cgi_fork_do();
		        unzip(write_buf, 512, *val_len, THTTP_UPGRADE);
			execl("/bin/reboot","reboot",NULL);	   
			exit(0);
		}else if(fd>0){
			html_parser("upg_pg.htm",NULL);
			exit(0);
		}


    }
	return 0;
}

static int t2r_back(const char *value){
    return 0;
}

static int t2r_start(const char *value){
    return 0;
}

static int t2r_help(const char *value){
    return 0;
}


int t2r_message(const char *value)
{
	return 0;
}

int t2r_progress(const char *value)
{
	return 0;
}

int upg_fw_main(void)
{
	LIST *hd=NULL;
	ReadSystemSettings(&system_conf);	
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		}
		list_clear(hd);
	}
	html_parser("upg_fw.htm",key_fun_tab);	
	return 0;
}

#endif /* _UPG_FW_CGI_C_ */
