#ifndef _WAN_01_CGI_C_
#define _WAN_01_CGI_C_
#include "system.h"
enum{
    WAN_TYPE_STANDARD,
    WAN_TYPE_SINGLE_POE,
    WAN_TYPE_MULTI_POE,
#ifdef _WAN_MODEM_
    WAN_TYPE_CDMA2001x,
#endif
    WAN_TYPE_LOCAL_OFFICE,
    WAN_TYPE_NONE,
    WAN_TYPE_NUM
};

int r2t_conn_type(char buf[CGI_BUF_LEN],char **buf1){
    int selectedIndex,i;
    
    switch(system_conf.Connection){
    default:
    case CONNECTION_DHCP:
        selectedIndex = WAN_TYPE_STANDARD;
        break;
    case CONNECTION_SINGLE_PPPOE:
        selectedIndex = WAN_TYPE_SINGLE_POE;
        break;
    case CONNECTION_MULTI_PPPOE:
        selectedIndex = WAN_TYPE_MULTI_POE;
        break;
#ifdef _WAN_MODEM_
    case CONNECTION_MODEM:
        selectedIndex = WAN_TYPE_CDMA2001x;
        break;
#endif
    case CONNECTION_LOCAL_OFFICE:                      //ada      
        selectedIndex = WAN_TYPE_LOCAL_OFFICE;        //ada
        break;               //ada
    }
    for(i=0;i<WAN_TYPE_NUM-1;i++){
        if(i==selectedIndex){
            strcat(buf,option_sl);
        }
        else{
            strcat(buf,option_s);
        }
        strcat(buf,wan_type_db[i]);
        strcat(buf,option_e);
    }
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
	return 0;
}

int t2r_conn_type(const char *value){
	return 0;
}

int t2r_next(const char *value){
	return 0;
}

int t2r_message(const char *value){
	return 0;
}

int wan_01_main()
{
	LIST *hd=NULL;
	
	ReadSystemSettings(&system_conf);
	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!hd)
			cgi_err("","");
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
		}
		list_clear(hd);
	}
	return html_parser("wan_01.htm",key_fun_tab);
}
#endif /* _WAN_01_CGI_C_ */
