#ifndef _WIZ_HOME_CGI_C_
#define _WIZ_HOME_CGI_C_
#include "system.h"
#include "wan.h"

int r2t_connect_status(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_access_method(char buf[CGI_BUF_LEN],char **buf1)
{
    switch(system_conf.Connection){
    case CONNECTION_DHCP:
        strcpy(buf,wiz_ac_method_db[WIZ_AC_DIRECT]);
        break;
    case CONNECTION_SINGLE_PPPOE:
    case CONNECTION_MULTI_PPPOE:
        strcpy(buf,wiz_ac_method_db[WIZ_AC_PPPOE]);
        break;
#ifdef _WAN_MODEM_
    case CONNECTION_MODEM:
        strcpy(buf,wiz_ac_method_db[WIZ_AC_MODEM]);
        break;
#endif
    }
	return 0;
}

int r2t_ipaddress_type(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,IPDNSTypeDB[(BYTE)dhcp_conf.dhcpc_type]);
    
	return 0;
}

int r2t_user_name(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,single_pppoe_conf.userName);
	return 0;
}

int r2t_user_pass(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,single_pppoe_conf.password);	
	return 0;
}

int r2t_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.ipAddress)));
	return 0;
}

int r2t_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.ipAddress)+1));
	return 0;
}

int r2t_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.ipAddress)+2));	
	return 0;
}

int r2t_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.ipAddress)+3));		
	return 0;
}

int r2t_mask_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.netMask)));		
	return 0;
}

int r2t_mask_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.netMask)+1));		
	return 0;
}

int r2t_mask_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.netMask)+2));		
	return 0;
}

int r2t_mask_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.netMask)+3));		
	return 0;
}

int r2t_gw_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.Gateway)));		
	return 0;
}

int r2t_gw_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.Gateway)+1));		
	return 0;
}

int r2t_gw_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.Gateway)+2));		
	return 0;
}

int r2t_gw_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.Gateway)+3));		
	return 0;
}

int r2t_dns1_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.dns[0])));		
	return 0;
}

int r2t_dns1_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.dns[0])+1));		
	return 0;
}

int r2t_dns1_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.dns[0])+2));		
	return 0;
}

int r2t_dns1_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&dhcp_conf.dns[0])+3));		
	return 0;
}

int r2t_date_time(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int t2r_next(const char *value){
    return 0;
}

static int t2r_cancelfinish(const char *value){
    return 0;
}

int t2r_connect_status(const char *value)
{
	return 0;
}

int t2r_access_method(const char *value)
{
	return 0;
}

int t2r_ipaddress_type(const char *value)
{
	return 0;
}

int t2r_user_name(const char *value)
{
	return 0;
}

int t2r_user_pass(const char *value)
{
	return 0;
}

int t2r_ip_1(const char *value)
{
	return 0;
}

int t2r_ip_2(const char *value)
{
	return 0;
}

int t2r_ip_3(const char *value)
{
	return 0;
}

int t2r_ip_4(const char *value)
{
	return 0;
}

int t2r_mask_1(const char *value)
{
	return 0;
}

int t2r_mask_2(const char *value)
{
	return 0;
}

int t2r_mask_3(const char *value)
{
	return 0;
}

int t2r_mask_4(const char *value)
{
	return 0;
}

int t2r_gw_1(const char *value)
{
	return 0;
}

int t2r_gw_2(const char *value)
{
	return 0;
}

int t2r_gw_3(const char *value)
{
	return 0;
}

int t2r_gw_4(const char *value)
{
	return 0;
}

int t2r_dns1_ip_1(const char *value)
{
	return 0;
}

int t2r_dns1_ip_2(const char *value)
{
	return 0;
}

int t2r_dns1_ip_3(const char *value)
{
	return 0;
}

int t2r_dns1_ip_4(const char *value)
{
	return 0;
}

int t2r_date_time(const char *value)
{
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int wiz_home_main()
{
	ReadSystemSettings(&system_conf);
	ReadDHCPSettings(&dhcp_conf);
	ReadSinglePPPoESettings(&single_pppoe_conf);
#ifdef _WAN_MODEM_
	ReadModemSettings(&mdm_conf);
#endif
	return html_parser("wiz_home.htm",key_fun_tab);
}
#endif /* _WIZ_HOME_CGI_C_ */

