#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_ctype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ctype_fixed(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ctype_pppoe(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_ctype(const char *value);
static int t2r_back(const char *value);
static int t2r_next(const char *value);
static int t2r_cancel(const char *value);


static keyfun_tab key_fun_tab[]={
	{"ctype",r2t_ctype,t2r_ctype},
	{"ctype_fixed",r2t_ctype_fixed,NULL},
	{"ctype_pppoe",r2t_ctype_pppoe,NULL},
	{"Back",NULL,t2r_back},
	{"Next",NULL,t2r_next},
	{"Cancel",NULL,t2r_cancel},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "wiz_mt_cgi.c"

/*************************/
