// 706ST V2111 2/18/2003

//public messages
var msg_blank = "%s can not be blank.\n";
var msg_space = "Blanks or spaces are not allowed in %s\n";
var msg_blank_in = "Blanks are not allowed in %s\n";
var msg_invalid = "Invalid character or characters in %s\nValid characters are: \n%s\n\n";
var msg_check_invalid = "%s contains an invalid number\n";
var msg_greater = "%s must be greater than %s \n";
var msg_less = "%s must be less than %s \n";
var msg_first = "First";  // eg. First field of GW must match device IP
var msg_second = "Second";
var msg_third = "Third";
var msg_fourth = "Fourth";
var msg_ip_address = "IP Address";
var msg_validIP = "%s is invalid. Valid range is 1.0.0.1 to 254.255.255.254\n";
var msg_netmask = "Network Mask";
var msg_validMask = "%s is invalid. Valid range is 0.0.0.0 to 255.255.255.255\n";
var msg_gatewayip = "Gateway IP Address";
var msg_DNS_ip = "DSN IP Address";
var msg_invalidMAC = "%s must be 12 Hex chars (0~9 and A~F) with optional delimiters (: or -)";
var msg_restart = "Restart ?\nAll existing connections will be terminated.\n\nClick OK to restart, Cancel to abort.";
var msg_logout = "\nLogout?\n\nClick OK to logout or Cancel to abort";


// Access Control
var msg_def_grp = 'Members cannot be assigned to or deleted from the "Default" group.\nThis group contains all PCs which have not been allocated to another group.';
var msg_selservice = "Please select a service or services for this rule.";
var msg_noschedule = "No schedule selected";

// config file
var msg_nofile = "Filename can not be blank";
var msg_confirmCfile = "Warning!\nRestoring settings from a config file will erase all the current settings.\nClick OK to continue , Cancel to abort." ;
var msg_confirmDefault = "Warning!\nLoading the Factory Default Settings will erase all the current settings.\nClick OK to continue, Cancel to abort.";

//ddns
var msg_username = "User name";
var msg_password = "Password";
var msg_user_domain = "First section of Domain name";
var msg_dyn_domain = "Middle section of Domain name";
var msg_tl_domain = "Last section of Domain name";
var msg_selsite = "Please select a DDNS Service provider";

//dev_opt
var msg_enable = "Enabling this has no effect unlesss %s are Enabled.";
var msg_bak_dns_field = "Backup DNS (%s) IP Address";
 
// diag
var msg_dns_lookup = "Domain name/URL can not be blank";

//di_users
var msg_name_used = "\nName is already in use. Please use another name.";
var msg_guest_rename = "'guest' user cannot be renamed.\nClick OK to restore original name";
var msg_no_user = "No user selected. Please select a user in the list.";
var msg_guest_delete = "'guest' user cannot be deleted.";
var msg_delete_user = "Delete user %s ?";
var msg_password_match = "Password entries do not match";
var msg_dial_in_limit = "Dial-in limit";

//dial_in
var msg_udef_modem = "User-defined";
var msg_ud_modem = '\nProperties can only be changed for the "User-defined" modem';

//fw_serv
var na_var = "n/a";
var msg_servname = "Service name";
var msg_startp = "Start port number";
var msg_finishp = "Finish port number";
var msg_icmp_type = "ICMP Type";
var msg_portbigger = "Finish port number must be greater than Start port number";
var msg_no_service = "No Service selected.  \nPlease select a Service from the list.";

//fw_rules
var msg_norule = "No Rule selected.  \nPlease select a Rule from the list.";
var msg_blank_plcy_name = "Policy Name can not be blank\n";
var msg_src_lan_start_ip = "Invalid Source start IP address, please enter again\n";
var msg_src_lan_finish_ip = "Invalid Source finish IP address, please enter again\n";
var msg_lan_ip = "Source start IP address must less than finish IP address\n";
var msg_lan_mask = "Invalid Source network mask, please enter again\n";
var msg_dest_start_ip = "Invalid Destination start IP address, please enter again\n";
var msg_dest_finish_ip = "Invalid Destination finish IP address, please enter again\n";
var msg_wan_ip = "Destination start IP address must less than finish IP address\n";
var msg_wan_mask = "Invalid Destination network mask, please enter again\n";

//i_sap
var msg_ud_in_start = "Incoming start port for user-defined [%s]";
var msg_ud_in_finish = "Incoming finish port for user-defined [%s]";
var msg_ud_out_start = "Outgoing start port for user-defined [%s]";
var msg_ud_out_finish = "Outgoing finish port for user-defined [%s]";
var msg_ud_name = "Name for user-defined [%s]";
var msg_entry_greater = "\nFor every entry, Finish Port must be greater than Start port"

//i_urlf
var msg_no_entries = "No entries selected. Please select 1 or more entries.";
var msg_filter = "Filter string";

//internet
var msg_dhcpc = "DHCP clients are added automatically. If not listed, restart the unlisted PC.\nYou can also manually add PCs using 'PC Database' on the Advanced menu.";
var msg_dmz_enable = "DMZ cannot be enabled unless a PC is selected";
var msg_mdmz_wan = "WAN IP address for Multi-DMZ";
var msg_ip_field = "Last field of IP address";



//lan
var msg_dhcp_start = "DHCP Server Start IP address";
var msg_dhcp_finish = "DHCP Server Finish IP address";
var msg_dhcp_greater = "DHCP Server finish address must be greater than start address";
var msg_client_range = "Avalidate IP range is 10 ... 253, please try again!";

// logs
var msg_sec_email = "Invalid E-mail address.\n";
var msg_smtp = "SMTP server address";
var msg_smtp_ip = "SMTP server IP address";
var msg_smtp_port = "SMTP port number";
var msg_syslog_ip = "Syslog server IP address";

// WAN Port
var msg_mac_addr = "MAC (physical) Address";
var msg_mac_default = "\nThis inserts the factory default value into the Hardware (MAC) address field.\nClick OK to continue or Cancel to retain the current value";
var msg_copy_from_pc = "\nThis copies the address of your PC into the Hardware (MAC) address field.\n- only required if your ISP has recorded the PC's hardware address.\n\nClick OK to continue or Cancel to retain the current value";


//pc_db, pc_dba

var msg_name = "Name";
var msg_delete_confirm = "\nDelete %s ? \n\nClick OK to delete or Cancel to retain.";
var msg_no_pc = "\nNo PC selected. Please select a PC.";
var msg_invalid_mac_name = "Invalid MAC Address, please try again!\n";


//print
var msg_pre_str = "L%s Pre string";
var msg_post_str = "L%s Post string";

//remotemg
var msg_port = "Port Number";

//routing
var msg_dest_rt = "Destination IP address";
var msg_net_mask = "Network Mask";
var msg_gw_addr = "Gateway Address";
var msg_metric = "Metric";
var msg_no_routing = "\nNo entry selected. Please select a Routing table entry.";
var msg_delete = "\nDelete %s? ";

// scheduling
var mon_msg = "Monday";
var tue_msg = "Tuesday";
var wed_msg = "Wednesday";
var thu_msg = "Thursday";
var fri_msg = "Friday";
var sat_msg = "Saturday";
var sun_msg = "Sunday";
var msg_time = "Invalid Time for %s. \n\nBlanks are only allowed if both Start and Finish are blank.\n24 hour clock must be used.\nHours: 0 to 24  \nMinutes: 0 to 59\n";
var msg_starttime = "Finish time must be after Start time.\nPlease check %s.";
var msg_sessions = "Session 2 Start time must be after \nSession 1 Finish time.\nPlease check %s";
var msg_overtime = "Times past 24:00 are not valid\nPlease check %s";

//st_dhcp
var msg_dhcp_ip = "This button is only operational when using a Dynamic\n(automatically assigned) IP Address.";

//techsupp
var msg_rts = "RTS Threshold";
var msg_frag = "Fragmentation"
var msg_beacon = "Beacon Interval"
var msg_firewall_high = "Firewall - High Water Mark";
var msg_firewall_low = "Firewall - Low Water Mark";
var msg_firewall_max = "Firewall - Maximum Sessions";
var msg_firewall_block = "Firewall - Block time";
var msg_mtu = "MTU";

// upgrade FW
var up_msg = "Continue?\nAll existing Internet connections will be terminated.";
var nofile_msg = "No filename provided. Please select the correct file.";
var finish_msg = "\Firmware Upgrade completed. \nRouter will now restart." + 
"\nPlease check the LEDs to see if the Router is ready before continuing.";
// copy to upg_pg.htm

// vpn
var msg_no_policy = "No Policy selected. \nPlease select a Policy from the list.";

var msg_p_name = "Policy name";
var msg_remote_endpoint = "Remote Endpoint IP address";
var msg_local_address = "Local IP address";
var msg_remote_address = "Remote IP address";
var msg_local_address_range = "Local IP address range";
var msg_remote_address_range = "Remote IP address range";
var msg_local_netmask = "Local Subnet Mask";
var msg_remote_netmask = "Remote Subnet Mask";
var msg_start_finish = "To set IP Range, Finish address must be greater than Start address";
var msg_local_id = "\nLocal Identity (name) can not be blank"
var msg_remote_id = "\nRemote Identity (name) can not be blank"
var msg_samenetwork = "\nLocal and Remote LANs can NOT use same address range.";

var msg_ike_dynimic_only = "Dynamic IP for Remote endpoint is only available with IKE.";
var msg_incoming_policy = "IKE must be set to Responder";
var msg_auth_key_out = "Authentication key (outgoing)";
var msg_auth_key_in = "Authentication key (incoming)";
var msg_md5_key_len = "For MD5, key should be 16 characters (32 HEX chars)";
var msg_sha1_key_len = "For SHA-1, key should be 20 characters (40 HEX chars)";
var msg_spi = "SPI (Security Parameter Index)";
var msg_esp_encr_key_in = "Encryption key (incoming)";
var msg_esp_encr_key_out = "Encryption key (outgoing)";
var msg_des_key_len = "For DES, key should be 8 characters (16 HEX chars)";
var msg_3des_key_len = "For 3DES, key should be 24 characters (48 HEX chars)";
var msg_spi_value = "Invalid SPI, more characters are required";
var msg_ipsec_mode = "Both AH and ESP can not be used. Please select either, but not both.";
var msg_preshare = "To use Pre-shared Key with Main Mode,\nInitiator/Responder must be set to 'Both'";
var msg_preshared_key = "Preshared key";
//var msg_preshared_key = "ID data can't be blank";
var msg_IKE_lifetime = "IKE Life time can not be value 0~179";
var msg_ipsec_lifetime = "Ipsec life time can not be value 0~299";


// vs
var msg_vs_enable = "Virtual Servers cannot be enabled unless a PC (Server) is selected.\nPlease select a PC (Server) for %s.";
// Firewall uses ONLY msg above. SOHO uses msg below.
var msg_two_entries = "This type of Server has 2 entries. The other entry - %s\nwill be set to the same PC and Enable/Disable setting.\nThis is required for proper operation.";
var msg_vs_name = "Virtual Server name";
var msg_inport_begin = "Beginning of Internal (LAN) Port range";
var msg_inport_end= "End of Internal (LAN) Port range";
var msg_export_begin = "Beginning of External (WAN) Port range";
var msg_export_end= "End of External (WAN) Port range";
var msg_inport_badrange = "Invalid Internal (LAN) Port Range. \nEnd of port range must be greater than beginning";
var msg_export_badrange = "Invalid External (WAN) Port Range. \nEnd of port range must be greater than beginning";
var msg_int_port = "Internal Port No";
var msg_ext_port = "External Port No";
var msg_invalid_int_port = "\nInvalid Internal Port No. \nThis port is already assigned to the %s Server";
var msg_invalid_ext_port = "\nInvalid External Port No. \nThis port is already assigned to the %s Server"
var msg_no_entry_update = "\nCannot update - no entry selected.";
var msg_pre_def_rename = "\nPre-defined Servers can not be renamed. \nClick OK to restore original name.";
var msg_vs_default = "\nAll Servers you have added will be deleted!\n\nThe names and port numbers for the pre-defined Servers\nwill be set to their default values.\n\nClick OK to continue or Cancel to abort";
var msg_vs_disable = "\nAll Virtual Servers will be disabled.\n\nClick OK to continue or Cancel to retain current settings.";
var msg_vs_no_item = "\nNo item selected. \nPlease select an entry in the list.";
var msg_pre_def_delete = "\nPre-defined Servers can not be deleted.\nAny Servers you have added may be deleted.";
var msg_vs_delete = "Delete?\n\nClick OK to delete \"%s\"";
var msg_saveVs = "The firewall feature in this product can setup the Virtual Server function. After you add a entry of virtual server, you need go to Firewall screen to manage the entry you just newly added. We recommend you to use the firewall feature in this product instead of Virtual Server. Do you wish to continue?"

//w_wep
var msg_hexkey = "Invalid Key. \nHex keys can only include the characters 0~9 and A~F.\nKey size is 10 chars (64bit) or 26 chars (128bit)";
var msg_asciikey = "Invalid Key. \nKey size is 5 chars (64bit) or  13 chars (128bit)";
var msg_noencypt = "Encryption is disabled"; 
var msg_wep_pass = "Please enter passphrase";
var msg_nopassph = "Passphrase is not available for 256 bit keys";
var msg_keytoobig = "Key cannot contain more than %s characters";

// Wireless Access Control
var msg_wire_list = "No Wireless station selected";
var msg_station_addr = "Station Address";
var msg_station_name = "Station name";
var msg_button_update = "Update";
var msg_button_add = " Add ";



// firewall & vpn moves
var msg_ptext = "New Position:";    
var msg_no_move = "Unable to move, specified destination is invalid.";
var msg_nomove_tosave = "No moves to save.";  



//wizard
var msg_hostname = "Hostname";
var msg_domainname = "Domain Name";
var msg_gw_match_ip = "%s field of  Gateway must match \ncorresponding field in IP Address.";
var msg_change_gw = "\n\nClick OK to change Gateway, Cancel to retain current values.";

var msg_server_ip = "Server IP Address";  // pptp, bpa
var msg_server_domainname = "Server Domain Name";
var msg_wiz_name = "User Name";  // pppoe, pptp, bpa, ras
var msg_idle_timer = "Idle time-out";  // pppoe, pptp, bpa
var msg_wan_ip = "Internet IP address";

var msg_test_select = "Option to run test was not selected.\nNo test will be performed.";
var msg_run_test = 'Preparing to run test; please wait ...';
var msg_wait = "Router is restarting and unavailable.\nPlease wait.\nRouter will be available shortly.";

var msg_dsl_auto_done = "Auto detection completed, on-screen DSL values set.";
var msg_dsl_auto_nocopy = "Wizard window is not available, unable to change DSL settings";
var msg_dsl_autofail = "Auto-detect failed. Please ask your DSL service provider for correct settings";

function addstr(input_msg)
{
	var last_msg = "";
	var str_location;
	var temp_str_1 = "";
	var temp_str_2 = "";
	var str_num = 0;
	temp_str_1 = addstr.arguments[0];
	while(1)
	{
		str_location = temp_str_1.indexOf("%s");
		if(str_location >= 0)
		{
			str_num++;
			temp_str_2 = temp_str_1.substring(0,str_location);
			last_msg += temp_str_2 + addstr.arguments[str_num];
			temp_str_1 = temp_str_1.substring(str_location+2,temp_str_1.length);
			continue;
		}
		if(str_location < 0)
		{
			last_msg += temp_str_1;
			break;
		}
	}
	return last_msg;
}


