CFLAGS += -MMD
DDEPS := $(patsubst %.o,%.d,$(OBJS))            # all ".d" files we should have 
MISSING_DDEPS := $(filter-out $(wildcard $(DDEPS)),$(DDEPS))

ifneq ($(MISSING_DDEPS),)
$(MISSING_DDEPS):
	rm -f $(patsubst %.d,%.o,$@)
endif

%.o: %.c
	@echo $@; $(CC) $(CFLAGS) -o $@ -c $<	

-include $(DDEPS)
