#ifndef __DDNS_H__
#define __DDNS_H__


#define DDNS_MaxNameLen			20
#define DDNS_MaxPassLen			15
#define DDNS_MaxUserDmLen		24
#define DDNS_MaxDynDmLen		16
#define DDNS_MaxTlDmLen			4

typedef struct ddns_conf{
	char	ddns_user[DDNS_MaxNameLen+1];
	char 	ddns_pwd[DDNS_MaxPassLen+1];
	char 	user_domain[DDNS_MaxUserDmLen+1];
	char 	dyn_domain[DDNS_MaxDynDmLen+1];
	char 	tl_domain[DDNS_MaxTlDmLen+1];
}ddns_conf;

enum{
    DDNS_USER,
    DDNS_PWD,
    DOMAIN_NAME,
    DDNS_ITEM_NUM
};

#define	DDNS_OK					0			//Succeed
#define	DDNS_ReadConfErr		-1			//Fail to read DDNS settings.
#define	DDNS_SaveConfErr		-2			//Fail to save DDNS settings.

int ReadDDNSConf(ddns_conf *conf, int poe_acc_index);
int SaveDDNSConf(ddns_conf *conf, int poe_acc_index);

#endif
