#ifndef _INTERNET_H_
#define _INTERNET_H_

#include "fw.h"
#include <netinet/in.h>
/**********
[INTERNET]

1=application_name1:PC_name1
2=application_name2
3=...

6=...
DMZ=PC_DMZ

**********/

#define	APP_NAME_LEN	50
#define	APP_NUM		    5

#define	INTERNET_SEC	"INTERNET"


#ifdef _SH2C_
#define CMD_DMZ_SH     "/htdocs/sh_dmz"
#else
#define CMD_DMZ_SH     "/etc/rc.d/dmz.sh"
#endif

typedef struct internet_conf{
	char		    app_name[APP_NUM][APP_NAME_LEN];
	char		    pc_name[APP_NUM][CommonNameLen];
	struct in_addr	pc_dmz;
}internet_conf;

int ReadInternet(internet_conf *p, int poe_acc_index);

int SaveInternet(internet_conf *p, int poe_acc_index);

int dmz_modify(internet_conf *internet);
#endif
