#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if.h>
#include "PRO_file.h"
#include "PRO_GetStr.h"
#include "PRO_SetStr.h"
#include "PRO_GetInt.h"
#include "PRO_SetInt.h"
#include "PRO_SetMultiItemStr.h"
#include "remotemg.h"


#include "wan.h"             //ada

#define SYSCONF "/var/system.conf"

int ReadRemoteConf(remotemg *conf,int poe_acc_index)
{
	FILE *fp;
	char key[20];
	char no[3];
	
	fp=fopen(SYSCONF,"r");
	if(!fp)
		return -1;
	//ada
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(key,"%sRemotemg_MG",no);
	PRO_GetInt(Remotemg_Section,key,&(conf->remote_mg),fp);	

	sprintf(key,"%sRemotemg_PORT",no);
	PRO_GetInt(Remotemg_Section,key,&(conf->remote_port),fp);
	//********************************************
//	PRO_GetInt(Remotemg_Section,Remotemg_MG,&(conf->remote_mg),fp);
//	PRO_GetInt(Remotemg_Section,Remotemg_PORT,&(conf->remote_port),fp);
	
	fclose(fp);
	return 0;
}

int CheckRemoteConf(remotemg *conf)
{
	if ((conf->remote_mg !=0) && (conf->remote_mg !=1))
		return INVALID_REMOTE_MG;
	
	if((conf->remote_port<1) || (conf->remote_port>65534))
		return INVALID_REMOTE_PORT;
	
	return 0;
}

int SaveRemoteConf(remotemg *conf,int poe_acc_index)
{
	multi_items	all_items[2];
	char mg[2],port[6];
	int ret;
	char no[3];   //ada
	
	ret=CheckRemoteConf(conf);
	if(ret)
		return ret;
	
	
        //ada
        if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(all_items[0].key,"%sRemotemg_MG",no);
	sprintf(mg,"%d",conf->remote_mg);
	all_items[0].value=mg;
	
	sprintf(all_items[1].key,"%sRemotemg_PORT",no);
	sprintf(port,"%d",conf->remote_port);
	all_items[1].value=port;
	
	ret=PRO_SetMultiItemStr(Remotemg_Section,all_items,2,SYSCONF);
	if(ret)
		return ret;

	WriteScript();
//	StartFW();
    remotemg_modify(conf);
	return 0;
}

int remotemg_modify(remotemg *conf){
    char cmd[128];
    
    sprintf(cmd,"%s %s %d 2>/dev/null", CMD_REMOTE_SH, conf->remote_mg ? "enable" : "disable", conf->remote_port);
    
    debug(cmd);
    
    return system(cmd);
}
