#ifndef _SECURITY_H_
#define _SECURITY_H_

#include "fw.h"

/*********
[SECURITY]
DOS=0/1/2/3
URL=1
ICMP=1
IPSEC=0
PPTP=1
L2TP=0
....
*********/

#define		SECU_SEC	"SECURITY"

#define		DOS		    "DOS"
#define		URL		    "URL"
#define		ICMP		"ICMP"
#define		IPSEC		"IPSEC"
#define		PPTP		"PPTP"
#define		L2TP		"L2TP"

#define		ENABLE		1
#define		DISABLE		0

#define		DOS_HIGH		1
#define		DOS_MEDIUM		2
#define		DOS_LOW			3

#ifdef _SH2C_
#define     CMD_SECURITY_SH     "/htdocs/sh_security"
#define     CMD_DOS_SH          "/htdocs/sh_dos"
#else
#define     CMD_SECURITY_SH     "/etc/rc.d/security.sh"
#define     CMD_DOS_SH          "/etc/rc.d/dos.sh"
#endif

typedef struct secu_conf{
	int	dos;
	int	url;
	int	icmp;
	int	ipsec;
	int	pptp;
	int	l2tp;
}secu_conf;


int ReadSecu(secu_conf *p,int poe_acc_index);

int SaveSecu(secu_conf *p,int poe_acc_index);

int secu_modify(int init, secu_conf *prev_secu, secu_conf *curr_secu);

#endif
