#include <string.h>
#include <stdlib.h>
#include "PRO_GetMsgByIndex.h"
#include "PRO_GetStr.h"

int PRO_GetMsgByIndex(char *sect, int start, int num, Char128 *msg, char *fn)
{
   FILE *fp;
   char buf[MAX_LEN];
   char k[MAX_KEY_LEN];
   char *p,*p0;
   int  no;

   if (fn)
      fp = fopen(fn,"r");
   else
      fp = fopen(MS_MSG_F,"r");
   if (fp == NULL)
      return -1;

   sprintf(k,"%d",start);
   if (PRO_GetStr(sect,k,(char*)msg,128,fp)!=OK)
      return -1;

   no = 1;
   while(fgets(buf,sizeof(buf),fp) && no < num)
   {
      if (buf[0]=='\n' || buf[0]=='\r' || buf[0]=='[')
         break;
      p=strchr(buf,'=');
      if (!p)
         continue;
      p0=buf+strlen(buf)-1;
      while(*p0==0x0d || *p0==0x0a)
         p0--;
      *(p0+1)=0;
      p++;  // to next char of '='
      if (p0-p < 128)
         strcpy(msg[no],p);
      else {
         strncpy(msg[no],p,127);
         msg[no][127] = 0;
      }
      no++;
   } // while

   fclose(fp);
   return no;
}
