#include <string.h>
#include <stdlib.h>
#include "PRO_GetStr.h"

int PRO_GetStr(char *sect, char *key, char *val, int size, FILE* fp)
{
   int  i,bl;
   char *buf,*p,*p0;
   char b[MAX_LEN]; /* a line read from ini file */

   if (val==NULL || fp==NULL || key==NULL)
      return -1;

   if (sect) {
      if (PRO_2sect(sect,fp) != OK) // section not found
         return -1;
   } else
      rewind(fp);

   if (size > MAX_LEN) {
      bl = size+MAX_KEY_LEN;
      buf = malloc(bl);
      if (!buf)
         return -1;
   } else {
      bl = sizeof(b);
      buf = b;   
   }

   i = strlen(key);
   while(fgets(buf,bl,fp))
   {
      if (buf[0]=='[')
         break; // end of section
      p=buf;
      while(*p==' ')
         p++;
      if (strncmp(p,key,i)==0)
      {
         p0=p+i;
         while (*p0==' ')
            p0++;
         if (*p0 != '=')
            continue;
         p0++;
         while (*p0==' ')
            p0++;
         p=buf+strlen(buf)-1;
         while(*p==0x0d || *p==0x0a)
            p--;
         *(p+1)=0;
         if (strlen(p0) > size)
            *(p0+size-1)=0;
         strcpy(val,p0);
         return OK;
      } //if (strncmp()
   } //while (fgets())
   return -1;
}
