#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "h_var.h"
#include "h_bmsg.h"

char glb_errlog[50]={0};
char option_s[] = "<option>";
char option_e[] = "</option>";
char option_sl[] = "<option selected>";
char str_brk[]="<br>";
char str_checked[] = " checked ";
char str_enable[] = "Enable";
char str_disable[] = "Disable";
char str_html_space[]= "&nbsp";
char str_null[]="";
char str_enabled[] = "enabled";

char *conn_type_db[]={"펞ڑ","gK[ڑ","蓮ڑ",0};
char *poe_type_db[]={"private IP","Unnumbered IP","Unnumbered IP + Private",0};
char *dhcp_cl_db[]={"Enable","Disable",0};
char *dns_type_db[]={"auto","fixed",0};
#ifdef _WAN_MODEM_
char *Connection_db[]={"Direct","PPPoE","Multi_PPPoE","Modem","Local_Office",0};//ada
char *wan_type_db[]={"DHCP/ŒIP","PPPoE/Unnumbered IP","}`PPPoE","_CAbv","LOCAL OFFICE",0};
#else 
char *wan_type_db[]={"DHCP/ŒIP","PPPoE/Unnumbered IP","}`PPPoE","LOCAL OFFICE",0};
char *Connection_db[]={"Direct","PPPoE","Multi_PPPoE","Local_Office",0};
#endif
char *Connection_sys_rpt_db[]={"Direct","PPPoE","Multi_PPPoE","_CAAbv",0};
char *IPDNSTypeDB[]={"Dynamic","Fixed","Unnumbered","Unnumbered plus Private",0};
char *if_status_db[]={"Connected","Disconnected",0};
char *Connection_status_db[]={"ڑ","ڑ",0};
char *dhcp_server_status_db[]={"ON","OFF",0};
char *modem_speed_db[]={"9600","19200","38400","57600","115200","144000",0};
char *wiz_ac_method_db[]={"Direct","PPPoE","Modem",0};
char *pc_group_db[]={"O[v0","O[v1","O[v2","O[v3","O[v4",0};

#if 0
char *pc_iface_db[]={"LAN","WLAN",0};
char *pc_access_db[]={"LAN","WAN","WLAN",0};
char *pc_reserved_db[]={"dynamic","",0};
char *pc_iface_db[]={"LAN","WLAN",0};
#endif /* #if 0 */

char *session_db[] = {"wȂ","ZbVP","ZbVQ",0};
char str_poe_ac_list_head[] = "<tr><th nowrap align=\"right\" valign=\"top\" width=\"140\"></th><td><TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"4\" width=\"100%\"><tr><b> PPPoEݒ: </b><select name=\"poe_ac_list\" size=\"1\" onChange=\"changeAccount()\"> ";
char str_poe_ac_list_head_opt[] = "<tr><td><TABLE border=\"0\" cellspacing=\"0\" cellpadding=\"4\" width=\"100%\"><tr><b> PPPoEݒ: </b><select name=\"poe_ac_list\" size=\"1\" onChange=\"changeAccount()\"> ";
char str_poe_ac_list_tail[] = "</select><small>ȉ̍ڂ̓AJEgƂɐݒ肵܂</small></tr></table></td></tr>";
char str_poe_ac_list_tail_opt[] = "</select><tr><small>ȉ̍ڂ̓AJEgƂɐݒ肵܂</small></tr></tr></table></td></tr>";
char *poe_ac_type_db[]={"ac1","ac2","ac3","ac4","ac5",0};

int str_db_search(char **db, const char *str){   
    int i;

    for(i=0;db[i];i++){
        if(strcasecmp(db[i],str)==0){
            break;
        }
    }
    if(db[i]==0){
        i=-1;
    }    
    return i;
}

int char2hex(const char *str, int len, int *value)
{
	char ch;
	int i;
	int result=0;
	
	*value = 0;
	for(i=0;(i<len)&&(str[i]);i++) {
        if(result<0) {
            return -1; /* overflow! */
        }        
		if(str[i]==' ') continue;
		result *= 16;
		ch = str[i];
		if((ch<='9') && (ch>='0')) result += (int)ch - '0';
		else if((ch<='F') && (ch>='A')) result += (int)ch - 'A' + 10;
		else if((ch<='f') && (ch>='a')) result += (int)ch - 'a' + 10;
		else return -1;
	}
	*value = result;
	
	return 0;
}

CHAR *print_mac(BYTE *mac,CHAR sep)
{
    static char str_mac[18];
    int i;
    
    for(*str_mac='\0',i=0;i<6;i++){
        sprintf(str_mac+strlen(str_mac),"%02x%c",mac[i],sep);
    }
    str_mac[17]='\0';
    return str_mac;
}

char  *str_pctype_db(short type)
{
	static char  str[10]={0};
	switch(type){
        case 0:
           	strcpy(str,"LAN");
           	break;
        case 1:
           	strcpy(str,"WLAN");
           	break;
        case 2:
          	strcpy(str,"WAN");
           	break;
#ifdef _SERIAL_
        case 3:
            strcpy(str,"RS232");
            break;
#endif
        case 10:
        	strcpy(str, "Unknown");
        	break;
        default:
          	sprintf(str,"%d",type);
           	break;
        }
    return str;
}
char *str_pcreserve_db(short reserve)
{
	static char str[20]={0};
	switch (reserve)
	{
	    case 0:
	    case 3:
	        strcpy(str, get_err_msg(MSG9_PC_DB));
	    break;
	    case 1:
	        strcpy(str, get_err_msg(MSG10_PC_DB));
	    break;
	    case 2:
	        strcpy(str, get_err_msg(MSG8_PC_DB));
	    break;

	}
	return str;
}

char hex2char(unsigned char hex)
{
	char ch;
	hex = hex & 0x0f;
	if(hex <= 9) ch = (char)('0' + hex);
	else ch = (char) ('a' + hex - 10);

	return ch;
}


/* print MAC Address				(Raining 2000/09)
 * Input : 	char * buf  	--> allocated buffer to write
 *			unsigned char * haddr  	--> six bytes MAC address pointer
 *			char separator	--> separator between two bytes, NULL is no separator
 */
void printf_haddr(char * buf, unsigned char * haddr, char separator)
{
    unsigned short i,j;

    for(i=j=0;i<6;i++) {
        buf[j++] = hex2char(((unsigned char)haddr[i] >> 4));
        buf[j++] = hex2char((unsigned char)haddr[i]);
    	if(separator) buf[j++] = separator;
    }
    if(separator) buf[j-1] = 0;
    else buf[j] = 0;
}
/* mac str format should be XX:XX:XX:XX:XX:XX or XX-XX-XX-XX-XX-XX */

static char hex(char aa)
{
      if((aa <= '9') && (aa >= '0'))
         return (char)(aa-'0');
      if((aa <= 'F') && (aa >= 'A'))
         return (char)((aa-'A')+10);
      if((aa <= 'f') && (aa >= 'a'))
         return (char)((aa-'a')+10);
      return 0;
}

short check_mac(const char *str)
{
    short len;
    for(len=0;str[len];len++)
        {
                if(str[len]>'9' || str[len]<'0')
                   if(str[len]>'F' || str[len]<'A')
                      if(str[len]>'f' || str[len]<'a')
                        if(str[len]!='-' && str[len]!=':')
                          return 0;
        }
     return 1;

}

//ada
short check_hex(const char *str)
{
    short len;
    for(len=0;str[len];len++)
        {
                if(str[len]>'9' || str[len]<'0')
                   if(str[len]>'F' || str[len]<'A')
                      if(str[len]>'f' || str[len]<'a')
                          return 0;
        }
     return 1;

}//ada

char get_hex(char *str)  /* just one byte */
{
     short len;
     if ((len = strlen(str)) == 2)
        return ((hex(str[0]) << 4) + hex(str[1]));
     if (len == 1)
        return (hex(str[0]));
     return 0;
}

void extract_mac(const char *str, unsigned char mac[6])
{
    short i;

    memset(mac, 0, 6);

    if (!check_mac(str))
    {
       	return;
    }

    for(i=0;i<6;i++)
    {
    	char temp[3];
    	strncpy(temp,&str[i*3],2);
    	temp[2]=0;
    	mac[i] = get_hex(temp);
    }
}

void extract_ip(char *ip, unsigned char dst[4])
{
	char *p=NULL,*p1=NULL;

	if (!ip||*ip == '\n'||*ip == 0)
		goto err;
	dst[0] = 0;
	dst[1] = 0;
	dst[2] = 0;
	dst[3] = 0;
	p1=strdup(ip);
	if(!p1)
		return;
	p=strrchr(p1,'.');
	if(!p||p==p1)   
		goto err;
	*p=0;
	if(p==p1+strlen(p1)-1)
		dst[3]=0;
	else
		dst[3]=atoi(p+1);
	p=strrchr(p1,'.');
	if(!p||p==p1)   
		goto err;
	*p=0;
	dst[2]=atoi(p+1);
	p=strrchr(p1,'.');
	if(!p||p==p1)   
		goto err;
	*p=0;
	dst[1]=atoi(p+1);
	dst[0]=atoi(p1);	
	free(p1);
	return;	
err:
	dst[0] = 0;
	dst[1] = 0;
	dst[2] = 0;
	dst[3] = 0;
	free(p1);
	return;   
}

int ErrlogIsSetted(void)
{
    int i;
    
    for(i=0;i<sizeof(glb_errlog);i++){
        if(glb_errlog[i]){
            return 1;
        }
    }
    return 0;
}


#if 0
/*
 * convert str format iface to numeric format iface.
 */
extract_iface(char *str_iface, int *int_iface){
    if(!str_iface || !int_iface){
        return -1;
    }
    
    
    
#endif /* #if 0 */
