#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if.h>
#include "PRO_file.h"
#include "PRO_GetStr.h"
#include "PRO_SetStr.h"
#include "PRO_GetInt.h"
#include "PRO_SetInt.h"
#include "PRO_SetMultiItemStr.h"
#include "remotemg.h"
#include "wan.h"             //ada

#define SYSCONF "/var/system.conf"

int ReadRemoteConf(remotemg *conf,int poe_acc_index)
{
	FILE *fp;
	char key[20];  //ada
	char no[3];  //ada
	
cgi_err("dsf","dfssdfs");	
	fp=fopen(SYSCONF,"r");
	if(!fp)
		return -1;

	//ada
	if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(key,"%sRemotemg_MG",no);
	PRO_GetInt(Section,key,&(conf->remote_mg),fp);	

	sprintf(key,"%sRemotemg_PORT",no);
	PRO_GetInt(Section,key,&(conf->remote_port),fp);
	//ada	
	
//	PRO_GetInt(Section,MG,&(conf->remote_mg),fp);
//	PRO_GetInt(Section,PORT,&(conf->remote_port),fp);

	fclose(fp);

	return 0;
}

int CheckRemoteConf(remotemg *conf)
{
	if ((conf->remote_mg !=0) && (conf->remote_mg !=1))
		return INVALID_REMOTE_MG;
	
	if((conf->remote_port<1) || (conf->remote_port>65534))
		return INVALID_REMOTE_PORT;
	
	return 0;
}

int SaveRemoteConf(remotemg *conf,int poe_acc_index)
{
	multi_items	all_items[2];
	char mg[2],port[6],ip[16],buf[128];
	int ret;
	remotemg info;
	char no[3];  //ada
	
	ret=CheckRemoteConf(conf);
	if(ret)
		return ret;
	memset(&info,0,sizeof(remotemg));
	ret=ReadRemoteConf(&info,poe_acc_index);
	if(ret)
		return ret;
	
        //ada
        if(poe_acc_index>=0&&poe_acc_index<MAX_PPPOE_ACCOUNT)
		sprintf(no,"%d",poe_acc_index+1);
	else
		no[0]='\0';	
	sprintf(all_items[0].key,"%sRemotemg_MG",no);
	sprintf(mg,"%d",conf->remote_mg);
	all_items[0].value=mg;
	
	sprintf(all_items[1].key,"%sRemotemg_PORT",no);
	sprintf(port,"%d",conf->remote_port);
	all_items[1].value=port;
	//ada	
	
/*	strcpy(all_items[0].key,MG);
	sprintf(mg,"%d",conf->remote_mg);
	all_items[0].value=mg;
	
	strcpy(all_items[1].key,PORT);
	sprintf(port,"%d",conf->remote_port);
	all_items[1].value=port; */
	
	ret=PRO_SetMultiItemStr(Section,all_items,2,SYSCONF);
	if(ret)
		return ret;
	
	ret=GetIp(ip,"eth0");
	if(info.remote_mg==0 && conf->remote_mg==1){
		sprintf(buf,"/sbin/iptables -t nat -A PREROUTING -p tcp --dport %d -j DNAT --to %s:%d &> /dev/null",conf->remote_port,ip,80);
		system(buf);
	}
		
	else if(info.remote_mg==1 && conf->remote_mg==0){
		sprintf(buf,"/sbin/iptables -t nat -D PREROUTING -p tcp --dport %d -j DNAT --to %s:%d &> /dev/null",info.remote_port,ip,80);
		system(buf);
	}
	else if((info.remote_mg==1) && (conf->remote_mg==1) && (info.remote_port!=conf->remote_port)){
		sprintf(buf,"/sbin/iptables -t nat -D PREROUTING -p tcp --dport %d -j DNAT --to %s:%d &> /dev/null",info.remote_port,ip,80);
		system(buf); 
		sprintf(buf,"/sbin/iptables -t nat -A PREROUTING -p tcp --dport %d -j DNAT --to %s:%d &> /dev/null",conf->remote_port,ip,80);
		system(buf);
	}	
	
	return 0;
}

int GetIp(char ip[16],char name[6])
{
	struct sockaddr_in *s_sin;
	int sockd;
	struct ifreq ifr;
	
    if ((sockd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		return -1;
	}
	strcpy(ifr.ifr_name, name); 
	if (ioctl(sockd, SIOCGIFADDR, &ifr) < 0) { 
		return -1;
	}
	s_sin = (struct sockaddr_in *)&(ifr.ifr_addr);	
	strcpy(ip, inet_ntoa(s_sin->sin_addr));
	
	return 0;
}
