#ifndef SCHLING_H
#define SCHLING_H

#define SCHL_EMAIL		0	// Send email

#define SCHL_MON		1
#define SCHL_TUE		2
#define SCHL_WED		3
#define SCHL_THU		4
#define SCHL_FRI		5
#define SCHL_SAT		6
#define SCHL_SUN		7
#define SCHL_WEEKDAYS	8
#define SCHL_EACHDAY		9

//schedul type
#define SCHL_TYP_WEEKLY		0
#define SCHL_TYP_MONTHLY		1
 
typedef struct Schl_Act {
	int task;	// schedule task type
	char *tsk_para;	// task command parameter, if no then null.  	
	int hour;	// the hours of the schedule time,   01~24
	int min;		// the minutes of schedule time,     00~59
	int date;		// the week date/month date of the task schedule
} Schl_Act;


int Schl_Add(Schl_Act * p, int schltype);
int Schl_Del(int type);

int Schl_Start (void);
int Schl_Stop  (void );
int Schl_Restart(void);
			
#define SCHL_OK 						0
#define SCHL_ERR_INPUT				-1
#define SCHL_ERR_DUPLCATE_TASK 	-2
#define SCHL_ERR_READ_FILE			-3
#endif
