#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <iptables.h>

int first=1;
int do_iptables(int argc, char *argv[])
{
	int ret;
	char *table = "filter";
	iptc_handle_t handle = NULL;

	program_name = "iptables";
	program_version = NETFILTER_VERSION;

#ifdef NO_SHARED_LIBS
	if(first){
		init_extensions();
		first=0;
	}
#endif
	ret = do_command(argc, argv, &table, &handle);
	if (ret)
		ret = iptc_commit(&handle);

	if (!ret)
		fprintf(stderr, "iptables: %s\n",
			iptc_strerror(errno));	
}

int iptables(char *arg)
{
	int argc=0;
	char *arg_new=NULL,*argv[50];
	char *p;
	int find=0,isstr=0,i,len,ret;

	if(!arg||!*arg)
		return 1;
	len=strlen(arg);
//	printf("iptables %s\n", arg);
	arg_new=strdup(arg);
	if(arg_new==NULL)
		return 2;
	argv[argc++]="iptables";
	for(i=0,p=arg_new; i<len; i++,p++){
		if(*p=='"')
			isstr=!isstr;
		if(*p==' '&&!isstr){
			find=0;	
			*p='\0';	
		}else{
			if(!find){
				argv[argc++]=p;
			}
			find=1;	
		}
	}
//	for(i=0; i<argc; i++)
//		printf("argv[%d]=%s\n", i, argv[i]);
	ret=do_iptables(argc, argv);
	if(arg_new)
		free(arg_new);
	return (!ret);
}

