#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include "atm_monitor.h"
#define SHOWTIME	1
#define INIT		2
#define TRAINING	3

int read_status(void)
{
	int fd;
	char tmp[128];
	fd=open(ATM_STATUS,O_RDONLY);
	if(fd<0)
		return -1;
	
	read(fd,tmp,128);
	close(fd);
	switch(tmp[0]){
		case 'S':
			return SHOWTIME;
		case 'I':
			if(tmp[1]=='D')
				return INIT;
			else
				return TRAINING;
		default:
			return -1;
	}
	return -1;		
}



int main(int argc,char **argv)
{
	int i=0;
	if(fork()!=0) exit(0); 
	while(i<argc){
		if(strstr(argv[i],"atm_monitor")) break;
		i++;
	}
	
	while(read_status()!=SHOWTIME)
		sleep(1);
	
	if(strncmp(argv[i+1],"init",4)==0)
		/* no demond */
		system("/usr/sbin/rc wan start");	
	else
		/* on demond */
		system("/usr/sbin/rc wan restart");	
	return 0;
}
