#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "nvram.h"
#include "rc.h"

#define _DO_BRIDGE_
#define GET_LAN_MAC
#if 0
#include <stdarg.h>
void mBUG(char *format,...){
 va_list args;
    FILE *fp;

    fp = fopen("/var/cgitest","a+");
    if(!fp){
        return;
    }
    va_start(args,format);
    vfprintf(fp,format,args);
    va_end(args);
    fprintf(fp,"\n");
    fflush(fp);
    fclose(fp);
    system("/bin/chmod 777 /var/cgitest");

}
#else
#define mBUG(format,...) 
#endif

int start_lan()
{	
	char *account=nvram_get("wan_account");
	char *domain=nvram_get("wan_domain");
//printf("start_lan ip<%s>\n",nvram_safe_get("lan_ipaddr"));
	sleep(1);
#ifndef _DO_BRIDGE_
	SYSTEM("/sbin/ifconfig %s %s netmask %s broadcast %s"
	       ,nvram_safe_get("lan_if")
		,nvram_safe_get("lan_ipaddr")
		,nvram_safe_get("lan_netmask")
		,nvram_safe_get("lan_bipaddr"));
#else
	SYSTEM("/sbin/ifconfig %s 0.0.0.0",nvram_safe_get("lan_if"));
	SYSTEM("/sbin/ifconfig %s promisc",nvram_safe_get("lan_if"));

	//SYSTEM("ifconfig br0");
#ifdef GET_LAN_MAC
        {    //   static unsigned char mac[6];
	     //   GetMACAdd(nvram_safe_get("lan_if"), mac);
	//	printf ("hw ether %02X:%02X:%02X:%02X:%02X:%02X\n",
	//		mac [0], mac[1], mac[2], mac[3],mac[4], mac[5]);
			
	//	SYSTEM("/sbin/ifconfig wlan0 down");			
	//	SYSTEM("/sbin/ifconfig wlan0 hw ether %02X%02X%02X%02X%02X%02X"
	//	       ,mac[0], mac[1], mac[2], mac[3],mac[4], mac[5]);
	//	SYSTEM("/sbin/ifconfig wlan0 up");
			       
		SYSTEM("/sbin/brctl addbr br0 >/dev/null 2>&1");
		
		SYSTEM("/sbin/brctl addif br0 %s >/dev/null 2>&1",nvram_safe_get("lan_if"));		
		SYSTEM("/sbin/brctl addif br0 wlan0 >>/dev/null 2>&1");//wlan0 should be started already	

	}	
#endif	
	       
	SYSTEM("/sbin/ifconfig br0 %s netmask %s broadcast %s >/dev/null 2>&1"
		,nvram_safe_get("lan_ipaddr")
		,nvram_safe_get("lan_netmask")
		,nvram_safe_get("lan_bipaddr")
		);
#endif		
        SYSTEM("/sbin/rc firewall restart >/dev/null 2>&1");
	if(account)
		sethostname(account,strlen(account));
	if(domain)
		setdomainname(domain,strlen(domain));
	return 0;	
}

int init_lan()
{
#ifdef GET_LAN_MAC
		static unsigned char mac[6];
                GetMACAdd(nvram_safe_get("lan_if"), mac);
		mBUG ("hw ether %02X:%02X:%02X:%02X:%02X:%02X\n",
			mac [0], mac[1], mac[2], mac[3],mac[4], mac[5]);						
		//SYSTEM("/sbin/ifconfig wlan0 down");			
		//SYSTEM("/sbin/ifconfig wlan0 hw ether %02X:%02X:%02X:%02X:%02X:%02X"
		 //      ,mac[0], mac[1], mac[2], mac[3],mac[4], mac[5]);
		//SYSTEM("/sbin/ifconfig wlan0 up");
#endif
		//SYSTEM("cd /var");
		//SYSTEM("ln -s /var/airgo/var/* .");
		//sleep(1);
		//SYSTEM("mount -t tmpfs none /dev/shm");
		//sleep(1);
		//SYSTEM("insmod /var/airgo/modules/ccd");
		//SYSTEM("insmod /var/airgo/modules/wns_mod");
		mBUG("insmod /var/airgo/modules/pol_nosdram.o pum_no_eth=1 plm_mac_address=%02X:%02X:%02X:%02X:%02X:%02X"
			,mac[0], mac[1], mac[2], mac[3],mac[4], mac[5]);
		SYSTEM("insmod /var/airgo/modules/pol_nosdram.o pum_no_eth=1 plm_mac_address=%02X:%02X:%02X:%02X:%02X:%02X"
			,mac [0], mac[1], mac[2], mac[3],mac[4], mac[5]);
		sleep(2);
		SYSTEM("/var/airgo/usr/sbin/ani8021x_aa");
		SYSTEM("/var/airgo/usr/sbin/wsm;cd /");


}


