#ifndef _RIP_
#define _RIP_

#define RIPD_CONF "/etc/ripd.conf"
#define ZEBRA_CONF "/etc/zebra.conf"


/* 
 * create rip & zebra daemon configuration data
 * @param	cfg    -return configuration data
 * return	0 success 1 error
 */
int create_rip_daemon_cfg(void);

/*
 * start rip daemon 
 * @return	0 success 1 error
 */
int start_rip_daemon(void);

/*
 * stop rip daemon 
 * @return	0 success 1 error
 */
int stop_rip_daemon(void);

#endif
