#ifndef _DHCP_
#define _DHCP_

/*
 * start dhcp server
 * @return	0 success 1 error
 */
int start_dhcp_server(void);

/*
 * stop dhcp server
 * @return	0 success 1 error
 */
int stop_dhcp_server(void);

/* 
 * create dhcp server configuration data
 * @param	cfg    -return configuration data
 * return	0 success
 */
int create_dhcp_server_cfg();

#endif
