#ifndef _UPNP_
#define _UPNP_

/* Necessary nvram values are 
 * 1. upnp_enable= 0/1
 * 2. upnp_adv_time=10 (count in minutes)
 * 3. upnp_ttl=4       (how many hops)
 */

/*
 * start upnp daemon function
 * @return	0 success otherwise error
 */
int start_upnp(void);

/*
 * stop upnp daemon function
 * @return	0 success otherwise error
 */
int stop_upnp(void);

#endif
