
#include "whalNVRAM.h"
#define IFCONFIG	"/sbin/ifconfig"
#define KILLALL		"/bin/killall"
#define INSMOD		"/sbin/insmod"
#define RMMOD		"/sbin/rmmod"
#define WIFI_SSID       "/var/tmp/wifi.ssid"
#define WIFI_BIN 	"/var/tmp/wifi.bin"
#define JOEL_SOCKET_IN "/var/tmp/joel_cmd.in"
#define JOEL_SOCKET_OUT "/var/tmp/joel_cmd.out"
#define JOEL_CMD_GET_STALIST	1
#define WIFI_AUTH_OPEN	1
#define WIFI_AUTH_SKEY	2
#define WIFI_AUTH_AUTO	3
#define MAX_ACL 22
#define ACL_BIN "/var/tmp/acl.bin"
#define TIWLAN_KRENEL_MODULE INSMOD" -f /lib/modules/tiwlan.o"
#define TIWLAN_USER_DRV	"/sbin/user_drv &"

typedef struct wifi_s {
/*	char ifname[MAX_IFNAME]; */
	unsigned char if_on;
	char ssid[WHAL_SSID_STRING_LEN+1];
	unsigned char channel;
	unsigned char auth_type;
	unsigned char wep_on;
	unsigned char key_len;
	unsigned char def_key;
	unsigned char key[4][WEP_KEY_LEN_MAX+1];
	unsigned char access_control;
	unsigned char broadcast_ssid;
	unsigned char dot11_mode;
} wifi_t;

/* Initial Wireless Interface. Return error if no Wireless Card found */
int wifi_init(void);
/* Restart Wireless Interface. Do not double check card presentation */
int start_wifi(void);

char *digital_to_keystring(char *dig_key, int keylen);
int wifi_save(void);
int wlan_socket_cmd(char *cmd);
int stop_wifi(void);
int save_wifi(void);
