
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "rc.h"
#include "nvram.h"
/* 
 * Reading name server information from /etc/resolv.conf 
 * and then setup the proxy DNS (dnrd -s xx.xx.xx.xx)
 */
int start_dnrd(void) {
   char ns[1024], *sb, *se, cmdline[1024];
   FILE *fp; 
   char *pt;
#if 1 
	/* set mtu */
	pt=nvram_safe_get("wan_mode");
	if(*pt=='p')
		SYSTEM("/sbin/ifconfig ppp0 mtu %s"
				,nvram_get("wan_mtu")?:"1492");
	/* fix dns */
	if(*nvram_safe_get("wan_fix_dns") == '1') {
		if(strlen(nvram_safe_get("wan_dns1"))>6)
			SYSTEM("/bin/echo \"nameserver %s\" > /etc/resolv.conf"
					,nvram_safe_get("wan_dns1"));
		if(strlen(nvram_safe_get("wan_dns2"))>6)
			SYSTEM("/bin/echo \"nameserver %s\" >> /etc/resolv.conf"
					,nvram_safe_get("wan_dns2"));
	}

#endif

	system("/bin/killall dnrd");
	strcpy(cmdline, "/sbin/dnrd -u99");
   
	fp=fopen("/etc/resolv.conf","r");
   
	if(fp) {
		fread(ns,1024,1,fp);
		fclose(fp);
		sb=ns;
		while((sb=strstr(sb, "nameserver")) != NULL) {
			sb+=11;
			if((se=strstr(sb, "\n"))==NULL)  
				se=ns+strlen(ns);
		        if((se-sb) > 3) {
				strcat(cmdline, " -s ");
				strncat(cmdline, sb, se-sb);
		        }
		 	sb=se;
		}
	}
	if(strlen(cmdline) > 20)
		system(cmdline);
	return 0;
}
