/*
 */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/poll.h>
#include <sys/socket.h>
#include <linux/un.h>
#include "wan.h"		/* definations */
#include "nvram.h"

void set_defaults(void) {
	nvram_set("wan_mode", "pppoe");
	nvram_set("wan_fix_dns", "0");
	nvram_set("wan_dns1", "");
	nvram_set("wan_dns2", "");
	nvram_set("wan_macaddr", "");
	nvram_set("wan_account", "");
	nvram_set("wan_domain", "");
	nvram_set("wan_ipaddr", "");
	nvram_set("wan_netmask", "");
	nvram_set("wan_gateway", "");
	nvram_set("pppoe_username", "joel");
	nvram_set("pppoe_password", "joel");
	nvram_set("pppoe_service", "");
	nvram_set("pppoe_idle", "0");
	nvram_set("pppoa_username", "joel");
	nvram_set("pppoa_password", "joel");
	nvram_set("pppoa_idle", "0");
}

int main(int argc, char *argv[]) {
	if(argc < 2) {
		puts("wan <start|stop|defaults>");
		return -1;
	}
	if(strncmp(argv[1], "start", 5)==0)
		start_wan();
	else if(strncmp(argv[1], "stop", 4)==0)
		stop_wan();
	else if(strncmp(argv[1], "defaults", 8)==0)
		set_defaults();

	return 0;
}
