#ifndef _DEV_OPT_CGI_C_
#define _DEV_OPT_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include "dev_opt.h"
#include "parser.h"
#include "system.h"          //ada
#include "wan.h"             //ada

static devopt_conf *pConf,dev_opt_conf;   //ada

//ada
static MULTI_PPPOE_CONF mpoe_conf;
static int poe_account_index;
static int wan_type;
static enum{
	CHANGE_ACCOUNT,
	SAVE
}which_submit;
//ada
static int ip;


static int r2t_dns2_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	ip=*(int *)(&pConf->dev_dns_1[0]);
	if(ip)
		sprintf(buf,"%d",pConf->dev_dns_1[0]);
	return 0;
}

static int r2t_dns2_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	if(ip)
		sprintf(buf,"%d",pConf->dev_dns_1[1]);
	return 0;
}

static int r2t_dns2_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	if(ip)
		sprintf(buf,"%d",pConf->dev_dns_1[2]);
	return 0;
}

static int r2t_dns2_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	if(ip)
		sprintf(buf,"%d",pConf->dev_dns_1[3]);
	return 0;
}

static int r2t_dns3_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	ip=*(int *)(&pConf->dev_dns_2[0]);
	if(ip)
		sprintf(buf,"%d",pConf->dev_dns_2[0]);
	return 0;
}

static int r2t_dns3_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	if(ip)
		sprintf(buf,"%d",pConf->dev_dns_2[1]);
	return 0;
}

static int r2t_dns3_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	if(ip)
		sprintf(buf,"%d",pConf->dev_dns_2[2]);
	return 0;
}

static int r2t_dns3_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	if(ip)
		sprintf(buf,"%d",pConf->dev_dns_2[3]);
	return 0;
}

static int r2t_enable_upnp(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->upnp_en)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_enable_config(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->upnp_en&&pConf->port_map)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_enable_disable(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->upnp_en&&pConf->wan_dial)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_mtu(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->mtu);
	return 0;
}

#if 0
static int r2t_ts1ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts1ip[0]);
	return 0;
}

static int r2t_ts1ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts1ip[1]);
	return 0;
}

static int r2t_ts1ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts1ip[2]);
	return 0;
}

static int r2t_ts1ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts1ip[3]);
	return 0;
}

static int r2t_ts2ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts2ip[0]);
	return 0;
}

static int r2t_ts2ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts2ip[1]);
	return 0;
}

static int r2t_ts2ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts2ip[2]);
	return 0;
}

static int r2t_ts2ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts2ip[3]);
	return 0;
}


static int r2t_ts3ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts3ip[0]);
	return 0;
}

static int r2t_ts3ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts3ip[1]);
	return 0;
}

static int r2t_ts3ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts3ip[2]);
	return 0;
}

static int r2t_ts3ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pConf->ts3ip[3]);
	return 0;
}
#endif


static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
	return 0;
}

static int r2t_set_time(char buf[CGI_BUF_LEN],char **buf1)
{
	if(!pConf->time_set)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_set_time_manually(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->time_set)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_year0(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_year/10);
	return 0;
}

static int r2t_year1(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_year%10);
	return 0;
}

static int r2t_month0(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_mon/10);
	return 0;
}

static int r2t_month1(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_mon%10);
	return 0;
}

static int r2t_day0(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_mday/10);
	return 0;
}

static int r2t_day1(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_mday%10);
	return 0;
}

static int r2t_hour0(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_hour/10);
	return 0;
}

static int r2t_hour1(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_hour%10);
	return 0;
}

static int r2t_minute0(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_min/10);
	return 0;
}

static int r2t_minute1(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_min%10);
	return 0;
}


static int r2t_second0(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_sec/10);
	return 0;
}

static int r2t_second1(char buf[CGI_BUF_LEN],char **buf1)
{
//	if(pConf->time_set)
		sprintf(buf,"%d",pConf->stm.tm_sec%10);
	return 0;
}

static int r2t_pppoe_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->pppoe_enable)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_wan_master(char buf[CGI_BUF_LEN],char **buf1)
{
	if(!pConf->upnp_session)
		strcpy(buf,str_checked);
	return 0;
}


static int r2t_wan_master_wan_master(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->upnp_session)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_wan_sub(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->upnp_session==1)
		strcpy(buf,str_checked);
	return 0;
}

static int r2t_wan_sub_wan_sub2(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->upnp_session==2)
		strcpy(buf,str_checked);
	return 0;
}


static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
        strcpy(buf,mpoe_conf.account[poe_account_index].poe_ac_name);       //ada	
	return 0;
}

static int r2t_hide_master_head(char buf[CGI_BUF_LEN],char **buf1)
{
    if(wan_type!=CONNECTION_MULTI_PPPOE){
        strcpy(buf,"<!--");
    }
   	return 0;
}

static int r2t_hide_enable_head(char buf[CGI_BUF_LEN],char **buf1)
{
    if(wan_type==CONNECTION_MULTI_PPPOE){
        strcpy(buf,"<!--");
    }
	return 0;
}

static int r2t_hide_enable_tail(char buf[CGI_BUF_LEN],char **buf1)
{
    if(wan_type==CONNECTION_MULTI_PPPOE){
        strcpy(buf,"-->");
    }
   	return 0;
}

static int r2t_upnp_message(char buf[CGI_BUF_LEN],char **buf1)
{
    if(wan_type==CONNECTION_MULTI_PPPOE){
        strcpy(buf,"UPnPgp");
    }
    else{
        strcpy(buf,"UPnPgĖ{i̐ݒύX");
    }
	return 0;
}

static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1)
{
	//ada
	int i;
	if(wan_type == CONNECTION_MULTI_PPPOE){
        strcpy(buf,str_poe_ac_list_head_opt);
        for(i=0;i<MAX_PPPOE_ACCOUNT;i++){
            if(i == poe_account_index){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            strcat(buf,mpoe_conf.account[i].poe_ac_name);
            strcat(buf,option_e);
        }
        strcat(buf,str_poe_ac_list_tail_opt);
    }//ada
    else{
        strcpy(buf,"-->");
    }
	return 0;
}

static int t2r_dns2_ip_1(const char *value)
{
	pConf->dev_dns_1[0]= atoi(value);
	return 0;
}

static int t2r_dns2_ip_2(const char *value)
{
	pConf->dev_dns_1[1]= atoi(value);
	return 0;
}

static int t2r_dns2_ip_3(const char *value)
{
	pConf->dev_dns_1[2]= atoi(value);
	return 0;
}

static int t2r_dns2_ip_4(const char *value)
{
	pConf->dev_dns_1[3]= atoi(value);
	return 0;
}

static int t2r_dns3_ip_1(const char *value)
{
	pConf->dev_dns_2[0]= atoi(value);
	return 0;
}

static int t2r_dns3_ip_2(const char *value)
{
	pConf->dev_dns_2[1]= atoi(value);
	return 0;
}

static int t2r_dns3_ip_3(const char *value)
{
	pConf->dev_dns_2[2]=atoi(value);
	return 0;
}

static int t2r_dns3_ip_4(const char *value)
{
	pConf->dev_dns_2[3]= atoi(value);
	return 0;
}

static int t2r_enable_upnp(const char *value)
{
	pConf->upnp_en=1;
	return 0;
}

static int t2r_enable_config(const char *value)
{
	pConf->port_map=1;
	return 0;
}

static int t2r_enable_disable(const char *value)
{
	pConf->wan_dial=1;
	return 0;
}

static int t2r_mtu(const char *value)
{
	pConf->mtu=atoi(value);
	return 0;
}
#if 0
static int t2r_ts1ip_1(const char *value)
{
	pConf->ts1ip[0]=atoi(value);
	return 0;
}

static int t2r_ts1ip_2(const char *value)
{
	pConf->ts1ip[1]=atoi(value);
	return 0;
}

static int t2r_ts1ip_3(const char *value)
{
	pConf->ts1ip[2]=atoi(value);
	return 0;
}
static int t2r_ts1ip_4(const char *value)
{
	pConf->ts1ip[3]=atoi(value);
	return 0;
}

static int t2r_ts2ip_1(const char *value)
{
	pConf->ts2ip[0]=atoi(value);
	return 0;
}

static int t2r_ts2ip_2(const char *value)
{
	pConf->ts2ip[1]=atoi(value);
	return 0;
}

static int t2r_ts2ip_3(const char *value)
{
	pConf->ts2ip[2]=atoi(value);
	return 0;
}
static int t2r_ts2ip_4(const char *value)
{
	pConf->ts2ip[3]=atoi(value);
	return 0;
}

static int t2r_ts3ip_1(const char *value)
{
	pConf->ts2ip[0]=atoi(value);
	return 0;
}

static int t2r_ts3ip_2(const char *value)
{
	pConf->ts2ip[1]=atoi(value);
	return 0;
}

static int t2r_ts3ip_3(const char *value)
{
	pConf->ts2ip[2]=atoi(value);
	return 0;
}
static int t2r_ts3ip_4(const char *value)
{
	pConf->ts2ip[3]=atoi(value);
	return 0;
}
#endif
static int t2r_save(const char *value)
{
	which_submit=SAVE;        //ada
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

static int t2r_set_time(const char *value)
{
	if(!strcmp(value,"manually"))
		pConf->time_set=1;
	else
		pConf->time_set=0;
	return 0;
}

static int t2r_year0(const char *value)
{	
	pConf->stm.tm_year=10*atoi(value);
	return 0;
}

static int t2r_year1(const char *value)
{
	pConf->stm.tm_year+=atoi(value);
	return 0;
}

static int t2r_month0(const char *value)
{
	pConf->stm.tm_mon=10*atoi(value);
	return 0;
}

static int t2r_month1(const char *value)
{
	pConf->stm.tm_mon+=atoi(value);
	return 0;
}

static int t2r_day0(const char *value)
{
	pConf->stm.tm_mday=10*atoi(value);
	return 0;
}

static int t2r_day1(const char *value)
{
	pConf->stm.tm_mday+=atoi(value);
	return 0;
}

static int t2r_hour0(const char *value)
{
	pConf->stm.tm_hour=10*atoi(value);
	return 0;
}

static int t2r_hour1(const char *value)
{
	pConf->stm.tm_hour+=atoi(value);
	return 0;
}

static int t2r_minute0(const char *value)
{
	pConf->stm.tm_min=10*atoi(value);
	return 0;
}

static int t2r_minute1(const char *value)
{
	pConf->stm.tm_min+=atoi(value);
	return 0;
}

static int t2r_second0(const char *value)
{
	pConf->stm.tm_sec=10*atoi(value);
	return 0;
}

static int t2r_second1(const char *value)
{
	pConf->stm.tm_sec+=atoi(value);
	return 0;
}

static int t2r_pppoe_enable(const char *value)
{
	pConf->pppoe_enable=1;
	return 0;
}

static int t2r_wan_master(const char *value)
{
	if(!strcmp(value,"enable_wan_ip"))
		pConf->upnp_session=0;
	else if(!strcmp(value,"wan_master"))
		pConf->upnp_session=1;
	return 0;
}

static int t2r_wan_sub(const char *value)
{
	if(pConf->upnp_session){
		if(!strcmp(value,"wan_sub2"))
			pConf->upnp_session=2;
		else
			pConf->upnp_session=1;
	}
	return 0;
}

static int t2r_poe_ac_value(const char *value)
{
	//ada
	int i;
	if(*value){
	    for(i=0;*value&&i<MAX_PPPOE_ACCOUNT;i++){
	        if(!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
	            poe_account_index = i;  
	            break;
	        }
	    }	
	} //ada        
	return 0;
}

int dev_opt_main(void)
{
	LIST *hd=NULL;
	int ccode;

	memset(glb_errlog,0,sizeof(glb_errlog));
	//ada
	which_submit = CHANGE_ACCOUNT;  		
	memset(&mpoe_conf, 0, sizeof(MULTI_PPPOE_CONF));	
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){
		poe_account_index=0;		
		ReadMultiPPPoESettings(&mpoe_conf);
	}
	else
	{
		poe_account_index=-1;		
	}
	//ada	

	memset(&dev_opt_conf,0,sizeof(devopt_conf));
	pConf=&dev_opt_conf;		
	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!hd)
			cgi_err("","");
		if(!do_cgi_t2r(hd,key_fun_tab)){
			if(ErrlogIsSetted()){
				if(isset(glb_errlog,MSG3_DEV_OPT)){
					char *msg=get_err_msg(MSG3_DEV_OPT);
					fmt_err_msg(msg);
				}
				if(isset(glb_errlog,MSG5_DEV_OPT)){
					char *msg=get_err_msg(MSG5_DEV_OPT);
					fmt_err_msg(msg);
				}
			}
			else{
				if(which_submit==SAVE){
					if(wan_type==CONNECTION_MULTI_PPPOE)
						pConf->upnp_en=1;
					ccode=SaveDevConf(&dev_opt_conf,poe_account_index);  //ada
					WriteConfToFlash();
					if(fork()==0){	
						cgi_fork_do();
						Daytime();
						if(pConf->upnp_en){
							StartUPnP();
						}else{
							StopUPnP();
						}
						exit(0);
					}
				}else if(which_submit==CHANGE_ACCOUNT){
					ReadDevConf(&dev_opt_conf,poe_account_index);  //ada	
			        }
			}
		}	
		list_clear(hd);
	}else
		ReadDevConf(&dev_opt_conf,poe_account_index);  //ada
	return html_parser("dev_opt.htm",key_fun_tab);
}

#endif
