#ifndef _GROUPS_CGI_C_
#define _GROUPS_CGI_C_

#include "serv.h"
#include "groups.h"
#include "lan.h"
#include "wan.h"
#include "system.h"

extern int mkcrontab_main(void);

static serv_conf *pConf=NULL;
static int serv_num=0;

static group_conf conf;
                           /*    NONE       ALL               SELECT        */
static char *access_right_db[]={"Ȃ","SẴT[rX","IT[rX",0};
                        /*ALWAYS  SCHEDULE */
static char *sch_db[] = {"Ȃ","",0};


static MULTI_PPPOE_CONF mpoe_conf;
static int poe_account_index;
static int wan_type;
static enum{
	CHANGE_GROUP,
	CHANGE_ACCOUNT,
	SAVE
}which_submit;

static int r2t_group_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;

	*buf='\0';
	for(i=0;i<5;i++){
		if(i==group_index)
			strcat(buf,option_sl);
		else
			strcat(buf,option_s);
		strcat(buf,pc_group_db[i]);
		strcat(buf,option_e);
	}

	return 0;
}

static int r2t_access_rights(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;

	*buf='\0';
	for(i=0;i<3;i++){
		if( (conf.block==BLOCK_NONE && i==0)
			|| (conf.block==BLOCK_ALL && i==1)
			|| (conf.block==BLOCK_SELECT && i==2)
		){
			strcat(buf,option_sl);
		}
		else{
			strcat(buf,option_s);
		}
		strcat(buf,access_right_db[i]);
		strcat(buf,option_e);
	}

	return 0;
}

static int r2t_access_sch(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;

	*buf='\0';
	for(i=0;i<2;i++){
	    if( (conf.schedule == GROUP_ALWAYS && i ==0)
	     || (conf.schedule == GROUP_BASE_SCHEDULE && i ==1)
	    ){
	        strcat(buf,option_sl);
	    }
	    else{
	        strcat(buf,option_s);
	    }
		strcat(buf,sch_db[i]);
		strcat(buf,option_e);
	}

	return 0;
}

static int r2t_service_name(char buf[CGI_BUF_LEN],char **buf1)
{
	serv_conf *p=pConf;

	*buf='\0';

	*buf1=(char *)malloc((EntryNameLen+30+strlen(option_sl)+strlen(option_e))*serv_num+1);
	if(*buf1==NULL){
		cgi_err("malloc error!","");
		return 0;
	}

	memset(*buf1,0,(EntryNameLen+30+strlen(option_sl)+strlen(option_e))*serv_num+1);
	while(p){
		char u_buf[100];
		if(serv_in_group(p->name,group_index))
			strcat(*buf1,option_sl);
		else
			strcat(*buf1,option_s);
		strcat(*buf1,p->name);
		sprintf(u_buf,"(%s:%s)",p->protocol,p->port_info);
		strcat(*buf1,u_buf);
		strcat(*buf1,option_e);
		p=p->next;
	}

	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{

	return 0;
}

static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mpoe_conf.account[poe_account_index].poe_ac_name);	
	return 0;
}

static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	if(wan_type == CONNECTION_MULTI_PPPOE){
        strcpy(buf,str_poe_ac_list_head);
        for(i=0;i<MAX_PPPOE_ACCOUNT;i++){
            if(i == poe_account_index){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            strcat(buf,mpoe_conf.account[i].poe_ac_name);
            strcat(buf,option_e);
        }
        strcat(buf,str_poe_ac_list_tail);
    }	
	return 0;
}

//=============================SAVE FUNCTIONS=================================


static int t2r_group_list(const char *value)
{
	if(value){
		group_index=str_db_search(pc_group_db, value);
		RecorderGrpIndex(group_index);
	}

	return 0;
}

static int t2r_members(const char *value)
{
	return 0;
}

static int t2r_access_rights(const char *value){

    int i;

	i = str_db_search(access_right_db,value);
	switch(i){
	case 0:
	    conf.block = BLOCK_NONE;
	    break;
	case 1:
	    conf.block = BLOCK_ALL;
	    break;
	case 2:
	    conf.block = BLOCK_SELECT;
	    break;
	default:
	    break;
	}


	return 0;
}

static int t2r_access_sch(const char *value){
    int i;

    i = str_db_search(sch_db,value);
    switch(i){
    case 0:
        conf.schedule = GROUP_ALWAYS;
        break;
    case 1:
        conf.schedule = GROUP_BASE_SCHEDULE;
        break;
    default:
        break;
    }
	return 0;
}

static int t2r_sch_def(const char *value)
{
	return 0;
}

static int t2r_service_name(const char *value)
{
	return 0;
}

static int t2r_help1(const char *value)
{
	return 0;
}

static int t2r_help2(const char *value)
{
	return 0;
}

static int t2r_clear_ac_log(const char *value)
{
	return 0;
}

static int t2r_save(const char *value)
{
	which_submit=SAVE;
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

static int t2r_todo(const char *value)
{
	if(strcmp(value,"change_select")==0)
		which_submit=CHANGE_GROUP;
	return 0;
}

static int t2r_poe_ac_value(const char *value)
{
	int i;
	if(*value){
	    for(i=0;*value&&i<MAX_PPPOE_ACCOUNT;i++){
	        if(!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
	            poe_account_index = i;  
	            break;
	        }
	    }	
    }  
	return 0;
}

int groups_main(void)
{

	LIST *hd=NULL;
	int ccode;

	memset(&conf,0,sizeof(conf));

	
	which_submit = CHANGE_ACCOUNT;  		
	memset(&mpoe_conf, 0, sizeof(MULTI_PPPOE_CONF));	
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){
		poe_account_index=0;		
		ReadMultiPPPoESettings(&mpoe_conf);
	}else{
		poe_account_index=-1;		
	}
	
	ReadSERV(&pConf,&serv_num,poe_account_index);
	
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){
			if(which_submit==SAVE){
				char **vals=NULL,**list=NULL;
				char *p=NULL;
				int no=0,i;

				if(conf.block==BLOCK_SELECT){

					no=find_val_multi(hd,"service_name",&vals);
					if(no==0)
						conf.block=BLOCK_NONE;
					else if(no==serv_num)
						conf.block=BLOCK_ALL;
					else{

						list=vals;
						conf.appname=list;
						for(i=0;i<no;i++){
							p=strchr(*vals,'(');
							if(p)
								*p=0;
							vals++;
						}
					}
				}
				ccode=SaveGroup(group_index,&conf,no);
				WriteConfToFlash();
				mkcrontab_main();
			}
			else if(which_submit==CHANGE_GROUP){
				char *value;

				value=find_val(hd,"group_list");
				group_index=str_db_search(pc_group_db, value);
				RecorderGrpIndex(group_index);
				ccode=ReadGroup(group_index,&conf);
			}else if(which_submit==CHANGE_ACCOUNT){
				ReadSERV(&pConf,&serv_num,poe_account_index);
			}
		}
		list_clear(hd);
	}
	else
		ReadGroup(group_index,&conf);

	ccode=html_parser("groups.htm",key_fun_tab);

   	if(pConf)
   		FreeSERV(pConf);
   	return ccode;
}

#endif
