#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_enable_udsp01(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp01(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp01_intype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp01_ins(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp01_inf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp01_otype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp01_outs(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp01_outf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_enable_udsp02(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp02(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp02_intype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp02_ins(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp02_inf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp02_otype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp02_outs(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp02_outf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_enable_udsp03(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp03(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp03_intype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp03_ins(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp03_inf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp03_otype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp03_outs(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp03_outf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_enable_udsp04(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp04(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp04_intype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp04_ins(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp04_inf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp04_otype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp04_outs(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp04_outf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_enable_udsp05(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp05(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp05_intype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp05_ins(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp05_inf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp05_otype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp05_outs(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp05_outf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_enable_udsp06(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp06(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp06_intype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp06_ins(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp06_inf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp06_otype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp06_outs(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ud_sp06_outf(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_enable_udsp01(const char *value);
static int t2r_ud_sp01(const char *value);
static int t2r_ud_sp01_intype(const char *value);
static int t2r_ud_sp01_ins(const char *value);
static int t2r_ud_sp01_inf(const char *value);
static int t2r_ud_sp01_otype(const char *value);
static int t2r_ud_sp01_outs(const char *value);
static int t2r_ud_sp01_outf(const char *value);
static int t2r_enable_udsp02(const char *value);
static int t2r_ud_sp02(const char *value);
static int t2r_ud_sp02_intype(const char *value);
static int t2r_ud_sp02_ins(const char *value);
static int t2r_ud_sp02_inf(const char *value);
static int t2r_ud_sp02_otype(const char *value);
static int t2r_ud_sp02_outs(const char *value);
static int t2r_ud_sp02_outf(const char *value);
static int t2r_enable_udsp03(const char *value);
static int t2r_ud_sp03(const char *value);
static int t2r_ud_sp03_intype(const char *value);
static int t2r_ud_sp03_ins(const char *value);
static int t2r_ud_sp03_inf(const char *value);
static int t2r_ud_sp03_otype(const char *value);
static int t2r_ud_sp03_outs(const char *value);
static int t2r_ud_sp03_outf(const char *value);
static int t2r_enable_udsp04(const char *value);
static int t2r_ud_sp04(const char *value);
static int t2r_ud_sp04_intype(const char *value);
static int t2r_ud_sp04_ins(const char *value);
static int t2r_ud_sp04_inf(const char *value);
static int t2r_ud_sp04_otype(const char *value);
static int t2r_ud_sp04_outs(const char *value);
static int t2r_ud_sp04_outf(const char *value);
static int t2r_enable_udsp05(const char *value);
static int t2r_ud_sp05(const char *value);
static int t2r_ud_sp05_intype(const char *value);
static int t2r_ud_sp05_ins(const char *value);
static int t2r_ud_sp05_inf(const char *value);
static int t2r_ud_sp05_otype(const char *value);
static int t2r_ud_sp05_outs(const char *value);
static int t2r_ud_sp05_outf(const char *value);
static int t2r_enable_udsp06(const char *value);
static int t2r_ud_sp06(const char *value);
static int t2r_ud_sp06_intype(const char *value);
static int t2r_ud_sp06_ins(const char *value);
static int t2r_ud_sp06_inf(const char *value);
static int t2r_ud_sp06_otype(const char *value);
static int t2r_ud_sp06_outs(const char *value);
static int t2r_ud_sp06_outf(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"enable_udsp01",r2t_enable_udsp01,t2r_enable_udsp01},
	{"ud_sp01",r2t_ud_sp01,t2r_ud_sp01},
	{"ud_sp01_intype",r2t_ud_sp01_intype,t2r_ud_sp01_intype},
	{"ud_sp01_ins",r2t_ud_sp01_ins,t2r_ud_sp01_ins},
	{"ud_sp01_inf",r2t_ud_sp01_inf,t2r_ud_sp01_inf},
	{"ud_sp01_otype",r2t_ud_sp01_otype,t2r_ud_sp01_otype},
	{"ud_sp01_outs",r2t_ud_sp01_outs,t2r_ud_sp01_outs},
	{"ud_sp01_outf",r2t_ud_sp01_outf,t2r_ud_sp01_outf},
	{"enable_udsp02",r2t_enable_udsp02,t2r_enable_udsp02},
	{"ud_sp02",r2t_ud_sp02,t2r_ud_sp02},
	{"ud_sp02_intype",r2t_ud_sp02_intype,t2r_ud_sp02_intype},
	{"ud_sp02_ins",r2t_ud_sp02_ins,t2r_ud_sp02_ins},
	{"ud_sp02_inf",r2t_ud_sp02_inf,t2r_ud_sp02_inf},
	{"ud_sp02_otype",r2t_ud_sp02_otype,t2r_ud_sp02_otype},
	{"ud_sp02_outs",r2t_ud_sp02_outs,t2r_ud_sp02_outs},
	{"ud_sp02_outf",r2t_ud_sp02_outf,t2r_ud_sp02_outf},
	{"enable_udsp03",r2t_enable_udsp03,t2r_enable_udsp03},
	{"ud_sp03",r2t_ud_sp03,t2r_ud_sp03},
	{"ud_sp03_intype",r2t_ud_sp03_intype,t2r_ud_sp03_intype},
	{"ud_sp03_ins",r2t_ud_sp03_ins,t2r_ud_sp03_ins},
	{"ud_sp03_inf",r2t_ud_sp03_inf,t2r_ud_sp03_inf},
	{"ud_sp03_otype",r2t_ud_sp03_otype,t2r_ud_sp03_otype},
	{"ud_sp03_outs",r2t_ud_sp03_outs,t2r_ud_sp03_outs},
	{"ud_sp03_outf",r2t_ud_sp03_outf,t2r_ud_sp03_outf},
	{"enable_udsp04",r2t_enable_udsp04,t2r_enable_udsp04},
	{"ud_sp04",r2t_ud_sp04,t2r_ud_sp04},
	{"ud_sp04_intype",r2t_ud_sp04_intype,t2r_ud_sp04_intype},
	{"ud_sp04_ins",r2t_ud_sp04_ins,t2r_ud_sp04_ins},
	{"ud_sp04_inf",r2t_ud_sp04_inf,t2r_ud_sp04_inf},
	{"ud_sp04_otype",r2t_ud_sp04_otype,t2r_ud_sp04_otype},
	{"ud_sp04_outs",r2t_ud_sp04_outs,t2r_ud_sp04_outs},
	{"ud_sp04_outf",r2t_ud_sp04_outf,t2r_ud_sp04_outf},
	{"enable_udsp05",r2t_enable_udsp05,t2r_enable_udsp05},
	{"ud_sp05",r2t_ud_sp05,t2r_ud_sp05},
	{"ud_sp05_intype",r2t_ud_sp05_intype,t2r_ud_sp05_intype},
	{"ud_sp05_ins",r2t_ud_sp05_ins,t2r_ud_sp05_ins},
	{"ud_sp05_inf",r2t_ud_sp05_inf,t2r_ud_sp05_inf},
	{"ud_sp05_otype",r2t_ud_sp05_otype,t2r_ud_sp05_otype},
	{"ud_sp05_outs",r2t_ud_sp05_outs,t2r_ud_sp05_outs},
	{"ud_sp05_outf",r2t_ud_sp05_outf,t2r_ud_sp05_outf},
	{"enable_udsp06",r2t_enable_udsp06,t2r_enable_udsp06},
	{"ud_sp06",r2t_ud_sp06,t2r_ud_sp06},
	{"ud_sp06_intype",r2t_ud_sp06_intype,t2r_ud_sp06_intype},
	{"ud_sp06_ins",r2t_ud_sp06_ins,t2r_ud_sp06_ins},
	{"ud_sp06_inf",r2t_ud_sp06_inf,t2r_ud_sp06_inf},
	{"ud_sp06_otype",r2t_ud_sp06_otype,t2r_ud_sp06_otype},
	{"ud_sp06_outs",r2t_ud_sp06_outs,t2r_ud_sp06_outs},
	{"ud_sp06_outf",r2t_ud_sp06_outf,t2r_ud_sp06_outf},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "i_sap_cgi.c"

/*************************/
