#ifndef _I_SAP_CGI_C_
#define _I_SAP_CGI_C_

#include "ud_sap.h"
#include "i_urlf.h"
static	sap_conf	conf[MAX_UD_SAP];

#define		TCP	"TCP"
#define		UDP	"UDP"

char *protocol_db[] = {"TCP","UDP",0};

#define R2T_ENABLE_UDSP0X(x)                                            \
static int r2t_enable_udsp0##x(char buf[CGI_BUF_LEN],char **buf1){      \
	if(conf[(x-1)].enable){                                             \
		strcpy(buf,str_checked);                                        \
	}                                                                   \
	return 0;                                                           \
}

#define R2T_UD_SP0X(x)                                                  \
static int r2t_ud_sp0##x(char buf[CGI_BUF_LEN],char **buf1){            \
	if(strlen(conf[(x-1)].name)){                                       \
		strcpy(buf,conf[(x-1)].name);                                   \
	}	                                                                \
	return 0;                                                           \
}

#define R2T_UD_SP0X_INTYPE(x)                                           \
static int r2t_ud_sp0##x##_intype(char buf[CGI_BUF_LEN],char **buf1){   \
    int Index = conf[(x-1)].in_protocol==PRO_UDP ? 1 : 0;               \
    int i;                                                              \
                                                                        \
    for(i = 0; i < 2; i++ ){                                            \
        if( Index == i){                                                \
            strcat(buf, option_sl);                                     \
        }                                                               \
        else{                                                           \
            strcat(buf, option_s);                                      \
        }                                                               \
        strcat(buf,protocol_db[i]);                                     \
        strcat(buf,option_e);                                           \
    }	                                                                \
	return 0;                                                           \
}

#define R2T_UD_SP0X_INS(x)                                              \
static int r2t_ud_sp0##x##_ins(char buf[CGI_BUF_LEN],char **buf1){      \
	if(strlen(conf[(x-1)].in_ports)){                                   \
		strcpy(buf,conf[(x-1)].in_ports);                               \
	}                                                                   \
	return 0;                                                           \
}

#define R2T_UD_SP0X_INF(x)                                              \
static int r2t_ud_sp0##x##_inf(char buf[CGI_BUF_LEN],char **buf1){      \
	if(strlen(conf[(x-1)].in_porte)){                                   \
		strcpy(buf,conf[(x-1)].in_porte);                               \
	}                                                                   \
	return 0;                                                           \
}


#define R2T_UD_SP0X_OTYPE(x)                                            \
static int r2t_ud_sp0##x##_otype(char buf[CGI_BUF_LEN],char **buf1){    \
    int Index = conf[(x-1)].ext_protocol==PRO_UDP ? 1 : 0;              \
    int i;                                                              \
                                                                        \
    for(i = 0; i < 2; i++ ){                                            \
        if( Index == i){                                                \
            strcat(buf, option_sl);                                     \
        }                                                               \
        else{                                                           \
            strcat(buf, option_s);                                      \
        }                                                               \
        strcat(buf,protocol_db[i]);                                     \
        strcat(buf,option_e);                                           \
    }	                                                                \
	return 0;                                                           \
}

#define R2T_UD_SP0X_OUTS(x)                                             \
static int r2t_ud_sp0##x##_outs(char buf[CGI_BUF_LEN],char **buf1){     \
	if(strlen(conf[(x-1)].ext_ports)){                                  \
		strcpy(buf,conf[(x-1)].ext_ports);                              \
	}                                                                   \
	return 0;                                                           \
}

#define R2T_UD_SP0X_OUTF(x)                                             \
static int r2t_ud_sp0##x##_outf(char buf[CGI_BUF_LEN],char **buf1){     \
	if(strlen(conf[(x-1)].ext_porte)){                                  \
		strcpy(buf,conf[(x-1)].ext_porte);                              \
	}                                                                   \
	return 0;                                                           \
}



R2T_ENABLE_UDSP0X(1);
R2T_UD_SP0X(1);
R2T_UD_SP0X_INTYPE(1);
R2T_UD_SP0X_INS(1);
R2T_UD_SP0X_INF(1);
R2T_UD_SP0X_OTYPE(1);
R2T_UD_SP0X_OUTS(1);
R2T_UD_SP0X_OUTF(1);

R2T_ENABLE_UDSP0X(2);
R2T_UD_SP0X(2);
R2T_UD_SP0X_INTYPE(2);
R2T_UD_SP0X_INS(2);
R2T_UD_SP0X_INF(2);
R2T_UD_SP0X_OTYPE(2);
R2T_UD_SP0X_OUTS(2);
R2T_UD_SP0X_OUTF(2);

R2T_ENABLE_UDSP0X(3);
R2T_UD_SP0X(3);
R2T_UD_SP0X_INTYPE(3);
R2T_UD_SP0X_INS(3);
R2T_UD_SP0X_INF(3);
R2T_UD_SP0X_OTYPE(3);
R2T_UD_SP0X_OUTS(3);
R2T_UD_SP0X_OUTF(3);

R2T_ENABLE_UDSP0X(4);
R2T_UD_SP0X(4);
R2T_UD_SP0X_INTYPE(4);
R2T_UD_SP0X_INS(4);
R2T_UD_SP0X_INF(4);
R2T_UD_SP0X_OTYPE(4);
R2T_UD_SP0X_OUTS(4);
R2T_UD_SP0X_OUTF(4);

R2T_ENABLE_UDSP0X(5);
R2T_UD_SP0X(5);
R2T_UD_SP0X_INTYPE(5);
R2T_UD_SP0X_INS(5);
R2T_UD_SP0X_INF(5);
R2T_UD_SP0X_OTYPE(5);
R2T_UD_SP0X_OUTS(5);
R2T_UD_SP0X_OUTF(5);

R2T_ENABLE_UDSP0X(6);
R2T_UD_SP0X(6);
R2T_UD_SP0X_INTYPE(6);
R2T_UD_SP0X_INS(6);
R2T_UD_SP0X_INF(6);
R2T_UD_SP0X_OTYPE(6);
R2T_UD_SP0X_OUTS(6);
R2T_UD_SP0X_OUTF(6);



static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}


//=============================SAVE FUNCTIONS=================================

#define T2R_ENABLE_UDSP0X(x)                            \
static int t2r_enable_udsp0##x(const char *value){      \
	if(value){                                          \
		conf[(x-1)].enable=ENABLE;                      \
	}	                                                \
	else{                                               \
		conf[(x-1)].enable=DISABLE;                     \
	}	                                                \
	return 0;                                           \
}

#define T2R_UD_SP0X(x)                                  \
static int t2r_ud_sp0##x(const char *value){            \
	strncpy(conf[(x-1)].name,value,CommonNameLen);      \
	conf[(x-1)].name[CommonNameLen-1] = '\0';           \
	return 0;                                           \
}

#define T2R_UD_SP0X_INTYPE(x)                           \
static int t2r_ud_sp0##x##_intype(const char *value){   \
	if(!strcmp(value,TCP))                              \
		conf[(x-1)].in_protocol=PRO_TCP;                \
	else if(!strcmp(value,UDP))                         \
		conf[(x-1)].in_protocol=PRO_UDP;                \
	                                                    \
	return 0;                                           \
}

#define T2R_UD_SP0X_INS(x)                              \
static int t2r_ud_sp0##x##_ins(const char *value){      \
	strncpy(conf[(x-1)].in_ports,value,PortLen);        \
	conf[(x-1)].in_ports[PortLen-1] = '\0';             \
	return 0;                                           \
}

#define T2R_UD_SP0X_INF(x)                              \
static int t2r_ud_sp0##x##_inf(const char *value){      \
	strncpy(conf[(x-1)].in_porte,value,PortLen);        \
	conf[(x-1)].in_porte[PortLen-1] = '\0';             \
	return 0;                                           \
}

#define T2R_UD_SP0X_OTYPE(x)                            \
static int t2r_ud_sp0##x##_otype(const char *value){    \
	if(!strcmp(value,TCP))                              \
		conf[(x-1)].ext_protocol=PRO_TCP;               \
	else if(!strcmp(value,UDP))                         \
		conf[(x-1)].ext_protocol=PRO_UDP;               \
	                                                    \
	return 0;                                           \
}

#define T2R_UD_SP0X_OUTS(x)                             \
static int t2r_ud_sp0##x##_outs(const char *value){     \
	strncpy(conf[(x-1)].ext_ports,value,PortLen);       \
	conf[(x-1)].ext_ports[PortLen-1] = '\0';            \
	return 0;                                           \
}

#define T2R_UD_SP0X_OUTF(x)                             \
static int t2r_ud_sp0##x##_outf(const char *value){     \
	strncpy(conf[(x-1)].ext_porte,value,PortLen);       \
	conf[(x-1)].ext_porte[PortLen-1] = '\0';            \
	return 0;                                           \
}



T2R_ENABLE_UDSP0X(1);
T2R_UD_SP0X(1);
T2R_UD_SP0X_INTYPE(1);
T2R_UD_SP0X_INS(1);
T2R_UD_SP0X_INF(1);
T2R_UD_SP0X_OTYPE(1);
T2R_UD_SP0X_OUTS(1);
T2R_UD_SP0X_OUTF(1);

T2R_ENABLE_UDSP0X(2);
T2R_UD_SP0X(2);
T2R_UD_SP0X_INTYPE(2);
T2R_UD_SP0X_INS(2);
T2R_UD_SP0X_INF(2);
T2R_UD_SP0X_OTYPE(2);
T2R_UD_SP0X_OUTS(2);
T2R_UD_SP0X_OUTF(2);

T2R_ENABLE_UDSP0X(3);
T2R_UD_SP0X(3);
T2R_UD_SP0X_INTYPE(3);
T2R_UD_SP0X_INS(3);
T2R_UD_SP0X_INF(3);
T2R_UD_SP0X_OTYPE(3);
T2R_UD_SP0X_OUTS(3);
T2R_UD_SP0X_OUTF(3);

T2R_ENABLE_UDSP0X(4);
T2R_UD_SP0X(4);
T2R_UD_SP0X_INTYPE(4);
T2R_UD_SP0X_INS(4);
T2R_UD_SP0X_INF(4);
T2R_UD_SP0X_OTYPE(4);
T2R_UD_SP0X_OUTS(4);
T2R_UD_SP0X_OUTF(4);

T2R_ENABLE_UDSP0X(5);
T2R_UD_SP0X(5);
T2R_UD_SP0X_INTYPE(5);
T2R_UD_SP0X_INS(5);
T2R_UD_SP0X_INF(5);
T2R_UD_SP0X_OTYPE(5);
T2R_UD_SP0X_OUTS(5);
T2R_UD_SP0X_OUTF(5);

T2R_ENABLE_UDSP0X(6);
T2R_UD_SP0X(6);
T2R_UD_SP0X_INTYPE(6);
T2R_UD_SP0X_INS(6);
T2R_UD_SP0X_INF(6);
T2R_UD_SP0X_OTYPE(6);
T2R_UD_SP0X_OUTS(6);
T2R_UD_SP0X_OUTF(6);


static char todo=0;

#define SAVE	1

static int t2r_save(const char *value){
	todo=SAVE;
	return 0;
}

static int t2r_help(const char *value){
	return 0;
}

static int t2r_close(const char *value){
	return 0;
}

static int t2r_message(const char *value){
	return 0;
}

int i_sap_main(void)
{
    
	LIST *hd=NULL;
	int ccode;
	int i;
	
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}		
		if(!do_cgi_t2r(hd,key_fun_tab)){
			
			if(todo==SAVE){
				for(i=0;i<MAX_UD_SAP;i++){
					ccode=SaveSAP(i+1,&conf[i]);
				}
			    WriteConfToFlash();
			    WriteScript();
//			    StartFW();
			    restart_urlgw();
			}
		}
		list_clear(hd);
	}
	for(i=0;i<MAX_UD_SAP;i++)
			ccode=ReadSAP(i+1,&conf[i]);
	
   	ccode=html_parser("i_sap.htm",key_fun_tab);
   	
   	return ccode;
}
#endif


