#ifndef _I_URLF_CGI_C_
#define _I_URLF_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "i_urlf.h"
#include "parser.h"

static int poe_account_index;

static int which_submit=0;
enum{
	URL_ADD,
	URL_DEL,
	URL_DELALL,
	ALL_ITEM
};

static int r2t_url_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int ret,num=0,len;
	char **p=NULL,**q=NULL;

	ret=GetSite(&p,&num,poe_account_index);
	if(ret)
		return GetSiteErr;
	if(num==0)
		return 0;
	len=MAX_SITE_LEN+20;
	*buf1=malloc(num*len);
	if(*buf1==NULL)
		return GetSiteErr;
	memset(*buf1,0,num*len);
	q=p;
	while(*q){
		strcat(*buf1,option_s);
		strcat(*buf1,*q);
		strcat(*buf1,option_e);
		q++;
	}
	if(p){
		FreeSite(p);
	}
	return 0;
}

static int r2t_u_name(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
    return 0;    
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
	return 0;
}

//ada
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",poe_account_index);
	return 0;
}//ada

static int t2r_url_list(const char *value)
{
	return 0;
}

static int t2r_u_delete(const char *value)
{
	if(value)
		which_submit=URL_DEL;
	return 0;
}

static int t2r_u_deleall(const char *value)
{
	if(value)
		which_submit=URL_DELALL;
	return 0;
}

static int t2r_u_name(const char *value)
{
	if(*value==0)
		setbit(glb_errlog,MSG1_URL_F);
	return 0;
}

static int t2r_u_add(const char *value)
{
	if(value)
		which_submit=URL_ADD;
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_close(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

//ada
static int t2r_poe_ac_value(const char *value)
{
	poe_account_index=atoi(value);
	return 0;
}//ada

int i_urlf_main(void)
{
	LIST *hd=NULL;
	char *val,**vals;
	int num,n,ccode;
	
	poe_account_index=-1;//ada
	hd=cgi_input_parse();//ada
	
	memset(glb_errlog,0,sizeof(glb_errlog));
	if (strcmp(REQUEST_METHOD,POST) == 0){

		if(!hd){
			cgi_err("","");
		}		
		if(!do_cgi_t2r(hd,key_fun_tab)){
			switch(which_submit){
				case URL_ADD:
					if(ErrlogIsSetted()){
    		    		if(isset(glb_errlog,MSG1_URL_F)){
    		        		char *msg=get_err_msg(MSG1_URL_F);
    		        		fmt_err_msg(msg);
    		    		}
    		    		if(isset(glb_errlog,MSG2_URL_F)){
    		        		char *msg=get_err_msg(MSG2_URL_F);
    		        		fmt_err_msg(msg);
    		    		}
    		   			if(isset(glb_errlog,MSG3_URL_F)){
    		        		char *msg=get_err_msg(MSG3_URL_F);
    		        		fmt_err_msg(msg);
    		    		}
    				}
    				else{
						val=find_val(hd,"u_name");
						if(val&&val[0]){
							ccode=AddSite(val,poe_account_index);
						}
					}
					break;
				case URL_DEL:
					num=0;
					n=find_val_multi(hd,"url_list",&vals);
					while(num<n){
						ccode=DelSite(vals[num],poe_account_index);
						num++;
					}
					break;
				case URL_DELALL:
					ccode=DelAllSite(poe_account_index);
					break;
			}
			if(!ErrlogIsSetted()){
			    WriteConfToFlash();
			    restart_urlgw();
			}			
		}
		list_clear(hd);
	}
	//ada
	else{
		val=find_val(hd,"acc_index");
		if(val)
			poe_account_index=atoi(val);  
	}//ada
		
	return html_parser("i_urlf.htm",key_fun_tab);
}
#endif /* _I_URLF_CGI_C_ */

