#ifndef _INTERNET_CGI_C_
#define _INTERNET_CGI_C_

#include "internet.h"

#include "lan.h"
#include "wan.h"
#include "system.h"

static internet_conf conf;

static MULTI_PPPOE_CONF mpoe_conf;
static int poe_account_index;
static int wan_type;
static enum{
	CHANGE_ACCOUNT,
	SAVE
}which_submit;

static int r2t_r_dest_pclist(char buf[CGI_BUF_LEN],char **buf1)
{
	int i,id;
	char id_s[5];

	*buf='\0';
	for(i=0;i<APP_NUM;i++){
		id=GetIndexByNameInWholePC(conf.pc_name[i]);
		sprintf(id_s,"%d,",id+1);
		strcat(buf,id_s);
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,

	return 0;
}


static int r2t_sap_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;

	*buf='\0';
	*buf1=(char *)malloc((APP_NAME_LEN+20)*APP_NUM);

	memset(*buf1,0,(APP_NAME_LEN+20)*APP_NUM);
	for(i=0;i<APP_NUM;i++){
		strcat(*buf1,option_s);
		strcat(*buf1,conf.app_name[i]);
		strcat(*buf1,option_e);
	}

	return 0;
}

static int r2t_sap_pc_list(char buf[CGI_BUF_LEN],char **buf1)
{

	unsigned char i;
	char *none="PCIĂ";
	short len=0;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;



	*buf1=(char *)malloc(255*(WK_NAME_LEN+2+16+/*sizeof(option_s)+sizeof(option_e)*/20));

	if(!buf1){
	    return 0; /* Fail to allocate memory. */
	}

	memset( *buf1,0,255*(WK_NAME_LEN+2+16+/*sizeof(option_s)+sizeof(option_e)*/20) );

	/* Fix IP entries */
	len += sprintf(*buf1+len, "%s%s%s", option_s,none,option_e);

    for (i=0, p_entry=p_pcdb_conf->p_database; i<p_pcdb_conf->number && p_entry; i++){
        len += sprintf(*buf1+len, "%s", option_s);

        len += sprintf(*buf1+len, "%s", p_entry->name);
        len += sprintf(*buf1+len, " (%u.%u.%u.%u) ", p_entry->ip_addr[0], p_entry->ip_addr[1], p_entry->ip_addr[2], p_entry->ip_addr[3]);

        len += sprintf(*buf1+len, "%s", option_e);
        p_entry = p_entry->next;
    }

	/* Dynamic IP entries */

    GetDynamicPCInfo(*buf1+len, 2, NULL);
    return 0;
}


static int r2t_dmz(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';

	if( conf.pc_dmz.s_addr )
		strcpy(buf,str_checked);

	return 0;
}

static int r2t_pc_list(char buf[CGI_BUF_LEN],char **buf1)
{
	unsigned char i;
	char *none="PCIĂ";
	short len=0;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;



	*buf1=(char *)malloc(255*(WK_NAME_LEN+2+16+/*sizeof(option_s)+sizeof(option_e)*/20));

	if(!buf1){
	    return 0; /* Fail to allocate memory. */
	}

	memset( *buf1,0,255*(WK_NAME_LEN+2+16+/*sizeof(option_s)+sizeof(option_e)*/20) );

	/* Fix IP entries */
	len += sprintf(*buf1+len, "%s%s%s", option_s,none,option_e);

    for (i=0, p_entry=p_pcdb_conf->p_database; i<p_pcdb_conf->number && p_entry; i++){
        if(!conf.pc_dmz.s_addr || memcmp(p_entry->ip_addr,(unsigned char *)&conf.pc_dmz.s_addr, 4) ){
            len += sprintf(*buf1+len, "%s", option_s);
        }
        else{
            len += sprintf(*buf1+len, "%s", option_sl);
        }

        len += sprintf(*buf1+len, "%s", p_entry->name);
        len += sprintf(*buf1+len, " (%u.%u.%u.%u) ", p_entry->ip_addr[0], p_entry->ip_addr[1], p_entry->ip_addr[2], p_entry->ip_addr[3]);

        len += sprintf(*buf1+len, "%s", option_e);
        p_entry = p_entry->next;
    }

	/* Dynamic IP entries */

    GetDynamicPCInfo(*buf1+len, 2, GetNameByIPInWholePC((unsigned char *)&conf.pc_dmz.s_addr) );
    return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_sap_dest(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	if(poe_account_index!=-1)
	strcpy(buf,mpoe_conf.account[poe_account_index].poe_ac_name);	
	return 0;
}

static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	if(wan_type == CONNECTION_MULTI_PPPOE){
        strcpy(buf,str_poe_ac_list_head);
        for(i=0;i<MAX_PPPOE_ACCOUNT;i++){
            if(i == poe_account_index){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            strcat(buf,mpoe_conf.account[i].poe_ac_name);
            strcat(buf,option_e);
        }
        strcat(buf,str_poe_ac_list_tail);
    }	
	return 0;
}

//=============================SAVE FUNCTIONS=================================



static int t2r_sap_list(const char *value)
{
	return 0;
}

static int t2r_sap_pc_list(const char *value)
{
	return 0;
}

static int t2r_udsp(const char *value)
{
	return 0;
}

static char dmz=0;

static int t2r_dmz(const char *value)
{
	dmz=1;
	return 0;
}

static int t2r_pc_list(const char *value){
	if(dmz==0){
		conf.pc_dmz.s_addr = 0;
	}
	else{
	    char name[50],pc_ip[16];
	    if( sscanf(value,"%s (%[^)])",name,pc_ip) != 2){
	        strcpy(pc_ip,"0.0.0.0");
	    }
	    inet_aton(pc_ip,&conf.pc_dmz);
	}
	return 0;
}



static int t2r_save(const char *value)
{
	which_submit=SAVE;
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

static int t2r_poe_ac_value(const char *value)
{
	int i;
	if(*value&&(poe_account_index!=-1)){
	    for(i=0;*value&&i<MAX_PPPOE_ACCOUNT;i++){
	        if(!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
	            poe_account_index = i;  
	            break;
	        }
	    }	
    } 
	return 0;
}

static int t2r_sap_dest(const char *value)
{
	int i=0;
	char *p,*q,*r,*name;
	q=strdup(value);
	r=q;
	while(*q!='\0'){
		p=strchr(q,',');
		if(p){
			*p=0;
		}
		name = PCDBGetNameByIndex((unsigned char)(atoi(q)-1));
		strcpy(conf.pc_name[i],name?name:" ");
		i++;
		q=p+1;
	}

	free(r);
	return 0;
}


int internet_main(void)
{

	LIST *hd=NULL;
	int ccode;
	
	which_submit = CHANGE_ACCOUNT;  		
	memset(&mpoe_conf, 0, sizeof(MULTI_PPPOE_CONF));	
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){
		poe_account_index=0;		
		ReadMultiPPPoESettings(&mpoe_conf);
	}else{
		poe_account_index=-1;		
	}
	
	memset(&conf,0,sizeof(conf));
	ReadInternet(&conf,poe_account_index);	
	
	pc_db_link_init();
	ReadPCDBConf(&pc_db_conf);
	

	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		memset(&conf.pc_dmz,0,sizeof(conf.pc_dmz));//ada
		if(!do_cgi_t2r(hd,key_fun_tab)){
			if(which_submit==SAVE){
				ccode=SaveInternet(&conf,poe_account_index);
			    WriteConfToFlash();
			}else if(which_submit==CHANGE_ACCOUNT){
				ReadInternet(&conf,poe_account_index);	
			}
		}
		list_clear(hd);
	}
	ccode=html_parser("internet.htm",key_fun_tab);
	
   	return ccode;
}

#endif
