#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_lan_mac(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_prefix(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_net_id(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_prelen(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ra_host(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ra_host_ra_off(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_lan_prefix(const char *value);
static int t2r_lan_net_id(const char *value);
static int t2r_lan_prelen(const char *value);
static int t2r_ra_host(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"lan_mac",r2t_lan_mac,NULL},
	{"lan_prefix",r2t_lan_prefix,t2r_lan_prefix},
	{"lan_net_id",r2t_lan_net_id,t2r_lan_net_id},
	{"lan_prelen",r2t_lan_prelen,t2r_lan_prelen},
	{"RA_HOST",r2t_ra_host,t2r_ra_host},
	{"RA_HOST_ra_off",r2t_ra_host_ra_off,NULL},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "ipv6_lan_cgi.c"

/*************************/
