#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_name_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ip_add_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ph_add_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_port_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_status_list(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_refresh(const char *value);
static int t2r_close(const char *value);


static keyfun_tab key_fun_tab[]={
	{"name_list",r2t_name_list,NULL},
	{"ip_add_list",r2t_ip_add_list,NULL},
	{"ph_add_list",r2t_ph_add_list,NULL},
	{"port_list",r2t_port_list,NULL},
	{"status_list",r2t_status_list,NULL},
	{"refresh",NULL,t2r_refresh},
	{"close",NULL,t2r_close},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "list_wk_cgi.c"

/*************************/
