#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t__date_(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_time_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_inout_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pk_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_act_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_reason_list(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_back(const char *value);
static int t2r_close(const char *value);


static keyfun_tab key_fun_tab[]={
	{"_date_",r2t__date_,NULL},
	{"time_list",r2t_time_list,NULL},
	{"inout_list",r2t_inout_list,NULL},
	{"pk_list",r2t_pk_list,NULL},
	{"act_list",r2t_act_list,NULL},
	{"reason_list",r2t_reason_list,NULL},
	{"back",NULL,t2r_back},
	{"close",NULL,t2r_close},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "log_fw_cgi.c"

/*************************/
