#ifndef _LOG_OUT_CGI_C_
#define _LOG_OUT_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "logging.h"
#include "parser.h"

url_list *url;
int urlnum=0;

static int r2t_date_list(char buf[CGI_BUF_LEN],char **buf1)
{
	url_list *date;
	
	if(urlnum==0)
		return 0;
	date=url;
	*buf1=malloc(urlnum*12);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,urlnum*12);
	while(date){
		strcat(*buf1,date->date);
		strcat(*buf1,str_brk);
		date=date->next;
	}
	return 0;
}

static int r2t_time_list(char buf[CGI_BUF_LEN],char **buf1)
{
	url_list *time;
	
	if(urlnum==0)
		return 0;
	time=url;
	*buf1=malloc(urlnum*12);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,urlnum*12);
	while(time){
		strcat(*buf1,time->time);
		strcat(*buf1,str_brk);
		time=time->next;
	}
	return 0;
}

static int r2t_ip_add_list(char buf[CGI_BUF_LEN],char **buf1)
{
	url_list *saddr;
	
	if(urlnum==0)
		return 0;
	saddr=url;
	*buf1=malloc(urlnum*20);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,urlnum*20);
	while(saddr){
		strcat(*buf1,saddr->saddr);
		strcat(*buf1,str_brk);
		saddr=saddr->next;
	}
	return 0;
}

static int r2t_dest_list(char buf[CGI_BUF_LEN],char **buf1)
{
	url_list *dest;
	
	if(urlnum==0)
		return 0;
	dest=url;
	*buf1=malloc(urlnum*URL_MAX_LEN);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,urlnum*URL_MAX_LEN);
	while(dest){
		strcat(*buf1,dest->host);
		strcat(*buf1,str_brk);
		dest=dest->next;
	}
	return 0;
}

static int r2t_blocked_list(char buf[CGI_BUF_LEN],char **buf1)
{
	url_list *block;
	
	if(urlnum==0)
		return 0;
	block=url;
	*buf1=malloc(urlnum*12);
	if(*buf1==NULL)
		return 0;
	memset(*buf1,0,urlnum*12);
	while(block){
		strcat(*buf1,block->block);
		strcat(*buf1,str_brk);
		block=block->next;
	}
	return 0;
}

static int t2r_back(const char *value)
{
	return 0;
}

static int t2r_close(const char *value)
{
	return 0;
}

int log_out_main(void)
{
	int ccode;
	
	ccode=GetUrlLog(&url,&urlnum);
   	ccode=html_parser("log_out.htm",key_fun_tab);
	if(url)
		FreeUrlLog(url);
		
   	return ccode;
}
#endif
