#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_poe_session_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_out_log(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ac_log(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fw_log(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_session_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_out_log(const char *value);
static int t2r_view_out_log(const char *value);
static int t2r_clear_out_log(const char *value);
static int t2r_ac_log(const char *value);
static int t2r_view_ac_log(const char *value);
static int t2r_clear_ac_log(const char *value);
static int t2r_fw_log(const char *value);
static int t2r_view_fw_log(const char *value);
static int t2r_clear_fw_log(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_session_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"poe_session_list",r2t_poe_session_list,NULL},
	{"out_log",r2t_out_log,t2r_out_log},
	{"view_out_log",NULL,t2r_view_out_log},
	{"clear_out_log",NULL,t2r_clear_out_log},
	{"ac_log",r2t_ac_log,t2r_ac_log},
	{"view_ac_log",NULL,t2r_view_ac_log},
	{"clear_ac_log",NULL,t2r_clear_ac_log},
	{"fw_log",r2t_fw_log,t2r_fw_log},
	{"view_fw_log",NULL,t2r_view_fw_log},
	{"clear_fw_log",NULL,t2r_clear_fw_log},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{"poe_session_value",r2t_poe_session_value,t2r_poe_session_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "logging_cgi.c"

/*************************/
