#ifndef _MODEM_CGI_C_
#define _MODEM_CGI_C_
#include "wan.h"
#include "system.h"
#include "lan.h"
#include "fw.h"
#include "dev_opt.h"

int r2t_poe_ac_name(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mdm_conf.mdm_modem_name);	
	return 0;
}

int r2t_user_name(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mdm_conf.mdm_user_name);	
	return 0;
}

int r2t_password(char buf[CGI_BUF_LEN],char **buf1)
{
    strcpy(buf,mdm_conf.mdm_password);
	return 0;
}

int r2t_service_name(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mdm_conf.mdm_service_name);	
	return 0;
}

int r2t_telephone(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mdm_conf.mdm_telephone);	
	return 0;
}

int r2t_at_cmd(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mdm_conf.mdm_at_cmd);	
	return 0;
}
static int r2t_connect_type(char buf[CGI_BUF_LEN],char **buf1){
    int i,select_index;
    
    select_index = mdm_conf.mdm_dialMode;
    for(i=0;i<DIAL_MODE_NUM-1;i++){
        if(i==select_index){
            strcat(buf,option_sl);
        }
        else{
            strcat(buf,option_s);
        }
        strcat(buf,conn_type_db[i]);
        strcat(buf,option_e);
    }
    return 0;
}

int r2t_idle_time(char buf[CGI_BUF_LEN],char **buf1){
    unsigned char time;
    
    switch(mdm_conf.mdm_dialMode){
    case ALWAYSON:
        time = 0;
        break;
    case DOD:
        time = mdm_conf.mdm_DOD_idleTime;
        break;
    case MANUALLY:
        time = mdm_conf.mdm_Manual_idelTime;
        break;
    default:
        time = 0;
    }
    sprintf(buf,"%u",time);
    return 0;
}

int r2t_ser_speed(char buf[CGI_BUF_LEN],char **buf1)
{
    int i;
    for(i=0;modem_speed_db[i];i++){
	if(mdm_conf.mdm_speed==atoi(modem_speed_db[i])){
	    strcat(buf,option_sl);
	}
	else{
	    strcat(buf,option_s);
	}
	strcat(buf,modem_speed_db[i]);
	strcat(buf,option_e);
    }
    return 0;
}

int r2t_pppd_retry_sw(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mdm_conf.mdm_pppd_retry_enable)
		strcpy(buf,str_checked);
	return 0;
}

int r2t_pppd_retry_sw_disable(char buf[CGI_BUF_LEN],char **buf1)
{
	if(!mdm_conf.mdm_pppd_retry_enable)
		strcpy(buf,str_checked);
	return 0;
}

int r2t_dns_type(char buf[CGI_BUF_LEN],char **buf1)
{
	if(!mdm_conf.mdm_dns_enable)
		strcpy(buf,str_checked);
	return 0;
}

int r2t_dns_type_fixed(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mdm_conf.mdm_dns_enable)
		strcpy(buf,str_checked);
	return 0;
}

int r2t_dns1_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&mdm_conf.mdm_dns1)));		
	return 0;
}

int r2t_dns1_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&mdm_conf.mdm_dns1)+1));		
	return 0;
}

int r2t_dns1_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&mdm_conf.mdm_dns1)+2));		
	return 0;
}

int r2t_dns1_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*((unsigned char *)(&mdm_conf.mdm_dns1)+3));		
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int t2r_poe_ac_name(const char *value)
{
	strcpy(mdm_conf.mdm_modem_name,value);	
	return 0;
}

int t2r_user_name(const char *value)
{
	strcpy(mdm_conf.mdm_user_name,value);	
	return 0;
}

int t2r_password(const char *value)
{
	strcpy(mdm_conf.mdm_password,value);	
	return 0;
}

int t2r_service_name(const char *value)
{
	strcpy(mdm_conf.mdm_service_name,value);	
	return 0;
}

int t2r_telephone(const char *value)
{
	strcpy(mdm_conf.mdm_telephone,value);	
	return 0;
}

int t2r_at_cmd(const char *value)
{
	strcpy(mdm_conf.mdm_at_cmd,value);	
	return 0;
}

static int t2r_connect_type(const char *value){
    mdm_conf.mdm_dialMode = str_db_search(conn_type_db,value);
    return 0;
}

int t2r_idle_time(const char *value){
    int time = atoi(value);
    
    if(time< PPPOE_IDLE_MIN || time > PPPOE_IDLE_MAX){
        time = PPPOE_IDLE_DEFAULT;
    }    
    switch(mdm_conf.mdm_dialMode){
    case ALWAYSON:
        break;
    case DOD:
        mdm_conf.mdm_DOD_idleTime = time;
        break;
    case MANUALLY:
        mdm_conf.mdm_Manual_idelTime = time;
        break;
    default:
        mdm_conf.mdm_DOD_idleTime = mdm_conf.mdm_Manual_idelTime = PPPOE_IDLE_DEFAULT;
        break;
    }
    return 0;
}

int t2r_ser_speed(const char *value)
{
        mdm_conf.mdm_speed=atoi(value);
	return 0;
}

int t2r_pppd_retry_sw(const char *value)
{
	if(strcmp(value,"Enable")==0)
		mdm_conf.mdm_pppd_retry_enable=1;
	else
		mdm_conf.mdm_pppd_retry_enable=0;	
	return 0;
}

int t2r_dns_type(const char *value)
{
	if(strcmp(value,"auto")==0)
		mdm_conf.mdm_dns_enable=0; /* Enable means enable peer dns. */
	else	
		mdm_conf.mdm_dns_enable=1;
	return 0;
}

int t2r_dns1_ip_1(const char *value)
{
	*((unsigned char *)(&mdm_conf.mdm_dns1))=(unsigned char)atoi(value);
	return 0;
}

int t2r_dns1_ip_2(const char *value)
{
	*((unsigned char *)(&mdm_conf.mdm_dns1)+1)=(unsigned char)atoi(value);
	return 0;
}

int t2r_dns1_ip_3(const char *value)
{
	*((unsigned char *)(&mdm_conf.mdm_dns1)+2)=(unsigned char)atoi(value);
	return 0;
}

int t2r_dns1_ip_4(const char *value)
{
	*((unsigned char *)(&mdm_conf.mdm_dns1)+3)=(unsigned char)atoi(value);
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int t2r_back(const char *value)
{
	return 0;
}

int t2r_save(const char *value)
{
	return 0;
}
int t2r_help(const char *value)
{
	return 0;
}

int modem_main()
{
	LIST *hd=NULL;
	int needRestartLAN=0;
	char prev_connType;
	int WanIfaceChange;
	
	ReadModemSettings(&mdm_conf);
	ReadSystemSettings(&system_conf);
	
	prev_connType = system_conf.Connection;
	
	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
		    system("/sbin/wan stop >/dev/null 2>&1");
			SaveModemSettings(&mdm_conf);
			
            if(CONNECTION_SINGLE_PPPOE == system_conf.Connection){
                SINGLE_PPPOE_CONF *pPPPoEConf=&single_pppoe_conf;
                ReadSinglePPPoESettings(pPPPoEConf);
                
                if(pPPPoEConf->ipType == TYPE_UNNUMBERED){
                    LAN_CONF *pLanConf=&lan_conf;
                    
                    ReadLanSettings(pLanConf);
                    RestoreLANSettings(pLanConf);
                    SaveLanSettings(pLanConf);
                    needRestartLAN = 1;
                }
            }

            if(CONNECTION_DHCP == system_conf.Connection){
                WanIfaceChange = 1;
            }
            else{
                WanIfaceChange = 0;
            }
            /* Set System WAN connection type to be Modem. */
            system_conf.Connection = CONNECTION_MODEM;
            SaveSystemSettings(&system_conf);
            WriteConfToFlash();
            ReadDevConf(&dev_opt_conf);
            if(dev_opt_conf.upnp_en && CONNECTION_DHCP == prev_connType){
                system("/etc/rc.d/rc.upnp >/dev/null 2>&1");
            }

//            WriteScript();
//            StartFW();
            if(WanIfaceChange){
                WriteScript();
                FWRestart();
            }

            if(needRestartLAN){
                system("/sbin/lan start >/dev/null 2>&1");
            }
            system("/sbin/wan start >/dev/null 2>&1");
		}else
			ReadModemSettings(&mdm_conf);
	}
	return html_parser("modem.htm",key_fun_tab);
}
#endif /* _MODEM_CGI_C_ */
