#include "wan.h"
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <math.h>

static TRF_PORT_CONF_s conf;
static TRF_PORT_CONF trf_port_conf,*pConf;
static int poe_account_index;
static int set=0;

static enum{
	TRF_PORT_ADD,
	TRF_PORT_DEL_ALL,
	TRF_PORT_DEL,
	TRF_PORT_SAVE
}which_submit;

int r2t_port(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_port_e(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_port_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	char tmp[20];
	for(i=0; i<MAX_TRF_PORT; i++){	
		if(!pConf->trf_port[i].port_s)
			continue;
		if(isset(&pConf->trf_port_set, i))
			strcat(buf, option_sl);
		else
			strcat(buf, option_s);
		if(pConf->trf_port[i].port_s!=pConf->trf_port[i].port_e)
			sprintf(tmp,"%d-%d",pConf->trf_port[i].port_s,pConf->trf_port[i].port_e);
		else
			sprintf(tmp,"%d",pConf->trf_port[i].port_s);
		strcat(buf,tmp);
		strcat(buf,option_e);				
	}	
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
	return 0;
}

int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",poe_account_index);
	return 0;
}

int r2t_poe_list_set(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int t2r_port(const char *value)
{
	conf.port_s=atoi(value);
	return 0;
}

int t2r_port_e(const char *value)
{
	conf.port_e=atoi(value);
	return 0;
}

int t2r_add(const char *value)
{
	which_submit=TRF_PORT_ADD;
	return 0;
}

int t2r_port_list(const char *value)
{
	return 0;
}

int t2r_sel_all(const char *value)
{
	return 0;
}

int t2r_sel_none(const char *value)
{
	return 0;
}

int t2r_del(const char *value)
{
	which_submit=TRF_PORT_DEL;
	return 0;
}

int t2r_del_all(const char *value)
{
	which_submit=TRF_PORT_DEL_ALL;
	return 0;
}

int t2r_save(const char *value)
{
	which_submit=TRF_PORT_SAVE;
	return 0;
}

int t2r_help(const char *value)
{
	return 0;
}

int t2r_close(const char *value)
{
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int t2r_poe_ac_value(const char *value)
{
	poe_account_index=atoi(value);  
	return 0;
}

int t2r_poe_list_set(const char *value)
{
	set=atoi(value);
	return 0;
}
int port_def_main()
{
	LIST *hd=NULL;
	int i,j;
	char *err_msg;
	poe_account_index=0;
	memset(&conf,0,sizeof(conf));
	memset(&trf_port_conf,0,sizeof(trf_port_conf));
	hd=cgi_input_parse();	
	pConf=&trf_port_conf;	
	if(strcmp(REQUEST_METHOD,POST)==0){
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
			ReadTrfPORTSettings(pConf, poe_account_index);

			switch(which_submit){				
			case TRF_PORT_ADD:
				if(pConf->trf_port_num<MAX_TRF_PORT){	
					char conflict=0;
					for(i=0; i<MAX_TRF_PORT; i++){
				        if((conf.port_s >= pConf->trf_port[i].port_s && conf.port_s <= pConf->trf_port[i].port_e)
				         ||(conf.port_e >= pConf->trf_port[i].port_s && conf.port_e <= pConf->trf_port[i].port_e)
				         ||(pConf->trf_port[i].port_s >= conf.port_s && pConf->trf_port[i].port_s <= conf.port_e)
				         ||(pConf->trf_port[i].port_e >= conf.port_s && pConf->trf_port[i].port_e <= conf.port_e)
				        ){
							err_msg=get_err_msg(MSG2_PORT_DEF);
							fmt_err_msg(err_msg);	
							conflict=1;
							break;			        	
				        }
					}
					if(!conflict){									
						memcpy(&pConf->trf_port[pConf->trf_port_num],&conf, sizeof(conf));
						setbit(&pConf->trf_port_set, pConf->trf_port_num);
						pConf->trf_port_num++;
						SaveTrfPORTSettings(pConf, poe_account_index);
					}
				}else{
					err_msg=get_err_msg(MSG1_PORT_DEF);
					fmt_err_msg(err_msg);
					break;
				}
				break;			
			case TRF_PORT_DEL_ALL:
				for(i=0; i<MAX_TRF_PORT; i++){
					pConf->trf_port[i].port_s=0;
				}			
				pConf->trf_port_set=0;
				pConf->trf_port_num=0;	
				SaveTrfPORTSettings(pConf, poe_account_index);						
				break;
			case TRF_PORT_DEL:
				for(i=0; i<MAX_TRF_PORT; i++){
					if(!pConf->trf_port[i].port_s)
						continue;
					j=pow(2,i);
					if(set&j){
						pConf->trf_port[i].port_s=0;
						clrbit(&pConf->trf_port_set,i);
						if(pConf->trf_port_num)
							pConf->trf_port_num--;
					}
				}
				for(i=0; pConf->trf_port_num>0&&i<(MAX_TRF_PORT-1); i++){		
					if(!pConf->trf_port[i].port_s){
						for(j=i+1;j<MAX_TRF_PORT; j++){
							if(pConf->trf_port[j].port_s)
								break;
						}
						if(j==MAX_TRF_PORT)
							break;					
						memcpy(&pConf->trf_port[i],&pConf->trf_port[j],sizeof(TRF_PORT_CONF_s));
						memset(&pConf->trf_port[j],0,sizeof(TRF_PORT_CONF_s));
						if(isset(&pConf->trf_port_set,j))
							setbit(&pConf->trf_port_set,i);
						else
							clrbit(&pConf->trf_port_set,i);
						clrbit(&pConf->trf_port_set,j);
					}
				}
				memset(&pConf->trf_port[pConf->trf_port_num],0,(MAX_TRF_PORT-pConf->trf_port_num)*sizeof(TRF_PORT_CONF_s));								
				SaveTrfPORTSettings(pConf, poe_account_index);
				break;
			case TRF_PORT_SAVE:
			default:
				pConf->trf_port_set=0;
				for(i=0; i<MAX_TRF_PORT; i++){
					if(!pConf->trf_port[i].port_s)
						continue;
					j=pow(2,i);
					if(set&j){
						setbit(&pConf->trf_port_set,i);
					}
				}	
				SaveTrfPORTSettings(pConf, poe_account_index);		
				break;
			}
		}
	}else{
		char *val;
		val=find_val(hd,"acc_index");
		if(val)
			poe_account_index=atoi(val);
		ReadTrfPORTSettings(pConf, poe_account_index);	  
	}
	return html_parser("port_def.htm",key_fun_tab);
}

