#include "wan.h"
#include "system.h"
#include <stdlib.h>

static MULTI_PPPOE_CONF mpoe_conf;
static PPPOE_CONF *pConf,poe_conf;
static int account_no;
static unsigned char *p;
static enum{
	GET_AC,
	SAVE
}which_submit;

int r2t_poe_ac_names(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;	
	for(i=0; i<MAX_PPPOE_ACCOUNT; i++){
		if(i==account_no)
			strcat(buf, option_sl);
		else
			strcat(buf, option_s);
		strcat(buf,mpoe_conf.account[i].poe_ac_name);
		strcat(buf,option_e);
	}	
	
	return 0;
}

int r2t_session(char buf[CGI_BUF_LEN],char **buf1)
{

	int i;
	int session=get_session_from_account(account_no);
	for(i=0; i<MAX_PPPOE_SESSION+1; i++){
		if(i==(session+1))
			strcat(buf, option_sl);
		else
			strcat(buf, option_s);
		strcat(buf,session_db[i]);
		strcat(buf,option_e);
	}	
	return 0;
}

int r2t_poe_ac_name(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,pConf->poe_ac_name);
	return 0;
}

int r2t_user_name(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,pConf->poe_user);
	return 0;
}

int r2t_password(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,pConf->poe_pass);
	return 0;
}

int r2t_connect_type(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	for(i=0; i<DIAL_MODE_NUM-1; i++){
		if(i==pConf->conn_type)
			strcat(buf, option_sl);
		else
			strcat(buf, option_s);
		strcat(buf,conn_type_db[i]);
		strcat(buf,option_e);
	}	
	return 0;
}

int r2t_idle_time(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d", pConf->poe_idle);
	return 0;
}

int r2t_lan_type_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->poe_lan_type)
		strcpy(buf, str_checked);	
	return 0;
}

int r2t_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	p=(unsigned char *)&pConf->poe_ip;
	sprintf(buf,"%u",*p);
	return 0;
}

int r2t_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+1));
	return 0;
}

int r2t_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+2));
	return 0;
}

int r2t_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+3));
	return 0;
}

int r2t_mask_1(char buf[CGI_BUF_LEN],char **buf1)
{
	p=(unsigned char *)&pConf->poe_mask;
	sprintf(buf,"%u",*p);
	return 0;
}

int r2t_mask_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+1));
	return 0;
}

int r2t_mask_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+2));
	return 0;
}

int r2t_mask_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+3));
	return 0;
}

int r2t_udp_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->poe_udp)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_udp_packet_len(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf, "%d", pConf->poe_udp_len);
	return 0;
}

int r2t_dns_type(char buf[CGI_BUF_LEN],char **buf1)
{
	if(!pConf->poe_dns_type)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_dns_type_fixed(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->poe_dns_type)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_dns1_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	p=(unsigned char *)&pConf->poe_dns_1;
	sprintf(buf,"%u",*p);
	return 0;
}

int r2t_dns1_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+1));
	return 0;
}

int r2t_dns1_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+2));
	return 0;
}

int r2t_dns1_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+3));
	return 0;
}

int r2t_dns2_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	p=(unsigned char *)&pConf->poe_dns_2;
	sprintf(buf,"%u",*p);
	return 0;
}

int r2t_dns2_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+1));
	return 0;
}

int r2t_dns2_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+2));
	return 0;
}

int r2t_dns2_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%u",*(p+3));
	return 0;
}

int r2t_traffic_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->poe_traffic)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_netbios_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	if(pConf->poe_netbios)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_primary_ac(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_secondary_ac(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
	return 0;
}

int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int t2r_poe_ac_names(const char *value)
{
	int i;
    for(i=0;i<MAX_PPPOE_ACCOUNT;i++){
        if(!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
            account_no = i;
            break;
        }
    }
	return 0;
}

int t2r_session(const char *value)
{
	int i,session_no;	
	session_no=str_db_search(session_db,value);
	for(i=0; i<MAX_PPPOE_SESSION; i++){
		if(mpoe_conf.session[i]==account_no){
			mpoe_conf.session[i]=-1;
		}
	}
	if(session_no>0&&session_no<(MAX_PPPOE_SESSION+1)){
		mpoe_conf.session[session_no-1]=account_no;
	}
	return 0;
}

int t2r_poe_ac_name(const char *value)
{
	int i;
	for(i=0; i<MAX_PPPOE_ACCOUNT; i++){
		if(i!=account_no&&!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
			setbit(glb_errlog,MSG1_PPPOE_M);
			return 1;
		}
	}
	strcpy(pConf->poe_ac_name, value);
	return 0;
}

int t2r_user_name(const char *value)
{
	strcpy(pConf->poe_user, value);
	return 0;
}

int t2r_password(const char *value)
{
	strcpy(pConf->poe_pass, value);
	return 0;
}

int t2r_connect_type(const char *value)
{
	pConf->conn_type=str_db_search(conn_type_db,value);
	return 0;
}

int t2r_idle_time(const char *value)
{
	pConf->poe_idle=(unsigned int)atoi(value);
	return 0;
}

int t2r_lan_type_enable(const char *value)
{
	pConf->poe_lan_type=1;
	return 0;
}

int t2r_ip_1(const char *value)
{
	p=(unsigned char *)&pConf->poe_ip;
	*p=atoi(value);
	return 0;
}

int t2r_ip_2(const char *value)
{
	*(p+1)=atoi(value);
	return 0;
}

int t2r_ip_3(const char *value)
{
	*(p+2)=atoi(value);
	return 0;
}

int t2r_ip_4(const char *value)
{
	*(p+3)=atoi(value);
	return 0;
}

int t2r_mask_1(const char *value)
{
	p=(unsigned char *)&pConf->poe_mask;
	*p=atoi(value);
	return 0;
}

int t2r_mask_2(const char *value)
{
	*(p+1)=atoi(value);
	return 0;
}

int t2r_mask_3(const char *value)
{
	*(p+2)=atoi(value);
	return 0;
}

int t2r_mask_4(const char *value)
{
	*(p+3)=atoi(value);
	return 0;
}

int t2r_udp_enable(const char *value)
{
	pConf->poe_udp=1;
	return 0;
}

int t2r_udp_packet_len(const char *value)
{
	pConf->poe_udp_len=(unsigned int)atoi(value);
	return 0;
}

int t2r_dns_type(const char *value)
{
	if(!strcmp(value, "auto"))
		pConf->poe_dns_type=0;
	else
		pConf->poe_dns_type=1;
	return 0;
}

int t2r_dns1_ip_1(const char *value)
{
	p=(unsigned char *)&pConf->poe_dns_1;
	*p=atoi(value);
	return 0;
}

int t2r_dns1_ip_2(const char *value)
{
	*(p+1)=atoi(value);
	return 0;
}

int t2r_dns1_ip_3(const char *value)
{
	*(p+2)=atoi(value);
	return 0;
}

int t2r_dns1_ip_4(const char *value)
{
	*(p+3)=atoi(value);	
	return 0;
}

int t2r_dns2_ip_1(const char *value)
{
	p=(unsigned char *)&pConf->poe_dns_2;
	*p=atoi(value);
	return 0;
}

int t2r_dns2_ip_2(const char *value)
{
	*(p+1)=atoi(value);
	return 0;
}

int t2r_dns2_ip_3(const char *value)
{
	*(p+2)=atoi(value);
	return 0;
}

int t2r_dns2_ip_4(const char *value)
{
	*(p+3)=atoi(value);
	return 0;
}

int t2r_traffic_enable(const char *value)
{
	pConf->poe_traffic=1;
	return 0;
}

int t2r_netbios_enable(const char *value)
{
	pConf->poe_netbios=1;
	return 0;
}

int t2r_add_ip(const char *value)
{
	return 0;
}

int t2r_add_url(const char *value)
{
	return 0;
}

int t2r_add_port(const char *value)
{
	return 0;
}

int t2r_back(const char *value)
{
	return 0;
}

int t2r_save(const char *value)
{
	return 0;
}

int t2r_help(const char *value)
{
	return 0;
}

int t2r_primary_ac(const char *value)
{
	return 0;
}

int t2r_secondary_ac(const char *value)
{
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int t2r_todo(const char *value)
{
	if(!strcmp(value, "get_ac"))
		which_submit=GET_AC;
	return 0;
}

int pppoe_m_main()
{
	LIST *hd=NULL;
	char *err_msg;
	account_no=0;
	which_submit=SAVE;
	memset(glb_errlog,0,sizeof(glb_errlog));
	memset(&mpoe_conf, 0, sizeof(mpoe_conf));
	ReadMultiPPPoESettings(&mpoe_conf);	
	hd=cgi_input_parse();
	if(strcmp(REQUEST_METHOD,POST)==0){
		memset(&poe_conf, 0, sizeof(poe_conf));
		pConf=&poe_conf;
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
			if(which_submit==SAVE){
				StopWan();
				memcpy(&mpoe_conf.account[account_no], &poe_conf, sizeof(poe_conf));
				SaveMultiPPPoESettings(&mpoe_conf,account_no);
				set_wan_type(CONNECTION_MULTI_PPPOE);
				if(fork()==0){
					cgi_fork_do();
					StartWan();
					exit(0);
				}
			}
		}else{
			if(which_submit==SAVE){
				if(isset(glb_errlog,MSG1_PPPOE_M)){
					err_msg=get_err_msg(MSG1_PPPOE_M);
					fmt_err_msg(err_msg);
				}	
			}	
		}
	}else{
		char *val;
		val=find_val(hd, "acc_index");
		if(val){
			account_no=atoi(val);
			account_no=(account_no>=0&&account_no<MAX_PPPOE_ACCOUNT)?account_no:0;
		}
	}
	pConf=&mpoe_conf.account[account_no];
	return html_parser("pppoe_m.htm",key_fun_tab);
}

