#include "wan.h"
#include "system.h"

static MULTI_PPPOE_CONF mpoe_conf;
static int session[MAX_PPPOE_SESSION];

int r2t_account0(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf, mpoe_conf.account[0].poe_ac_name);
	return 0;
}

int r2t_account1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf, mpoe_conf.account[1].poe_ac_name);
	return 0;
}

int r2t_account2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf, mpoe_conf.account[2].poe_ac_name);
	return 0;
}

int r2t_account3(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf, mpoe_conf.account[3].poe_ac_name);
	return 0;
}

int r2t_account4(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf, mpoe_conf.account[4].poe_ac_name);
	return 0;
}

int r2t_poe_session1(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[0]==0)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session1_ac2(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[0]==1)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session1_ac3(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[0]==2)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session1_ac4(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[0]==3)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session1_ac5(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[0]==4)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session2(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[1]==0)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session2_ac2(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[1]==1)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session2_ac3(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[1]==2)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session2_ac4(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[1]==3)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_poe_session2_ac5(char buf[CGI_BUF_LEN],char **buf1)
{
	if(mpoe_conf.session[1]==4)
		strcpy(buf, str_checked);
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf,buf1);
	return 0;
}

int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int t2r_poe_ac_name0(const char *value)
{
	return 0;
}

int t2r_poe_ac_name1(const char *value)
{
	return 0;
}

int t2r_poe_ac_name2(const char *value)
{
	return 0;
}

int t2r_poe_ac_name3(const char *value)
{
	return 0;
}

int t2r_poe_ac_name4(const char *value)
{
	return 0;
}

int t2r_poe_session1(const char *value)
{
	session[0]=str_db_search(poe_ac_type_db,value);
	return 0;
}

int t2r_poe_session2(const char *value)
{
	session[1]=str_db_search(poe_ac_type_db,value);
	memcpy(mpoe_conf.session,session,sizeof(session));
	return 0;
}

int t2r_back(const char *value)
{
	return 0;
}

int t2r_next(const char *value)
{
	return 0;
}

int t2r_save(const char *value)
{
	return 0;
}

int t2r_help(const char *value)
{
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int t2r_todo(const char *value)
{
	return 0;
}

int pppoe_ss_main()
{
	LIST *hd=NULL;
	memset(&mpoe_conf, 0, sizeof(mpoe_conf));	
	ReadMultiPPPoESettings(&mpoe_conf);	

	if(strcmp(REQUEST_METHOD,POST)==0){
		hd=cgi_input_parse();
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
			StopWan();
			SaveMultiPPPoESettings(&mpoe_conf,0);	
			set_wan_type(CONNECTION_MULTI_PPPOE);		
			WriteConfToFlash();
			if(fork()==0){
				cgi_fork_do();
			StartWan();
				exit(0);
			}
		}
	}
	return html_parser("pppoe_ss.htm",key_fun_tab);
}

