#ifndef _SCH_DEF_CGI_C_
#define _SCH_DEF_CGI_C_
#include <time.h>
#include "sch_def.h"
#include "system.h"
#include "groups.h"
extern int mkcrontab_main(void);

static sch_def_conf	conf;
static int groupIndex;

static char hs1[3]={0};
static char ms1[3]={0};
static char hf1[3]={0};
static char mf1[3]={0};

static char hs2[3]={0};
static char ms2[3]={0};
static char hf2[3]={0};
static char mf2[3]={0};

#define EMPTY_STR	do {	\
				strcpy(hs1,"");	\
				strcpy(ms1,"");	\
				strcpy(hf1,"");	\
				strcpy(mf1,"");	\
				strcpy(hs2,"");	\
				strcpy(ms2,"");	\
				strcpy(hf2,"");	\
				strcpy(mf2,"");	\
			}while(0)




#define PARSER_CONF(i)                                                              \
	if(strlen(conf.weekday[i])==11)                                                 \
		sscanf(conf.weekday[i],SCH_HALF_FORMAT,hs1,ms1,hf1,mf1);                    \
	else if(strlen(conf.weekday[i])==23)                                            \
		sscanf(conf.weekday[i],SCH_FULL_FORMAT,hs1,ms1,hf1,mf1,hs2,ms2,hf2,mf2);

#define FILLIN_CONF(i)                                                              \
	if(strlen(hs1)==0)                                                              \
		strcpy(conf.weekday[i],"");                                                 \
	else if(strlen(hs2)==0)                                                         \
		sprintf(conf.weekday[i],SCH_HALF_FORMAT_PRT,hs1,ms1,hf1,mf1);               \
	else                                                                            \
		sprintf(conf.weekday[i],SCH_FULL_FORMAT_PRT,hs1,ms1,hf1,mf1,hs2,ms2,hf2,mf2);

static int r2t_mon_hrs_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';

	EMPTY_STR;

    PARSER_CONF(MONDAY);

	strcpy(buf,hs1);
	return 0;
}

static int r2t_mon_min_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms1);
	return 0;
}

static int r2t_mon_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf1);
	return 0;
}

static int r2t_mon_min_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf1);
	return 0;
}

static int r2t_mon_hrs_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hs2);
	return 0;
}

static int r2t_mon_min_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms2);
	return 0;
}

static int r2t_mon_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf2);
	return 0;
}

static int r2t_mon_min_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf2);
	return 0;
}

static int r2t_tue_hrs_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';

	EMPTY_STR;

	PARSER_CONF(TUESDAY);

	strcpy(buf,hs1);
	return 0;
}

static int r2t_tue_min_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms1);
	return 0;
}


static int r2t_tue_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf1);
	return 0;
}

static int r2t_tue_min_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf1);
	return 0;
}

static int r2t_tue_hrs_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hs2);
	return 0;
}

static int r2t_tue_min_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms2);
	return 0;
}

static int r2t_tue_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf2);
	return 0;
}

static int r2t_tue_min_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf2);
	return 0;
}

static int r2t_wed_hrs_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';

	EMPTY_STR;

	PARSER_CONF(WEDNESDAY);
	strcpy(buf,hs1);
	return 0;
}

static int r2t_wed_min_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms1);
	return 0;
}

static int r2t_wed_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf1);
	return 0;
}

static int r2t_wed_min_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf1);
	return 0;
}

static int r2t_wed_hrs_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hs2);
	return 0;
}

static int r2t_wed_min_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms2);
	return 0;
}

static int r2t_wed_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf2);
	return 0;
}

static int r2t_wed_min_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf2);
	return 0;
}


static int r2t_thu_hrs_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';

	EMPTY_STR;

	PARSER_CONF(THURSDAY);
	strcpy(buf,hs1);
	return 0;
}


static int r2t_thu_min_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms1);
	return 0;
}

static int r2t_thu_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf1);
	return 0;
}

static int r2t_thu_min_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf1);
	return 0;
}

static int r2t_thu_hrs_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hs2);
	return 0;
}


static int r2t_thu_min_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms2);
	return 0;
}


static int r2t_thu_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf2);
	return 0;
}


static int r2t_thu_min_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf2);
	return 0;
}

static int r2t_fri_hrs_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';

	EMPTY_STR;

	PARSER_CONF(FRIDAY);
	strcpy(buf,hs1);
	return 0;
}

static int r2t_fri_min_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms1);
	return 0;
}


static int r2t_fri_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf1);
	return 0;
}


static int r2t_fri_min_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf1);
	return 0;
}


static int r2t_fri_hrs_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hs2);
	return 0;
}

static int r2t_fri_min_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms2);
	return 0;
}

static int r2t_fri_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf2);
	return 0;
}

static int r2t_fri_min_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf2);
	return 0;
}


static int r2t_sat_hrs_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';

	EMPTY_STR;

	PARSER_CONF(SATURDAY);

	strcpy(buf,hs1);
	return 0;
}

static int r2t_sat_min_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms1);
	return 0;
}

static int r2t_sat_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf1);
	return 0;
}

static int r2t_sat_min_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf1);
	return 0;
}

static int r2t_sat_hrs_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hs2);
	return 0;
}

static int r2t_sat_min_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms2);
	return 0;
}

static int r2t_sat_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf2);
	return 0;
}

static int r2t_sat_min_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf2);
	return 0;
}


static int r2t_sun_hrs_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';

	EMPTY_STR;

	PARSER_CONF(SUNDAY);

	strcpy(buf,hs1);
	return 0;
}


static int r2t_sun_min_start1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms1);
	return 0;
}

static int r2t_sun_hrs_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf1);
	return 0;
}

static int r2t_sun_min_finish1(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf1);
	return 0;
}

static int r2t_sun_hrs_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hs2);
	return 0;
}

static int r2t_sun_min_start2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,ms2);
	return 0;
}

static int r2t_sun_hrs_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,hf2);
	return 0;
}

static int r2t_sun_min_finish2(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mf2);
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

//=============================SAVE FUNCTIONS=================================

static int t2r_mon_hrs_start1(const char *value)
{
	EMPTY_STR;

	strcpy(hs1,value);
	return 0;
}

static int t2r_mon_min_start1(const char *value)
{
	strcpy(ms1,value);
	return 0;
}

static int t2r_mon_hrs_finish1(const char *value)
{
	strcpy(hf1,value);
	return 0;
}

static int t2r_mon_min_finish1(const char *value)
{
	strcpy(mf1,value);
	return 0;
}

static int t2r_mon_hrs_start2(const char *value)
{
	strcpy(hs2,value);
	return 0;
}

static int t2r_mon_min_start2(const char *value)
{
	strcpy(ms2,value);
	return 0;
}

static int t2r_mon_hrs_finish2(const char *value)
{
	strcpy(hf2,value);
	return 0;
}

static int t2r_mon_min_finish2(const char *value)
{
	strcpy(mf2,value);

	FILLIN_CONF(MONDAY);

	return 0;
}


static int t2r_tue_hrs_start1(const char *value)
{
	EMPTY_STR;

	strcpy(hs1,value);
	return 0;
}

static int t2r_tue_min_start1(const char *value)
{
	strcpy(ms1,value);
	return 0;
}

static int t2r_tue_hrs_finish1(const char *value)
{
	strcpy(hf1,value);
	return 0;
}

static int t2r_tue_min_finish1(const char *value)
{
	strcpy(mf1,value);
	return 0;
}

static int t2r_tue_hrs_start2(const char *value)
{
	strcpy(hs2,value);
	return 0;
}

static int t2r_tue_min_start2(const char *value)
{
	strcpy(ms2,value);
	return 0;
}

static int t2r_tue_hrs_finish2(const char *value)
{
	strcpy(hf2,value);
	return 0;
}

static int t2r_tue_min_finish2(const char *value)
{
	strcpy(mf2,value);

	FILLIN_CONF(TUESDAY);

	return 0;
}

static int t2r_wed_hrs_start1(const char *value)
{
	EMPTY_STR;

	strcpy(hs1,value);
	return 0;
}

static int t2r_wed_min_start1(const char *value)
{
	strcpy(ms1,value);
	return 0;
}

static int t2r_wed_hrs_finish1(const char *value)
{
	strcpy(hf1,value);
	return 0;
}

static int t2r_wed_min_finish1(const char *value)
{
	strcpy(mf1,value);
	return 0;
}

static int t2r_wed_hrs_start2(const char *value)
{
	strcpy(hs2,value);
	return 0;
}

static int t2r_wed_min_start2(const char *value)
{
	strcpy(ms2,value);
	return 0;
}

static int t2r_wed_hrs_finish2(const char *value)
{
	strcpy(hf2,value);
	return 0;
}

static int t2r_wed_min_finish2(const char *value)
{
	strcpy(mf2,value);

	FILLIN_CONF(WEDNESDAY);

	return 0;
}

static int t2r_thu_hrs_start1(const char *value)
{
	EMPTY_STR;

	strcpy(hs1,value);
	return 0;
}

static int t2r_thu_min_start1(const char *value)
{
	strcpy(ms1,value);
	return 0;
}

static int t2r_thu_hrs_finish1(const char *value)
{
	strcpy(hf1,value);
	return 0;
}

static int t2r_thu_min_finish1(const char *value)
{
	strcpy(mf1,value);
	return 0;
}

static int t2r_thu_hrs_start2(const char *value)
{
	strcpy(hs2,value);
	return 0;
}

static int t2r_thu_min_start2(const char *value)
{
	strcpy(ms2,value);
	return 0;
}

static int t2r_thu_hrs_finish2(const char *value)
{
	strcpy(hf2,value);
	return 0;
}

static int t2r_thu_min_finish2(const char *value)
{
	strcpy(mf2,value);

	FILLIN_CONF(THURSDAY);

	return 0;
}

static int t2r_fri_hrs_start1(const char *value)
{
	EMPTY_STR;

	strcpy(hs1,value);
	return 0;
}

static int t2r_fri_min_start1(const char *value)
{
	strcpy(ms1,value);
	return 0;
}

static int t2r_fri_hrs_finish1(const char *value)
{
	strcpy(hf1,value);
	return 0;
}

static int t2r_fri_min_finish1(const char *value)
{
	strcpy(mf1,value);
	return 0;
}

static int t2r_fri_hrs_start2(const char *value)
{
	strcpy(hs2,value);
	return 0;
}

static int t2r_fri_min_start2(const char *value)
{
	strcpy(ms2,value);
	return 0;
}

static int t2r_fri_hrs_finish2(const char *value)
{
	strcpy(hf2,value);
	return 0;
}

static int t2r_fri_min_finish2(const char *value)
{
	strcpy(mf2,value);

	FILLIN_CONF(FRIDAY);

	return 0;
}

static int t2r_sat_hrs_start1(const char *value)
{
	EMPTY_STR;

	strcpy(hs1,value);
	return 0;
}

static int t2r_sat_min_start1(const char *value)
{
	strcpy(ms1,value);
	return 0;
}

static int t2r_sat_hrs_finish1(const char *value)
{
	strcpy(hf1,value);
	return 0;
}

static int t2r_sat_min_finish1(const char *value)
{
	strcpy(mf1,value);
	return 0;
}

static int t2r_sat_hrs_start2(const char *value)
{
	strcpy(hs2,value);
	return 0;
}

static int t2r_sat_min_start2(const char *value)
{
	strcpy(ms2,value);
	return 0;
}

static int t2r_sat_hrs_finish2(const char *value)
{
	strcpy(hf2,value);
	return 0;
}

static int t2r_sat_min_finish2(const char *value)
{
	strcpy(mf2,value);

	FILLIN_CONF(SATURDAY);

	return 0;
}


static int t2r_sun_hrs_start1(const char *value)
{
	EMPTY_STR;

	strcpy(hs1,value);
	return 0;
}

static int t2r_sun_min_start1(const char *value)
{
	strcpy(ms1,value);
	return 0;
}

static int t2r_sun_hrs_finish1(const char *value)
{
	strcpy(hf1,value);
	return 0;
}

static int t2r_sun_min_finish1(const char *value)
{
	strcpy(mf1,value);
	return 0;
}

static int t2r_sun_hrs_start2(const char *value)
{
	strcpy(hs2,value);
	return 0;
}

static int t2r_sun_min_start2(const char *value)
{
	strcpy(ms2,value);
	return 0;
}

static int t2r_sun_hrs_finish2(const char *value)
{
	strcpy(hf2,value);
	return 0;
}

static int t2r_sun_min_finish2(const char *value)
{
	strcpy(mf2,value);

	FILLIN_CONF(SUNDAY);

	return 0;
}

static char todo=0;

#define SAVE	1

static int t2r_save(const char *value)
{
	todo=SAVE;
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_close(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

int sch_def_main(void)
{

	LIST *hd=NULL;
	int ccode;

	groupIndex = GetGrpIndex();

	memset(&conf,0,sizeof(conf));
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){

			if(todo==SAVE){
				ccode=SaveSchDef(&conf,groupIndex);
			    WriteConfToFlash();
                mkcrontab_main();
//            	WriteScript();
//            	StartFW();
                sch_modify(groupIndex,time(0));
			}
		}
		list_clear(hd);
	}
	else{
		ReadSchDef(&conf,groupIndex);
	}


   	ccode=html_parser("sch_def.htm",key_fun_tab);

   	return ccode;
}


#endif
