#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_threshold(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_threshold_medium(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_spi_threshold_low(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_url_filter(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_icmp(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vpn_ipsec(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_vpn_pptp(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_l2tp(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_spi_enable(const char *value);
static int t2r_spi_threshold(const char *value);
static int t2r_url_filter(const char *value);
static int t2r_urlfilter_cfg(const char *value);
static int t2r_icmp(const char *value);
static int t2r_vpn_ipsec(const char *value);
static int t2r_vpn_pptp(const char *value);
static int t2r_l2tp(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_poe_ac_value(const char *value);


static keyfun_tab key_fun_tab[]={
	{"poe_account_list",r2t_poe_account_list,NULL},
	{"spi_enable",r2t_spi_enable,t2r_spi_enable},
	{"spi_threshold",r2t_spi_threshold,t2r_spi_threshold},
	{"spi_threshold_medium",r2t_spi_threshold_medium,NULL},
	{"spi_threshold_low",r2t_spi_threshold_low,NULL},
	{"url_filter",r2t_url_filter,t2r_url_filter},
	{"urlfilter_cfg",NULL,t2r_urlfilter_cfg},
	{"icmp",r2t_icmp,t2r_icmp},
	{"vpn_ipsec",r2t_vpn_ipsec,t2r_vpn_ipsec},
	{"vpn_pptp",r2t_vpn_pptp,t2r_vpn_pptp},
	{"l2tp",r2t_l2tp,t2r_l2tp},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"poe_ac_value",r2t_poe_ac_value,t2r_poe_ac_value},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "security_cgi.c"

/*************************/
