#ifndef	_SECURITY_CGI_C_
#define	_SECURITY_CGI_C_

#include "security.h"
#include "i_urlf.h"

#include "system.h"          //ada
#include "wan.h"             //ada

static secu_conf conf;

//ada
static MULTI_PPPOE_CONF mpoe_conf;
static int poe_account_index;
static int wan_type;
static enum{
	CHANGE_ACCOUNT,
	SAVE
}which_submit;
//ada

static int r2t_spi_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.dos!=DISABLE)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_spi_threshold(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.dos==DOS_HIGH)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_spi_threshold_medium(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.dos==DOS_MEDIUM)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_spi_threshold_low(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.dos==DOS_LOW)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_url_filter(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.url)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_icmp(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.icmp)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_vpn_ipsec(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.ipsec)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_vpn_pptp(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.pptp)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_l2tp(char buf[CGI_BUF_LEN],char **buf1)
{
	
	if(conf.l2tp)
		strcpy(buf,str_checked);
		
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mpoe_conf.account[poe_account_index].poe_ac_name);       //ada
	return 0;
}

static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1)
{
	//ada
	int i;
	if(wan_type == CONNECTION_MULTI_PPPOE){
        strcpy(buf,str_poe_ac_list_head);
        for(i=0;i<MAX_PPPOE_ACCOUNT;i++){
            if(i == poe_account_index){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            strcat(buf,mpoe_conf.account[i].poe_ac_name);
            strcat(buf,option_e);
        }
        strcat(buf,str_poe_ac_list_tail);
        }//ada        	
   	return 0;
}
//=============================SAVE FUNCTIONS=================================

static char spi=0;

static int t2r_spi_enable(const char *value)
{
	if(!value)
		spi=0;
	else
		spi=1;
	
	return 0;
}

static int t2r_spi_threshold(const char *value)
{
	if(spi==0){
		conf.dos=DISABLE;
		return 0;
	}
	else{
		if(strcmp(value,"high")==0)
			conf.dos=DOS_HIGH;
		else if(strcmp(value,"medium")==0)
			conf.dos=DOS_MEDIUM;
		else if(strcmp(value,"low")==0)
			conf.dos=DOS_LOW;
		
		return 0;
	}
}

static int t2r_url_filter(const char *value)
{
	if(value)
		conf.url=ENABLE;
	else
		conf.url=DISABLE;
	
	return 0;	
}



static int t2r_urlfilter_cfg(const char *value)
{

	return 0;	
}

static int t2r_icmp(const char *value)
{
	if(value)
		conf.icmp=ENABLE;
	else
		conf.icmp=DISABLE;
	
	return 0;	
}

static int t2r_vpn_ipsec(const char *value)
{
	if(value)
		conf.ipsec=ENABLE;
	else
		conf.ipsec=DISABLE;
	
	return 0;	
}

static int t2r_vpn_pptp(const char *value)
{
	if(value)
		conf.pptp=ENABLE;
	else
		conf.pptp=DISABLE;
	
	return 0;	
}

static int t2r_l2tp(const char *value)
{
	if(value)
		conf.l2tp=ENABLE;
	else
		conf.l2tp=DISABLE;
	
	return 0;	
}



static int t2r_save(const char *value)
{
	which_submit=SAVE;        //ada
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}

static int t2r_poe_ac_value(const char *value)
{
	//ada
	int i;
	if(*value){
	    for(i=0;*value&&i<MAX_PPPOE_ACCOUNT;i++){
	        if(!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
	            poe_account_index = i;  
	            break;
	        }
	    }	
	} //ada   	
	return 0;
}

int security_main(void)
{
    
	LIST *hd=NULL;
	int ccode;
	
	memset(glb_errlog,0,sizeof(glb_errlog));  //ada
	//ada
	which_submit = CHANGE_ACCOUNT;  		
	memset(&mpoe_conf, 0, sizeof(MULTI_PPPOE_CONF));	
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){
		poe_account_index=0;		
		ReadMultiPPPoESettings(&mpoe_conf);
	}
	else
	{
		poe_account_index=-1;		
	}
	//ada		
	
	memset(&conf,0,sizeof(conf));

	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}		
		if(!do_cgi_t2r(hd,key_fun_tab)){
			if(which_submit==SAVE){
				ccode=SaveSecu(&conf,poe_account_index);
			    WriteConfToFlash();
			    restart_urlgw();
			}			
			else if(which_submit==CHANGE_ACCOUNT){
				ReadSecu(&conf,poe_account_index);
			}				
		}
		list_clear(hd);
	}
	else
		ReadSecu(&conf,poe_account_index);

   	ccode=html_parser("security.htm",key_fun_tab);
   	
   	return ccode;
}



#endif
