#include <stdio.h>
#include <string.h>
#include "h_const.h"
#define VPN_CHAIN	  "vpn_pass"
#define URLF_CHAIN        "url_filter"
#define ICMP_CHAIN        "icmp_echo" 
#define PPTP	  	  "pptp"
#define IPSEC             "ipsec"
#define L2TP        	  "l2tp"
#define URL_FILTER	  "url-filter"
#define ICMP_ECHO         "icmp-echo"


extern int iptables(char *arg);

int sh_security_main(int argc, char *argv[])
{   
	char arg[200];
	char ACTION[10],TARGET[10];
	char *NO1, *NO2, *NO3, *NO4, *NO5;
	int i;
		
	if(!strcmp(argv[1],"init")){
		strcpy(ACTION, "-A");
		i=2;
		argc--;
		sprintf(arg, "-F %s", VPN_CHAIN);
		iptables(arg);	
		sprintf(arg, "-F %s", URLF_CHAIN);
		iptables(arg);		
		sprintf(arg, "-F %s", ICMP_CHAIN);
		iptables(arg);
		NO1="";
		NO2="";
		NO3="";
		NO4="";
		NO5="";
	}else{
//		char *temp;
		strcpy(ACTION, "-R");
		i=1;
		NO1="1";
		NO2="2";
		NO3="3";
		NO4="4";
		NO5="5";	
	}
	while(argc>1){
		if(!strcmp(argv[i],"enable"))
			strcpy(TARGET, "RETURN");
		else
			strcpy(TARGET, "DROP");
		if(!strcmp(argv[i+1],PPTP)){
			sprintf(arg, "%s %s %s -p tcp --dport 1723 -j %s", ACTION, VPN_CHAIN, NO1, TARGET);
			iptables(arg);
		}else if(!strcmp(argv[i+1],L2TP)){
			sprintf(arg, "%s %s %s -p udp --sport 1701 --dport 1701 -j %s", ACTION, VPN_CHAIN, NO2, TARGET);
			iptables(arg);
		}else if(!strcmp(argv[i+1],IPSEC)){
			sprintf(arg, "%s %s %s -p udp --dport 500 -j %s", ACTION, VPN_CHAIN, NO3, TARGET);
			iptables(arg);
			sprintf(arg, "%s %s %s -p ESP -j %s", ACTION, VPN_CHAIN, NO4, TARGET);
			iptables(arg);			
			sprintf(arg, "%s %s %s -p AH -j %s", ACTION, VPN_CHAIN, NO5, TARGET);
			iptables(arg);			
		}else if(!strcmp(argv[i+1],URL_FILTER)){
			sprintf(arg, "-F %s", URLF_CHAIN);
			iptables(arg);
			if(!strcmp(argv[i],"enable")){
				sprintf(arg, "-A %s -i %s -p tcp --dport 80 ! --syn -j QUEUE", URLF_CHAIN, LAN_ITF);
				iptables(arg);
			}			
		}else if(!strcmp(argv[i+1],ICMP_ECHO)){	
			if(!strcmp(TARGET,"RETURN")){
				strcpy(TARGET,"ACCEPT");
			}		
			sprintf(arg, "%s %s %s -i ! %s -p icmp --icmp-type echo-request -j %s", ACTION, ICMP_CHAIN, NO1, LAN_ITF, TARGET);
			iptables(arg);
			//
			if(!strcmp(ACTION,"-A")){
				strcpy(ACTION,"-I");
			}		
      			sprintf(arg, "-t nat %s PREROUTING 3 -i ! %s -p icmp --icmp-type echo-request -j %s", ACTION, LAN_ITF, TARGET);
			iptables(arg);
			if(!strcmp(ACTION,"-I")){
				strcpy(ACTION,"-A");
			}			
			//						
		}else{
			printf("items must be pptp, l2tp, ipsec, url-filter, or icmp-echo!");
		}
		i=i+2;
		argc=argc-2;
	}							
	return 0;
}
