#include <stdio.h>
#include <string.h>
#include "h_const.h"

#define DEBUG	       ""
#define F_VS_CHAIN     "vs_forward" 

extern int iptables(char *arg);
int sh_vs_main(int argc, char *argv[])
{   
	char arg[200];
	char ACTION[10];
	char *start_in, *end_in, *protocol;
	int i=1;	
	
	while(argc>1){
		if(!strcmp(argv[i],"add"))
			strcpy(ACTION, "-A");
		else if(!strcmp(argv[i],"del"))
			strcpy(ACTION, "-D");
		else{		
			return 1;
		}
		if(!DEBUG){
			printf("action        is  %s", ACTION);
			printf("server IP     is  %s", argv[i+1]);
			printf("protocol      is  %s", argv[i+2]);
			printf("external port is  %s", argv[i+3]);			
			printf("internalport  is  %s", argv[i+4]);
			printf("\n");
		}
		start_in=strtok(argv[i+4],":");
        	end_in=strtok(NULL,":");
        	protocol=strtok(argv[i+2]," ");
        	while(protocol){
	        	sprintf(arg, "-t nat %s NAT_VS_DNAT_CHAIN -i ! %s -p %s --dport %s -j DNAT --to %s:%s-%s", ACTION, LAN_ITF, protocol, argv[i+3], argv[i+1], start_in, end_in);
			iptables(arg);				        	        	
	        	sprintf(arg, "%s %s -i ! %s -d %s -p %s --dport %s -j ACCEPT", ACTION, F_VS_CHAIN, LAN_ITF, argv[i+1], protocol, argv[i+4]);
			iptables(arg); 
			protocol =  strtok(NULL," ");
		}
		i=i+5;
		argc=argc-5;
	}							
	return 0;
}
