#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_dport_phadd(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dport_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dport_mask(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dport_gw(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dport_dns(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"dport_phadd",r2t_dport_phadd,NULL},
	{"dport_ip",r2t_dport_ip,NULL},
	{"dport_mask",r2t_dport_mask,NULL},
	{"dport_gw",r2t_dport_gw,NULL},
	{"dport_dns",r2t_dport_dns,NULL},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "st_fixip_cgi.c"

/*************************/
