#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_dport_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_modem_link(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_modem_log(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_modem_log(const char *value);
static int t2r_clr_log(const char *value);
static int t2r_dial(const char *value);
static int t2r_hang_up(const char *value);
static int t2r_refresh(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);
static int t2r_todo(const char *value);


static keyfun_tab key_fun_tab[]={
	{"dport_ip",r2t_dport_ip,NULL},
	{"modem_link",r2t_modem_link,NULL},
	{"MODEM_LOG",r2t_modem_log,t2r_modem_log},
	{"clr_log",NULL,t2r_clr_log},
	{"dial",NULL,t2r_dial},
	{"hang_Up",NULL,t2r_hang_up},
	{"refresh",NULL,t2r_refresh},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{"todo",r2t_todo,t2r_todo},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "st_modem_cgi.c"

/*************************/
