#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_device_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_fw_version(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_hadd_id(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_connect_method(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_mac_addr(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_mask(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wan_gw(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dhcpc_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dport_dns(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mac_addr(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_mask(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dhcp_enable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dhcp_start_ip(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_dhcp_end_ip(char buf[CGI_BUF_LEN],char **buf1);




static keyfun_tab key_fun_tab[]={
	{"device_name",r2t_device_name,NULL},
	{"fw_version",r2t_fw_version,NULL},
	{"hadd_id",r2t_hadd_id,NULL},
	{"connect_method",r2t_connect_method,NULL},
	{"wan_mac_addr",r2t_wan_mac_addr,NULL},
	{"wan_ip",r2t_wan_ip,NULL},
	{"wan_mask",r2t_wan_mask,NULL},
	{"wan_gw",r2t_wan_gw,NULL},
	{"dhcpc_enable",r2t_dhcpc_enable,NULL},
	{"dport_dns",r2t_dport_dns,NULL},
	{"lan_mac_addr",r2t_lan_mac_addr,NULL},
	{"lan_ip",r2t_lan_ip,NULL},
	{"lan_mask",r2t_lan_mask,NULL},
	{"dhcp_enable",r2t_dhcp_enable,NULL},
	{"dhcp_start_ip",r2t_dhcp_start_ip,NULL},
	{"dhcp_end_ip",r2t_dhcp_end_ip,NULL},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "sys_rpt_cgi.c"

/*************************/
