#ifndef _TITLE_CGI_C_
#define _TITLE_CGI_C_
#include "system.h"
#include "wan.h"
#include "lan.h"
#include <time.h>

static time_t now_time;
static struct tm *pltm;

int r2t_device_name(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,"VR888T");
	return 0;
}

int r2t_wan_ip(char buf[CGI_BUF_LEN],char **buf1)
{

	char if_name[10];
	if(system_conf.Connection==CONNECTION_DHCP){	
		sprintf(if_name,ETH_WAN);
	}else{
		sprintf(if_name,"ppp0");
	
	}
	
	if(GetIfaceStatus(if_name,&if_status)==0){
    
		strcpy(buf,inet_ntoa(if_status.ip));
		
        if( system_conf.Connection != CONNECTION_DHCP
          && !strcmp(inet_ntoa(if_status.ip), DOD_IP) ){
            sprintf(buf,"0.0.0.0");
        }
	}
	//ada
	else if(system_conf.Connection==CONNECTION_LOCAL_OFFICE){
			sprintf(buf,"%u.%u.%u.%u",*((unsigned char*)&(local_conf.Local_IP)),*(((unsigned char*)&(local_conf.Local_IP))+1),*(((unsigned char*)&(local_conf.Local_IP))+2),*(((unsigned char*)&(local_conf.Local_IP))+3));
        	}//ada	
	else{
		sprintf(buf,"0.0.0.0");
	}
	return 0;
}

int r2t_connection_type(char buf[CGI_BUF_LEN],char **buf1)
{
	if(system_conf.Connection==CONNECTION_DHCP){
		strcpy(buf,"Direct");
	}
	//ada
	else if(system_conf.Connection==CONNECTION_LOCAL_OFFICE){
			strcpy(buf,"̶IP");
	}//ada
	else{
		strcpy(buf,"PPPoE");
	}
	return 0;
}

int r2t_lan_ip(char buf[CGI_BUF_LEN],char **buf1)
{
	if(GetIfaceStatus(LAN_ITF,&if_status)==0){
		sprintf(buf,"%s",inet_ntoa(if_status.ip));
	}
	else{
		sprintf(buf,"0.0.0.0");
	}
	
	return 0;
}

int r2t_dhcp_status(char buf[CGI_BUF_LEN],char **buf1){
    /* This is dhcp server status. */
    
    if(lan_conf.DhcpEnable == DHCP_ENABLE){
		sprintf(buf,"Enable");
	}	
	else{
		sprintf(buf,"Disable");
	}	
	return 0;
}

int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_title_year(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",pltm->tm_year+1900);
	return 0;
}

int r2t_title_month(char buf[CGI_BUF_LEN],char **buf1)
{
        sprintf(buf,"%d",pltm->tm_mon+1);
	return 0;
}

int r2t_title_day(char buf[CGI_BUF_LEN],char **buf1)
{
        sprintf(buf,"%d",pltm->tm_mday);
	return 0;
}

int r2t_title_hour(char buf[CGI_BUF_LEN],char **buf1)
{
        sprintf(buf,"%d",pltm->tm_hour);
	return 0;
}

int r2t_title_minute(char buf[CGI_BUF_LEN],char **buf1)
{
        sprintf(buf,"%d",pltm->tm_min);
	return 0;
}

int r2t_title_second(char buf[CGI_BUF_LEN],char **buf1)
{
        sprintf(buf,"%d",pltm->tm_sec);
	return 0;
}

int t2r_todo(const char *value)
{
	return 0;
}

int t2r_title_year(const char *value)
{
	return 0;
}

int t2r_title_month(const char *value)
{
        return 0;
}


int t2r_title_day(const char *value)
{
        return 0;
}

int t2r_title_hour(const char *value)
{
        return 0;
}

int t2r_title_minute(const char *value)
{
        return 0;
}

int t2r_title_second(const char *value)
{
        return 0;
}

int title_main(void)
{
	ReadLocalSettings(&local_conf);//ada
	ReadDHCPSettings(&dhcp_conf);
	ReadSystemSettings(&system_conf);
	ReadLanSettings(&lan_conf);	
	time(&now_time);	
	pltm=localtime(&now_time);
	return html_parser("title.htm",key_fun_tab);
}
#endif /* _TITLE_CGI_C_ */

