#include "wan.h"
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <math.h>

static TRF_IP_CONF_s conf;
static TRF_IP_CONF trf_ip_conf,*pConf;
static int poe_account_index;
static unsigned char *p;
static int type;
static int set=0;

static enum{
	TRF_IP_ADD,
	TRF_IP_ADD_NET,
	TRF_IP_DEL_ALL,
	TRF_IP_DEL,
	TRF_IP_SAVE
}which_submit;

int r2t_dest_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_dest_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_dest_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_dest_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_dest_ip_end(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_net_ip_1(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_net_ip_2(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_net_ip_3(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_net_ip_4(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_net_ip_end(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_ip_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	char tmp[30];
	for(i=0; i<pConf->trf_ip_num; i++){
		if(!pConf->trf_ip[i].ip)
			continue;
		if(isset(&pConf->trf_ip_set, i))
			strcat(buf, option_sl);
		else
			strcat(buf, option_s);
		switch(pConf->trf_ip[i].type){
		case TRF_IP_TYPE_RANGE:
			sprintf(tmp,"%s-%d", inet_ntoa(*(struct in_addr *)&(pConf->trf_ip[i].ip)),pConf->trf_ip[i].ip_end);
			break;
		case TRF_IP_TYPE_MASK:
			sprintf(tmp,"%s/%d", inet_ntoa(*(struct in_addr *)&(pConf->trf_ip[i].ip)),pConf->trf_ip[i].mask);
			break;	
		case TRF_IP_TYPE_SINGLE:
		default:
			sprintf(tmp,"%s", inet_ntoa(*(struct in_addr *)&(pConf->trf_ip[i].ip)));		
			break;			
		}		
		strcat(buf,tmp);
		strcat(buf,option_e);		
	}
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",poe_account_index);
	return 0;
}

int r2t_poe_list_set(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int t2r_dest_ip_1(const char *value)
{
	p=(unsigned char *)&conf.ip;
	if(*value)
		*p=atoi(value);
	return 0;
}

int t2r_dest_ip_2(const char *value)
{
	if(*value)
		*(p+1)=atoi(value);
	return 0;
}

int t2r_dest_ip_3(const char *value)
{
	if(*value)
		*(p+2)=atoi(value);
	return 0;
}

int t2r_dest_ip_4(const char *value)
{
	if(*value)
		*(p+3)=atoi(value);
	return 0;
}

int t2r_dest_ip_end(const char *value)
{
	conf.ip_end=(unsigned int)atoi(value);
	return 0;
}

int t2r_add(const char *value)
{
	which_submit=TRF_IP_ADD;
	type=TRF_IP_TYPE_RANGE;
	return 0;
}

int t2r_net_ip_1(const char *value)
{
	p=(unsigned char *)&conf.ip;
	if(*value)
		*p=atoi(value);
	return 0;
}

int t2r_net_ip_2(const char *value)
{
	if(*value)
		*(p+1)=atoi(value);
	return 0;
}

int t2r_net_ip_3(const char *value)
{
	if(*value)
		*(p+2)=atoi(value);
	return 0;
}

int t2r_net_ip_4(const char *value)
{
	if(*value)
		*(p+3)=atoi(value);
	return 0;
}

int t2r_net_ip_end(const char *value)
{
	conf.mask=(unsigned int)atoi(value);
	return 0;
}

int t2r_add_net(const char *value)
{
	which_submit=TRF_IP_ADD_NET;
	type=TRF_IP_TYPE_MASK;
	return 0;
}

int t2r_ip_list(const char *value)
{
	return 0;
}

int t2r_sel_all(const char *value)
{
	return 0;
}

int t2r_sel_none(const char *value)
{
	return 0;
}

int t2r_del(const char *value)
{
	which_submit=TRF_IP_DEL;
	return 0;
}

int t2r_del_all(const char *value)
{
	which_submit=TRF_IP_DEL_ALL;
	return 0;
}

int t2r_save(const char *value)
{
	which_submit=TRF_IP_SAVE;
	return 0;
}

int t2r_help(const char *value)
{
	return 0;
}

int t2r_close(const char *value)
{
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int t2r_poe_ac_value(const char *value)
{
	poe_account_index=atoi(value);  
	return 0;
}

int t2r_poe_list_set(const char *value)
{
	set=atoi(value);
	return 0;
}

int trf_def_main()
{
	LIST *hd=NULL;
	int i,j;
//	char tmp[21];
	which_submit=TRF_IP_SAVE;
	poe_account_index=0;
	memset(&conf,0,sizeof(conf));
	memset(&trf_ip_conf,0,sizeof(trf_ip_conf));
	hd=cgi_input_parse();
	pConf=&trf_ip_conf;
	if(strcmp(REQUEST_METHOD,POST)==0){
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
			ReadTrfIPSettings(pConf, poe_account_index);

			switch(which_submit){				
			case TRF_IP_ADD:			
			case TRF_IP_ADD_NET:
				if(pConf->trf_ip_num<MAX_TRF_IP){
					conf.type=type;
					memcpy(&pConf->trf_ip[pConf->trf_ip_num],&conf, sizeof(conf));
					setbit(&pConf->trf_ip_set, pConf->trf_ip_num);
					pConf->trf_ip_num++;;
				}
				break;
				
			case TRF_IP_DEL_ALL:
				for(i=0; i<MAX_TRF_IP; i++){
					pConf->trf_ip[i].ip=0;
				}			
				pConf->trf_ip_set=0;
				pConf->trf_ip_num=0;
				break;		
						
			case TRF_IP_DEL:
				for(i=0; i<MAX_TRF_IP; i++){
					if(!pConf->trf_ip[i].ip)
						continue;
					j=pow(2,i);
					if(set&j){
						pConf->trf_ip[i].ip=0;
						if(pConf->trf_ip_num)
							pConf->trf_ip_num--;
					}
				}	
				for(i=0; pConf->trf_ip_num>0&&i<(MAX_TRF_IP-1); i++){		
					if(!pConf->trf_ip[i].ip){
						for(j=i+1;j<MAX_TRF_IP; j++){
							if(pConf->trf_ip[j].ip)
								break;
						}
						if(j==MAX_TRF_IP)
							break;					
						memcpy(&pConf->trf_ip[i],&pConf->trf_ip[j],sizeof(TRF_IP_CONF_s));
						memset(&pConf->trf_ip[j],0,sizeof(TRF_IP_CONF_s));
						if(isset(&pConf->trf_ip_set,j))
							setbit(&pConf->trf_ip_set,i);
						else
							clrbit(&pConf->trf_ip_set,i);
						clrbit(&pConf->trf_ip_set,j);
					}
				}
				memset(&pConf->trf_ip[pConf->trf_ip_num],0,(MAX_TRF_IP-pConf->trf_ip_num)*sizeof(TRF_IP_CONF_s));
				break;
								
			case TRF_IP_SAVE:
			default:
				pConf->trf_ip_set=0;
				for(i=0; i<MAX_TRF_IP; i++){
					if(!pConf->trf_ip[i].ip)
						continue;
					j=pow(2,i);
					if(set&j){
						setbit(&pConf->trf_ip_set,i);
					}
				}			
				break;
			}
			SaveTrfIPSettings(pConf, poe_account_index);				
		}
	}else{
		char *val;
		val=find_val(hd,"acc_index");
		if(val)
			poe_account_index=atoi(val);  
		ReadTrfIPSettings(pConf, poe_account_index);
	}
	return html_parser("trf_def.htm",key_fun_tab);
}

