#include "wan.h"
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <math.h>


static TRF_URL_CONF_s conf;
static TRF_URL_CONF trf_url_conf,*pConf;
static int poe_account_index;
static int set=0;

static enum{
	TRF_URL_ADD,
	TRF_URL_DEL_ALL,
	TRF_URL_DEL,
	TRF_URL_SAVE
}which_submit;

int r2t_url(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_url_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	for(i=0; i<MAX_TRF_URL; i++){	
		if(!pConf->trf_url[i].url[0])
			continue;
		if(isset(&pConf->trf_url_set, i))
			strcat(buf, option_sl);
		else
			strcat(buf, option_s);
		strcat(buf,pConf->trf_url[i].url);
		strcat(buf,option_e);				
	}
	return 0;
}

int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	sprintf(buf,"%d",poe_account_index);
	return 0;
}

int r2t_poe_list_set(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

int t2r_url(const char *value)
{
	strcpy(conf.url,value);
	return 0;
}

int t2r_add(const char *value)
{
	which_submit=TRF_URL_ADD;
	return 0;
}

int t2r_url_list(const char *value)
{
	return 0;
}

int t2r_sel_all(const char *value)
{
	return 0;
}

int t2r_sel_none(const char *value)
{
	return 0;
}

int t2r_del(const char *value)
{
	which_submit=TRF_URL_DEL;
	return 0;
}

int t2r_del_all(const char *value)
{
	which_submit=TRF_URL_DEL_ALL;
	return 0;
}

int t2r_save(const char *value)
{
	which_submit=TRF_URL_SAVE;
	return 0;
}

int t2r_help(const char *value)
{
	return 0;
}

int t2r_close(const char *value)
{
	return 0;
}

int t2r_message(const char *value)
{
	return 0;
}

int t2r_poe_ac_value(const char *value)
{
	poe_account_index=atoi(value);  
	return 0;
}

int t2r_poe_list_set(const char *value)
{
	set=atoi(value);
	return 0;
}

int url_def_main()
{
	LIST *hd=NULL;
	int i,j;
	poe_account_index=0;
	memset(&conf,0,sizeof(conf));
	memset(&trf_url_conf,0,sizeof(trf_url_conf));
	hd=cgi_input_parse();	
	pConf=&trf_url_conf;
	if(strcmp(REQUEST_METHOD,POST)==0){
		if(!do_cgi_t2r(hd,key_fun_tab)){
		/* success */
			ReadTrfURLSettings(pConf, poe_account_index);

			switch(which_submit){				
			case TRF_URL_ADD:
				if(pConf->trf_url_num<MAX_TRF_URL){					
					memcpy(&pConf->trf_url[pConf->trf_url_num],&conf, sizeof(conf));
					setbit(&pConf->trf_url_set, pConf->trf_url_num);
					pConf->trf_url_num++;
				}
				break;			
			case TRF_URL_DEL_ALL:
				for(i=0; i<MAX_TRF_URL; i++){
					pConf->trf_url[i].url[0]='\0';
				}			
				pConf->trf_url_set=0;
				pConf->trf_url_num=0;			
				break;
			case TRF_URL_DEL:
				for(i=0; i<MAX_TRF_URL; i++){
					if(!pConf->trf_url[i].url[0])
						continue;
					j=pow(2,i);
					if(set&j){
						pConf->trf_url[i].url[0]='\0';
						clrbit(&pConf->trf_url_set,i);
						if(pConf->trf_url_num)
							pConf->trf_url_num--;
					}
				}
				for(i=0; pConf->trf_url_num>0&&i<(MAX_TRF_URL-1); i++){		
					if(!pConf->trf_url[i].url[0]){
						for(j=i+1;j<MAX_TRF_URL; j++){
							if(pConf->trf_url[j].url[0])
								break;
						}
						if(j==MAX_TRF_URL)
							break;					
						memcpy(&pConf->trf_url[i],&pConf->trf_url[j],sizeof(TRF_URL_CONF_s));
						memset(&pConf->trf_url[j],0,sizeof(TRF_URL_CONF_s));
						if(isset(&pConf->trf_url_set,j))
							setbit(&pConf->trf_url_set,i);
						else
							clrbit(&pConf->trf_url_set,i);
						clrbit(&pConf->trf_url_set,j);
					}
				}
				memset(&pConf->trf_url[pConf->trf_url_num],0,(MAX_TRF_URL-pConf->trf_url_num)*sizeof(TRF_URL_CONF_s));								
				break;
			case TRF_URL_SAVE:
			default:
				pConf->trf_url_set=0;
				for(i=0; i<MAX_TRF_URL; i++){
					if(!pConf->trf_url[i].url[0])
						continue;
					j=pow(2,i);
					if(set&j){
						setbit(&pConf->trf_url_set,i);
					}
				}			
				break;
			}
			SaveTrfURLSettings(pConf, poe_account_index);
		}
	}else{
		char *val;
		val=find_val(hd,"acc_index");
		if(val)
			poe_account_index=atoi(val);  
		ReadTrfURLSettings(pConf, poe_account_index);
	}
	return html_parser("url_def.htm",key_fun_tab);
}

