#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_voipenable(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sip1_address(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sip2_address(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sip_protocol(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sip_port(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sip_loginname(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_sip_loginpass(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_reg_timeout(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_voipenable(const char *value);
static int t2r_sip1_address(const char *value);
static int t2r_sip2_address(const char *value);
static int t2r_sip_protocol(const char *value);
static int t2r_sip_port(const char *value);
static int t2r_sip_loginname(const char *value);
static int t2r_sip_loginpass(const char *value);
static int t2r_reg_timeout(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"voipenable",r2t_voipenable,t2r_voipenable},
	{"sip1_address",r2t_sip1_address,t2r_sip1_address},
	{"sip2_address",r2t_sip2_address,t2r_sip2_address},
	{"sip_protocol",r2t_sip_protocol,t2r_sip_protocol},
	{"sip_port",r2t_sip_port,t2r_sip_port},
	{"sip_loginname",r2t_sip_loginname,t2r_sip_loginname},
	{"sip_loginpass",r2t_sip_loginpass,t2r_sip_loginpass},
	{"reg_timeout",r2t_reg_timeout,t2r_reg_timeout},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "voip_cgi.c"

/*************************/
