#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_pb_list(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pb_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pb_id(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pb_address(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_pb_adtype(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_pb_list(const char *value);
static int t2r_delete(const char *value);
static int t2r_pb_name(const char *value);
static int t2r_pb_id(const char *value);
static int t2r_pb_address(const char *value);
static int t2r_pb_adtype(const char *value);
static int t2r_new(const char *value);
static int t2r_update(const char *value);
static int t2r_clear(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"pb_list",r2t_pb_list,t2r_pb_list},
	{"delete",NULL,t2r_delete},
	{"pb_name",r2t_pb_name,t2r_pb_name},
	{"pb_id",r2t_pb_id,t2r_pb_id},
	{"pb_address",r2t_pb_address,t2r_pb_address},
	{"pb_adtype",r2t_pb_adtype,t2r_pb_adtype},
	{"new",NULL,t2r_new},
	{"update",NULL,t2r_update},
	{"clear",NULL,t2r_clear},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "voip_pb_cgi.c"

/*************************/
