#ifndef _VOIP_PB_CGI_C_
#define _VOIP_PB_CGI_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "voip_pb.h"
#include "h_var.h"
#include "parser.h"

static voip_pb_conf conf ;
#if 0
static int r2t_a_id(char buf[CGI_BUF_LEN],char **buf1)
{
	
	strcpy(buf, conf.a_id);
	return 0;    
}
static int r2t_a_address(char buf[CGI_BUF_LEN],char **buf1)
{
	
	strcpy(buf, conf.a_address);
	return 0;    
}
static int r2t_a_type(char buf[CGI_BUF_LEN],char **buf1)
{
	
	strcpy(buf, conf.a_type);
	return 0;    
}
#endif
static int r2t_pb_list(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf, conf.pb_list);
	return 0;   
}
static int r2t_pb_name(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_pb_id(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_pb_address(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_pb_adtype(char buf[CGI_BUF_LEN],char **buf1)
{
	
	strcat(buf, "<option>URL\n") ;
	strcat(buf, "<option>SIP Server\n") ;
	return 0; 
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	set_err_msg(buf, buf1) ;
	return 0;
}


static int t2r_pb_list(const char *value)
{
	if(value!=NULL)
		strcpy(conf.pb_list, value);
	return 0;
}
static int t2r_pb_name(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		fmt_err_msg("No phone book name!!!\n") ;
		return 1 ;
	}
	else if(strlen(value) > PB_NAME_MAXLEN)
	{
		fmt_err_msg("Phone book name is too long!!!\n") ;
       		strcpy(conf.pb_name, "") ;
       		return 1 ;
	}
	else
	{
		strcpy(conf.pb_name, value) ;
		return 0 ;		
	}
}
static int t2r_pb_id(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		fmt_err_msg("No phone book id!!!\n") ;
		return 1 ;
	}
	else if(strlen(value) > PB_NAME_MAXLEN)
	{
		fmt_err_msg("Phone book id is too long!!!\n") ;
       		strcpy(conf.pb_id, "") ;
       		return 1 ;
	}
	else
	{
		strcpy(conf.pb_id, value) ;
		return 0 ;		
	}
}
static int t2r_pb_address(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		fmt_err_msg("No phone book address!!!\n") ;
		return 1 ;
	}
	else if(strlen(value) > PB_ADDRESS_MAXLEN)
	{
		fmt_err_msg("Phone book address is too long!!!\n") ;
       		strcpy(conf.pb_address, "") ;
       		return 1 ;
	}
	else
	{
		strcpy(conf.pb_address, value) ;
		return 0 ;		
	}
}
static int t2r_pb_adtype(const char *value)
{
	if(value!=NULL)
		strcpy(conf.pb_adtype, value) ;
	return 0 ;
}
static int t2r_new(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		return 0 ;
	}
	else
	{
		strcpy(conf.pb_edit, value);
		return 0 ;
	}
}
static int t2r_update(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		return 0 ;
	}
	else
	{
		strcpy(conf.pb_edit, value);
		return 0 ;
	}
}
static int t2r_delete(const char *value)
{
	if((value==NULL)||(strcmp(value, "")==0))
	{
		return 0 ;
	}
	else
	{
		strcpy(conf.pb_edit, value);
		return 0 ;
	}
}
static int t2r_clear(const char *value)
{
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_close(const char *value)
{
	return 0;
}
static int t2r_refresh(const char *value)
{
	return 0;
}
static int t2r_message(const char *value)
{
	return 0;
}


int voip_pb_main(void)
{
	LIST *hd=NULL;
	int ccode;
	
	memset(glb_errlog,0,sizeof(glb_errlog));
	
	ccode=ReadVOIPPBConf(&conf) ;
	
	if(strcmp(REQUEST_METHOD,POST) == 0)
	{
		hd=cgi_input_parse() ;
		
		if(!hd)
		{
			cgi_err("","");
		}

		if(!do_cgi_t2r(hd, key_fun_tab))
		{
			SaveVOIPPBConf(&conf) ;
			fmt_err_msg("Save config!!!") ;
		}
	}
/*	else
	{
		ccode=ReadVOIPPBConf(&conf) ;
	}*/
	
	return html_parser("voip_pb.htm", key_fun_tab);
}
#endif /* _VOIP_PB_CGI_C_*/
