#ifndef	_VS_CGI_C_
#define	_VS_CGI_C_
#include <time.h>
#include "vs.h"
#include "lan.h"
#include "wan.h"
#include "system.h"

static vs_conf	*pConf=NULL;
static vs_conf conf;
static int vs_num=0;

static MULTI_PPPOE_CONF mpoe_conf;
static int poe_account_index;
static int wan_type;
static enum{
	SET_DEFAULTS,
	DISABLE_ALL,
	VS_ADD,
	VS_DEL,
	UPDATE_VS,
	CHANGE_ACCOUNT,
	SAVE
}which_submit;

static int r2t_r_vs_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	char en_s[3];
	vs_conf *p;

	p=pConf;
	while(p){
		sprintf(en_s,"%d,",p->enable);
		strcat(buf,en_s);
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,

	return 0;
}

static int r2t_r_vs_pc_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i,id;
	char id_s[5];
	vs_conf *p;

	p=pConf;
	while(p){
	    id=GetIndexByIPInWholePC( (unsigned char *)&(p->pc_ip.s_addr) );
		sprintf(id_s,"%d,",id+1);
		strcat(buf,id_s);
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,

	return 0;
}

static int r2t_r_protocol(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	vs_conf *p;

	p=pConf;
	while(p){
		if(strcmp(p->protocol,"TCP")==0)
			strcat(buf,"0,");
		if(strcmp(p->protocol,"UDP")==0)
			strcat(buf,"1,");
		if(strcmp(p->protocol,"TCP/UDP")==0)
			strcat(buf,"2,");
		p=p->next;
	}
	i=strlen(buf);
	buf[i-1]='\0';	//Remove last ,

	return 0;
}

static int r2t_r_in_port(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	char port_s[PortLen+3];
	vs_conf *p;

	*buf1=(char *)malloc(vs_num*(PortLen+3));
	memset(*buf1,0,vs_num*(PortLen+3));
	p=pConf;
	while(p){
		sprintf(port_s,"\"%s\",",p->in_p);
		strcat(*buf1,port_s);
		p=p->next;
	}
	i=strlen(*buf1);
	(*buf1)[i-1]='\0';	//Remove last ,

	return 0;
}

static int r2t_r_ex_port(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	char port_s[PortLen+3];
	vs_conf *p;

	*buf1=(char *)malloc(vs_num*(PortLen+3));
	memset(*buf1,0,vs_num*(PortLen+3));
	p=pConf;
	while(p){
		sprintf(port_s,"\"%s\",",p->ext_p);
		strcat(*buf1,port_s);
		p=p->next;
	}
	i=strlen(*buf1);
	(*buf1)[i-1]='\0';	//Remove last ,

	return 0;
}
static int r2t_r_in_end_port(char buf[CGI_BUF_LEN],char **buf1){
	int i;
	char port_s[PortLen+3];
	vs_conf *p;

	*buf1=(char *)malloc(vs_num*(PortLen+3));
	memset(*buf1,0,vs_num*(PortLen+3));
	p=pConf;
	while(p){
		sprintf(port_s,"\"%s\",",p->in_endp);
		strcat(*buf1,port_s);
		p=p->next;
	}
	i=strlen(*buf1);
	(*buf1)[i-1]='\0';	//Remove last ,

	return 0;
}

static int r2t_r_ex_end_port(char buf[CGI_BUF_LEN],char **buf1){
    int i;
	char port_s[PortLen+3];
	vs_conf *p;

	*buf1=(char *)malloc(vs_num*(PortLen+3));
	memset(*buf1,0,vs_num*(PortLen+3));
	p=pConf;
	while(p){
		sprintf(port_s,"\"%s\",",p->ext_endp);
		strcat(*buf1,port_s);
		p=p->next;
	}
	i=strlen(*buf1);
	(*buf1)[i-1]='\0';	//Remove last ,

	return 0;
}

static int r2t_vs_list(char buf[CGI_BUF_LEN],char **buf1)
{
	vs_conf *p;

	*buf1=(char *)malloc(vs_num*(EntryNameLen+20));
	memset(*buf1,0,vs_num*(EntryNameLen+20));
	p=pConf;
	while(p){
		if(strcmp(conf.name,p->name)==0)
			strcat(*buf1,option_sl);
		else
			strcat(*buf1,option_s);
		strcat(*buf1,p->name);
		strcat(*buf1,option_e);
		p=p->next;
	}

	return 0;
}

static int r2t_vs_enable(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_vs_name(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_vs_pc_list(char buf[CGI_BUF_LEN],char **buf1)
{

	int i;
	char *none="PCIĂ";
	short len=0;
  	PC_DB_CONF *p_pcdb_conf=&pc_db_conf;
    PC_DB_CONF_s *p_entry;



	*buf1=(char *)malloc(255*(WK_NAME_LEN+2+16+/*sizeof(option_s)+sizeof(option_e)*/20));

	if(!buf1){
	    return 0; /* Fail to allocate memory. */
	}

	memset( *buf1,0,255*(WK_NAME_LEN+2+16+/*sizeof(option_s)+sizeof(option_e)*/20) );

	/* Fix IP entries */
	len += sprintf(*buf1+len, "%s%s%s", option_s,none,option_e);

    for (i=0, p_entry=p_pcdb_conf->p_database; i<p_pcdb_conf->number && p_entry; i++){
        len += sprintf(*buf1+len, "%s", option_s);

        len += sprintf(*buf1+len, "%s", p_entry->name);
        len += sprintf(*buf1+len, " (%u.%u.%u.%u) ", p_entry->ip_addr[0], p_entry->ip_addr[1], p_entry->ip_addr[2], p_entry->ip_addr[3]);

        len += sprintf(*buf1+len, "%s", option_e);
        p_entry = p_entry->next;
    }

	/* Dynamic IP entries */

    GetDynamicPCInfo(*buf1+len, 2,NULL);
    return 0;

}

static int r2t_vs_protocol(char buf[CGI_BUF_LEN],char **buf1)
{
	char *pro[3]={
		"TCP",
		"UDP",
		"TCP/UDP",
	};
	int i;

	*buf='\0';
	for(i=0;i<3;i++){
		strcat(buf,option_s);
		strcat(buf,pro[i]);
		strcat(buf,option_e);
	}

	return 0;
}

static int r2t_vs_inport(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_vs_export(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_vs_in_endport(char buf[CGI_BUF_LEN],char **buf1){
    return 0;
}

static int r2t_vs_ex_endport(char buf[CGI_BUF_LEN],char **buf1){
    return 0;
}

static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_linked_to(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}

static int r2t_num_predefined(char buf[CGI_BUF_LEN],char **buf1)
{
	*buf='\0';
	sprintf(buf,"%d",RESERVERED_NUM);
	return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1)
{
	return 0;
}


static int r2t_poe_ac_value(char buf[CGI_BUF_LEN],char **buf1)
{
	strcpy(buf,mpoe_conf.account[poe_account_index].poe_ac_name);
	return 0;
}

static int r2t_poe_account_list(char buf[CGI_BUF_LEN],char **buf1)
{
	int i;
	if(wan_type == CONNECTION_MULTI_PPPOE){
        strcpy(buf,str_poe_ac_list_head);
        for(i=0;i<MAX_PPPOE_ACCOUNT;i++){
            if(i == poe_account_index){
                strcat(buf,option_sl);
            }
            else{
                strcat(buf,option_s);
            }
            strcat(buf,mpoe_conf.account[i].poe_ac_name);
            strcat(buf,option_e);
        }
        strcat(buf,str_poe_ac_list_tail);
    }	
	return 0;
}
//=============================SAVE FUNCTIONS=================================


static char old_vs_name[EntryNameLen];

static int t2r_vs_list(const char *value){
	strcpy(old_vs_name,value);
	
	return 0;
}

static int t2r_defaults(const char *value)
{
	return 0;
}

static int t2r_disable_all(const char *value)
{
	return 0;
}

static int t2r_vs_enable(const char *value)
{
	if(value)
		conf.enable=ENABLE;
	else
		conf.enable=DISABLE;
	return 0;
}

static int t2r_vs_name(const char *value)
{
	strcpy(conf.name,value);
	return 0;
}

static int t2r_vs_pc_list(const char *value)
{
	char name[50],pc_ip[16];
	if( sscanf(value,"%s (%[^)])",name,pc_ip) != 2){
	    strcpy(pc_ip,"0.0.0.0");
	}
	inet_aton(pc_ip,&conf.pc_ip);
	return 0;
}

static int t2r_vs_protocol(const char *value)
{
	strcpy(conf.protocol,value);
	return 0;
}

static int t2r_vs_inport(const char *value)
{
	strcpy(conf.in_p,value);
	return 0;
}

static int t2r_vs_export(const char *value)
{
	strcpy(conf.ext_p,value);
	return 0;
}

static int t2r_vs_in_endport(const char *value){
	strcpy(conf.in_endp,value);
	return 0;
}

static int t2r_vs_ex_endport(const char *value){
	strcpy(conf.ext_endp,value);
	return 0;
}



static int t2r_clear(const char *value)
{
	return 0;
}

static int t2r_add(const char *value)
{
	return 0;
}

static int t2r_update(const char *value)
{
	return 0;
}

static int t2r_delete(const char *value)
{
	return 0;
}

static int t2r_help(const char *value)
{
	return 0;
}

static int t2r_todo(const char *value)
{
	if(strcmp(value,"add_vs")==0)
		which_submit=VS_ADD;
	else if(strcmp(value,"update_vs")==0)
		which_submit=UPDATE_VS;
	else if(strcmp(value,"set_defaults")==0)
		which_submit=SET_DEFAULTS;
	else if(strcmp(value,"disable_all")==0)
		which_submit=DISABLE_ALL;
	else if(strcmp(value,"del_vs")==0)
		which_submit=VS_DEL;
	return 0;
}

static int t2r_linked_to(const char *value)
{
	return 0;
}

static int t2r_num_predefined(const char *value)
{
	return 0;
}

static int t2r_message(const char *value)
{
	return 0;
}


static int t2r_poe_ac_value(const char *value)
{
	int i;
	if(*value){
	    for(i=0;*value&&i<MAX_PPPOE_ACCOUNT;i++){
	        if(!strcmp(value,mpoe_conf.account[i].poe_ac_name)){
	            poe_account_index = i;  
	            break;
	        }
	    }	
    }  
	return 0;
}

int vs_main(void)
{

	LIST *hd=NULL;
	int ccode;

	pc_db_link_init();
	ReadPCDBConf(&pc_db_conf);
	
	which_submit = CHANGE_ACCOUNT;  		
	memset(&mpoe_conf, 0, sizeof(MULTI_PPPOE_CONF));	
	if((wan_type=get_wan_type())==CONNECTION_MULTI_PPPOE){
		poe_account_index=0;		
		ReadMultiPPPoESettings(&mpoe_conf);
	}else{
		poe_account_index=-1;		
	}	
	
	if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}
		if(!do_cgi_t2r(hd,key_fun_tab)){
            debug("%s:%s():[%d]: time is %lu.",__FILE__,__FUNCTION__,__LINE__,time(0));
			if(which_submit==VS_ADD)
				ccode=AddVS(&conf,poe_account_index);
			else if(which_submit==VS_DEL)
				ccode=DelVS(old_vs_name,poe_account_index);
			else if(which_submit==UPDATE_VS)
				ccode=UpdateVS(old_vs_name,&conf,poe_account_index);
			else if(which_submit==SET_DEFAULTS)
				ccode=ResetVS(poe_account_index);
			else if(which_submit==DISABLE_ALL)
				ccode=DisableAllVS(poe_account_index);
            debug("%s:%s():[%d]: time is %lu.",__FILE__,__FUNCTION__,__LINE__,time(0));
            WriteConfToFlash();
            debug("%s:%s():[%d]: time is %lu.",__FILE__,__FUNCTION__,__LINE__,time(0));
		}
		list_clear(hd);
	}
    debug("%s:%s():[%d]: time is %lu.",__FILE__,__FUNCTION__,__LINE__,time(0));
	
	ReadVS(&pConf,&vs_num,poe_account_index);

    debug("%s:%s():[%d]: time is %lu.",__FILE__,__FUNCTION__,__LINE__,time(0));
	
   	ccode=html_parser("vs.htm",key_fun_tab);
    
    debug("%s:%s():[%d]: time is %lu.",__FILE__,__FUNCTION__,__LINE__,time(0));

   	if(pConf)
   		FreeVS(pConf);

   	return ccode;
}

#endif
