#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_br_method(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_br_method_fixed(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r1_mbps(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r2_mbps(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r55_mbps(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_r11_mbps(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_br_method(const char *value);
static int t2r_r1_mbps(const char *value);
static int t2r_r2_mbps(const char *value);
static int t2r_r55_mbps(const char *value);
static int t2r_r11_mbps(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_close(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"br_method",r2t_br_method,t2r_br_method},
	{"br_method_fixed",r2t_br_method_fixed,NULL},
	{"r1_mbps",r2t_r1_mbps,t2r_r1_mbps},
	{"r2_mbps",r2t_r2_mbps,t2r_r2_mbps},
	{"r55_mbps",r2t_r55_mbps,t2r_r55_mbps},
	{"r11_mbps",r2t_r11_mbps,t2r_r11_mbps},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"close",NULL,t2r_close},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "w_brate_cgi.c"

/*************************/
