#ifndef _W_BRATE_C_
#define _W_BRATE_C_
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "wireless.h"
#include "h_var.h"


static CHAR *method_db[3]={"auto","fixed",0};
static INT16 method=0;

static int r2t_br_method(char buf[CGI_BUF_LEN],char **buf1){
    method=0;
    if(wireless_conf.pcmcia.BasicDataRate == PCMCIA_BASIC_RATE){
        strcpy(buf,str_checked);
    }
    else{
        *buf = '\0';
    }
    return 0;
}

static int r2t_br_method_fixed(char buf[CGI_BUF_LEN],char **buf1){

    *buf = '\0';
    if(wireless_conf.pcmcia.BasicDataRate != PCMCIA_BASIC_RATE){
        strcpy(buf,str_checked);
    }
    return 0;
}

static unsigned long b_rate;
static int r2t_r1_mbps(char buf[CGI_BUF_LEN],char **buf1){

    b_rate=0;
    
    *buf = '\0';
    if(wireless_conf.pcmcia.BasicDataRate & TX_RATE_1M){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_r2_mbps(char buf[CGI_BUF_LEN],char **buf1){

    *buf = '\0';
    if(wireless_conf.pcmcia.BasicDataRate & TX_RATE_2M){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_r55_mbps(char buf[CGI_BUF_LEN],char **buf1){

    *buf = '\0';
    if(wireless_conf.pcmcia.BasicDataRate & TX_RATE_5_5M){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_r11_mbps(char buf[CGI_BUF_LEN],char **buf1){

    *buf = '\0';
    if(wireless_conf.pcmcia.BasicDataRate & TX_RATE_11M){
        strcpy(buf,str_checked);
    }
    return 0;
}

static int r2t_message(char buf[CGI_BUF_LEN],char **buf1){
    *buf = '\0';
    return 0;
}

/*==========================Save Functions================================*/

static int t2r_br_method(const char *value){
    method=str_db_search(method_db,value);
    return 0;
}

static int t2r_r1_mbps(const char *value){
    b_rate |= TX_RATE_1M;
    return 0;
}

static int t2r_r2_mbps(const char *value){
    b_rate |= TX_RATE_2M;
    return 0;
}

static int t2r_r55_mbps(const char *value){
    b_rate |= TX_RATE_5_5M;
    return 0;
}

static int t2r_r11_mbps(const char *value){
    b_rate |= TX_RATE_11M;
    return 0;
}

static int t2r_save(const char *value){
    return 0;
}

static int t2r_help(const char *value){
    return 0;
}

static int t2r_close(const char *value){
    return 0;
}

static int t2r_message(const char *value){
    return 0;
}

int w_brate_main(void){
	LIST *hd=NULL;
	WIRELESS_CONF *pConf=&wireless_conf;
	int ccode;
	
    ReadWirelessSettings(pConf);
    if (strcmp(REQUEST_METHOD,POST) == 0){
		hd=cgi_input_parse();
		if(!hd){
			cgi_err("","");
		}		
		if(!do_cgi_t2r(hd,key_fun_tab)){
		    if(!method){
    	        pConf->pcmcia.BasicDataRate=PCMCIA_BASIC_RATE;
    	    }   	    
            else{
                pConf->pcmcia.BasicDataRate=b_rate;
            }
            ccode=SaveWirelessSettings(pConf);
            WriteConfToFlash();
        }
        list_clear(hd);
    }
    return html_parser("w_brate.htm",key_fun_tab);
}

#endif /* _W_BRATE_C_ */
