#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_conn_type(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_conn_type(const char *value);
static int t2r_next(const char *value);
static int t2r_message(const char *value);


static keyfun_tab key_fun_tab[]={
	{"conn_type",r2t_conn_type,t2r_conn_type},
	{"next",NULL,t2r_next},
	{"message",r2t_message,t2r_message},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "wan_01_cgi.c"

/*************************/
