#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t__device_name_(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_ssid(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_w_channel(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_wep_status(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ac(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_lan_ac_some(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_int_ac(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_int_ac_some(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_message(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_incompatible_card(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_todo(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_ssid(const char *value);
static int t2r_w_channel(const char *value);
static int t2r_wep(const char *value);
static int t2r_baserate(const char *value);
static int t2r_lan_ac(const char *value);
static int t2r_lan_pcs(const char *value);
static int t2r_int_ac(const char *value);
static int t2r_int_pcs(const char *value);
static int t2r_save(const char *value);
static int t2r_help(const char *value);
static int t2r_message(const char *value);
static int t2r_incompatible_card(const char *value);
static int t2r_todo(const char *value);


static keyfun_tab key_fun_tab[]={
	{"_device_name_",r2t__device_name_,NULL},
	{"ssid",r2t_ssid,t2r_ssid},
	{"w_channel",r2t_w_channel,t2r_w_channel},
	{"wep_status",r2t_wep_status,NULL},
	{"wep",NULL,t2r_wep},
	{"baserate",NULL,t2r_baserate},
	{"lan_ac",r2t_lan_ac,t2r_lan_ac},
	{"lan_ac_some",r2t_lan_ac_some,NULL},
	{"lan_pcs",NULL,t2r_lan_pcs},
	{"int_ac",r2t_int_ac,t2r_int_ac},
	{"int_ac_some",r2t_int_ac_some,NULL},
	{"int_pcs",NULL,t2r_int_pcs},
	{"save",NULL,t2r_save},
	{"help",NULL,t2r_help},
	{"message",r2t_message,t2r_message},
	{"incompatible_card",r2t_incompatible_card,t2r_incompatible_card},
	{"todo",r2t_todo,t2r_todo},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "wireless_cgi.c"

/*************************/
