#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgi_def.h"
#include "cgi_err.h"
#include "cgi-lib.h"
#include "html-lib.h"
#include "parser.h"
#include "h_var.h"


static int r2t_mdm_user_name(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mdm_pass(char buf[CGI_BUF_LEN],char **buf1);
static int r2t_mdm_telephone(char buf[CGI_BUF_LEN],char **buf1);


static int t2r_mdm_user_name(const char *value);
static int t2r_mdm_pass(const char *value);
static int t2r_mdm_telephone(const char *value);
static int t2r_back(const char *value);
static int t2r_next(const char *value);
static int t2r_cancel(const char *value);


static keyfun_tab key_fun_tab[]={
	{"mdm_user_name",r2t_mdm_user_name,t2r_mdm_user_name},
	{"mdm_pass",r2t_mdm_pass,t2r_mdm_pass},
	{"mdm_telephone",r2t_mdm_telephone,t2r_mdm_telephone},
	{"back",NULL,t2r_back},
	{"next",NULL,t2r_next},
	{"cancel",NULL,t2r_cancel},
	{NULL,NULL,NULL}
};

/******CGI code here******/

#include "wiz_modem_cgi.c"

/*************************/
