#ifndef _EMAIL_H_
#define _EMAIL_H_

#define MaxEmailLen 	32

typedef struct mail_conf{
	int dos_enable;
	int out_enable;
	int in_enable;
	int mail_type;
	int day;
	int hour;
	int ampm;
	char receiver[MaxEmailLen+1];
	char subject[MaxEmailLen+1];
	/* SMTP settings */
    char smtp_type;
    char smtp_server[MaxEmailLen];
    unsigned char smtp_serverip[4];
    int smtp_port;
}mail_conf;

#define Section 	"EMAIL"
#define DOS_EN			"mail_en_dos"
#define OUT			"mail_en_out"
#define IN			"mail_en_access"
#define MAIL		"mail_type"
#define TIME		"mail_time"
#define RECV		"receiver"
#define SUBJ		"subject"
#define SMTPTYPE    "smtp_type"
#define SMTPSRV     "smtp_server"
#define SMTPIP      "smtp_serverip"
#define SMTPPORT    "smtp_port"

int ReadMailConf(mail_conf *conf);
int SaveMailConf(mail_conf *conf);
int SaveMailSchl(mail_conf *conf,char fname[32]);
#define INVALID_DOS_ENABLE 	1
#define INVALID_OUT_ENABLE 	2
#define INVALID_IN_ENABLE 	3
#define INVALID_MAIL_TYPE 	4
#define INVALID_DAY 		5
#define INVALID_HOUR 		6
#define INVALID_AMPM 		7
#define INVALID_RECEIVER 		8
#define INVALID_SUBJECT 		9

#endif
