#ifndef _SERV_H_
#define _SERV_H_

#include "fw.h"

/**********
[SERVICE]

name1=0/1,TCP/UDP:port1-port2
name2=0/1,ICMP:icmp_type
name3=0/1,GRE/IGMP/ESP:0

**********/

#define	SERV_SEC	"SERVICE"
#define	RESERVERED	1
#define	UNRESERVERED	0

#define	MAX_SERV_NUM	70

typedef struct serv_conf{
	char		name[EntryNameLen];
	int		reserver;
	char		protocol[10];
	char		port_info[20];
	struct serv_conf	*next;
}serv_conf;

int ReadSERV(serv_conf **p,int *num, int poe_acc_index);

void FreeSERV(serv_conf *p);

int AddSERV(serv_conf *p, int poe_acc_index);

int DelSERV(char **name,int num, int poe_acc_index);

#endif
