#ifndef _UD_SAP_H_
#define _UD_SAP_H_

#include "fw.h"

/*********
[UD_SAP]
1=1 name 1 1000 2000 2 3000 4000
2=
3=


6=
....
*********/

#define		MAX_UD_SAP	6

#define		UD_SAP_SEC	"UD_SAP"

#define		ENABLE		1
#define		DISABLE		0

typedef struct sap_conf{
	int	enable;
	char	name[CommonNameLen];
	int	in_protocol;
	char	in_ports[PortLen];
	char	in_porte[PortLen];
	int	ext_protocol;
	char	ext_ports[PortLen];
	char	ext_porte[PortLen];
}sap_conf;

int ReadSAP(int id,sap_conf *p);

int SaveSAP(int id,sap_conf *p);

#define SAP_CONF_FILE   "/var/sapconf"
#endif
