#include <string.h>
#include <stdlib.h>
#include <stdio.h>
//----------------------------------------------------------------
// purpose: get a string from profile file
// Note: user must call OpenProfile to get the file handle (fp1)
// return: 0 - find key
//         1 - use default value
//----------------------------------------------------------------
int GetLineFromFile(char **lbuf,FILE *fp)
{
	int	c,sz=128;
	char	*p,*buf;
	buf=(char *) malloc(sz);
	if(!buf){
	    *lbuf=NULL;
	    return 1;
	}    
	p=buf;
	while ((c=fgetc(fp)) != '\n' && c!=EOF) {
		if (p-buf ==sz-2) {
			buf=(char *) realloc(buf, sz*2);
			if(!buf){
				*lbuf=NULL;
				return 1;
			}    
			p=buf+sz-2;
			sz*=2;
		}
		*p++=c;
	}
	if(c=='\n')
	     *p++=c;
	if (c==EOF &&p==buf) {
		free(buf);
		*lbuf=NULL;
		return 1;
	}
	*p++='\0';
	*lbuf = buf;
	return 0;
}
