#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#include "PRO_DelSEC.h"

int PRO_DelSEC(char *sect,char *fn)
{
	struct stat st;
	int ret;
	char *buf,*p,*q;
	FILE *fp;
	char key1[30];
	
	ret=stat(fn,&st);
	if(ret<0)
		return -1;
	
	buf=(char *)alloca(st.st_size+1);
	if(!buf)
		return -1;
	memset(buf,0,st.st_size+1);
	fp=fopen(fn,"r");
	ret=fread(buf,1,st.st_size,fp);
	fclose(fp);
	if(ret!=st.st_size)
		return -1;
	sprintf(key1,"[%s]",sect);
	if(strncmp(buf,key1,strlen(key1))==0){
		//The first section match
		fp=fopen(fn,"w");
		p=strstr(buf,"\n[");
		if(p){
			p++;
			fwrite(p,strlen(p),1,fp);
		}
		fclose(fp);
		
		return OK;
	}
	
	sprintf(key1,"\n[%s]",sect);
	p=strstr(buf,key1);
	if(!p)
		return -1;
	p++;
	*p=0;
	
	fp=fopen(fn,"w");
	fwrite(buf,strlen(buf),1,fp);

	q=strstr(p+1,"\n[");
	if(q){
		q++;
		fwrite(q,strlen(q),1,fp);
	}
	fclose(fp);
	
	return OK;
}


