#include <string.h>
#include <stdlib.h>
#include "PRO_GetInt.h"

int PRO_GetInt(char *sect, char *key, int *val, FILE *fp)
{
   char buf[MAX_KEY_LEN];
   int ret;

   ret = PRO_GetStr(sect,key,buf,sizeof(buf),fp);
   if (ret==OK)
      *val = atoi(buf);

   return ret;
}

int PRO_GetChar(char *sect, char *key, char *val, FILE *fp)
{
   char buf[MAX_KEY_LEN];
   int ret;

   ret = PRO_GetStr(sect,key,buf,sizeof(buf),fp);
   if (ret==OK)
      *val = atol(buf);

   return ret;
}

int PRO_GetShort(char *sect, char *key, short *val, FILE *fp)
{
   char buf[MAX_KEY_LEN];
   int ret;

   ret = PRO_GetStr(sect,key,buf,sizeof(buf),fp);
   if (ret==OK)
      *val = atol(buf);

   return ret;
}

int PRO_GetLong(char *sect, char *key, long *val, FILE *fp)
{
   char buf[MAX_KEY_LEN];
   int ret;

   ret = PRO_GetStr(sect,key,buf,sizeof(buf),fp);
   if (ret==OK)
      *val = atol(buf);

   return ret;
}

