#include <string.h>
#include <stdlib.h>
#include "PRO_GetStrLen.h"

int PRO_GetStrLen(char *sect, char *key, FILE* fp)
{
   char buf[MAX_LEN];      /* a line read from ini file */
   char k[MAX_KEY_LEN];  /*  key=...  */
   int n,i,c;

   if (fp==NULL || key==NULL)
      return -1;

   if (sect) {
      if (PRO_2sect(sect,fp) != OK) // section not found
         return -1;
   } else
      rewind(fp);

   sprintf(k,"%s=",key);
   n=strlen(k);
   while(fgets(buf,n+1,fp)) //only read n bytes
   {
      if (strcmp(buf,k)==0) { //find the key
         i=0;
         c=fgetc(fp);
         while(c!='\n'&&c!=EOF)
         {
         	i++;
         	c=fgetc(fp);         
         }
         return i;
      }
      if (buf[0]=='[')
         break;  /* end of the exact section */
      if (strlen(buf)==n && buf[n-1]!='\n')
         while(fgetc(fp)!='\n');     //read the rest of this line
   } //while
   return 0;
}
