#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/file.h>
#include "PRO_SetMultiItemStr.h"

int PRO_SetMultiItemStr(char *sect,multi_items *val,int itemnum, char *fname)
{
	int len,i,fd,fd1;
	char *buf,tmpfile1[]="/var/tmp/tmpfile1.XXXXXX";
	char systmp[MAX_LEN];
	char s[MAX_SECTION_LEN];
	FILE	*fh,*fp;
	char found=0;
   
	if(!val||!fname)
		return -1;

  	fp=fopen(fname,"r+");
	if(!fp)
		return -1;
	fd=fileno(fp);
	if(lockf(fd,F_TEST,0)==-1){
		fclose(fp);
		return -1;
	}
	if(lockf(fd,F_TLOCK,0)<0){
		fclose(fp);
		return -1;
	}
	fd1=mkstemp(tmpfile1);
	if(fd1<0){
		lockf(fd,F_ULOCK,0);
		fclose(fp);
		return -1;
	}
	close(fd1);
	fh=fopen(tmpfile1,"w");
	if(!fh) {
		lockf(fd,F_ULOCK,0);
		fclose(fp);	
		return -1;
	} 
	for(i=0;i<itemnum;i++)
		(val+i)->flag=0;
		
	if(sect){//!=NULL
		if (sect[0]=='[')
			strcpy(s,sect);
		else
			sprintf(s,"[%s]",sect);
		len = strlen(s);
	   
  		while(!GetLineFromFile(&buf,fp)){ // while 1
	     	if (buf[0]!='[')	{
				fputs(buf,fh);
				free(buf);
				continue;
	     	}
			if (strncmp(buf,s,len)==0){ //find section
				found=1;
				fputs(buf,fh);
				free(buf);
	         
				while (!GetLineFromFile(&buf,fp)&&buf[0]!='[') {
					int founditem;
				   
					for(i=0,founditem=0;i<itemnum;i++) {
						len=strlen((val+i)->key);
						if((buf[len]=='='||buf[len]==' ')&&strncmp(buf,(val+i)->key,len)==0){
		              		fprintf(fh,"%s%c%s\n",(val+i)->key,buf[len],(val+i)->value);
		         			(val+i)->flag=1;
							founditem=1;
		         			break;
		         		}
		        	}
					if(!founditem)
		            	fputs(buf,fh);  
		      		free(buf);    
		  		}
		  		for(i=0;i<itemnum;i++){
		  			if ((val+i)->flag==0)
		      		fprintf(fh,"%s=%s\n",(val+i)->key,(val+i)->value);
		  		}
		  		
		  		if(buf){
		  			fputs(buf,fh);
		  			free(buf);
	      			while(!GetLineFromFile(&buf,fp)) {
						fputs(buf,fh);
                    	free(buf);
	      			}
	      		}
	      		fflush(fh);
				fclose(fh);
		    	sprintf(systmp,"/bin/cp -f %s %s >/dev/null",tmpfile1,fname);	
				lockf(fd,F_ULOCK,0);
				fclose(fp);		
				system(systmp);
		    	sync();  
		    	remove(tmpfile1); 	
		   	    return OK;   	
	     	}//end if
			else{ // not the same section
	      		fputs(buf,fh);
	      		free(buf);
	      		continue;
			}	      
		}//end while
		fflush(fh);
		fclose(fh);
		lockf(fd,F_ULOCK,0);
		fclose(fp);

		remove(tmpfile1);
		
		if(!found){
			fp=fopen(fname,"a");
			fprintf(fp,"\n%s\n",s);
			for(i=0;i<itemnum;i++)
		      		fprintf(fp,"%s=%s\n",(val+i)->key,(val+i)->value);
		      	fflush(fp);
		      	fclose(fp);
 		}
 		
		sync();		
		return OK; //not found section
  	}//end if(section)
  	else{
		while (!GetLineFromFile(&buf,fp)) {

			for(i=0,found=0;i<itemnum;i++) {
				len=strlen((val+i)->key);
         		if((buf[len]=='='||buf[len]==' ')&&strncmp(buf,(val+i)->key,len)==0){
					fprintf(fh,"%s%c%s\n",(val+i)->key,buf[len],(val+i)->value);
         			(val+i)->flag=1;
					found=1;
         			break;
				}		
			}
         	
			if(!found)
				fputs(buf,fh);
			free(buf); 
		}
	}
  	for(i=0;i<itemnum;i++) 	{
		if((val+i)->flag==0)
      		fprintf(fh,"%s=%s\n",(val+i)->key,(val+i)->value);
  	}
  	fflush(fh);
  	fclose(fh);
  	sprintf(systmp,"/bin/cp -f %s %s >/dev/null",tmpfile1,fname);	
	lockf(fd,F_ULOCK,0);
  	fclose(fp); 
  	system(systmp);
 	sync(); 
 	remove(tmpfile1);
    return OK;   		  
}
