#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include <unistd.h>
#include <sys/file.h>
#include "PRO_SetStr.h"

int PRO_SetStr(char *sect, char *key, char *val, char *fname)
{
	char buf[MAX_LEN];  /* a line read from ini file */
	char s[MAX_KEY_LEN];
	int  len,j,i,fd;
	FILE *fh,*fh1;
	char IniTmp[]="/var/tmp/tmpfile.XXXXXX";

	fh = fopen(fname,"r+");
	if (fh==NULL){  // file not exists, create one
		fh=fopen(fname,"w");
		if (fh==NULL)
			return -1;
		fclose(fh);
		fh=fopen(fname,"r");
	}
	fd=fileno(fh);
	if(lockf(fd,F_TEST,0)==-1){
		fclose(fh);
		return -1;
	}
	if(lockf(fd,F_TLOCK,0)<0){
		fclose(fh);
		return -1;
	}
	// create a temp file
	j = mkstemp(IniTmp);
	if (j == -1){
		lockf(fd,F_ULOCK,0);
		fclose(fh);	
		return -1;
	}
	close(j);
	fh1 = fopen(IniTmp,"w");
	if (fh1==NULL) {
		lockf(fd,F_ULOCK,0);
		fclose(fh);
		return -1;
	}

	if(sect==NULL){
		j = 0;
		len=strlen(key);
		while (fgets(buf,sizeof(buf),fh)) {
			if ((buf[len] == '=' || buf[len] == ' ') && (strncmp(buf,key,len)==0)){
            	j = 1;
            	fprintf(fh1,"%s=%s\n",key,val);
            	len=strlen(buf);
				if(buf[len-1]!='\n') {
                	i=fgetc(fh);
                	while(i!='\n' && i!=EOF)
                     	i=fgetc(fh);
            	}
			}
			else
				fputs(buf,fh1);
		}
		if(!j)
			goto append;
		goto exit0;
	}

	if (sect[0]=='[')
		strcpy(s,sect);
	else
		sprintf(s,"[%s]",sect);
	len = strlen(s);

	while(fgets(buf,sizeof(buf),fh)) // while 1
   {
      if (buf[0]!='[') {
         fputs(buf,fh1);
         continue;
      }
      if (strncmp(buf,s,len)==0) //find section
      {
         fputs(buf,fh1);
         len = strlen(key);
         while(fgets(buf,sizeof(buf),fh)) // while 2
         {
            if (buf[0]=='[') { //next section
               fprintf(fh1,"%s=%s\n",key,val);
               fputs(buf,fh1);
save_rest:
               while(fgets(buf,sizeof(buf),fh))
                  fputs(buf,fh1);
               fflush(fh1);
               fclose(fh1);
               lockf(fd,F_ULOCK,0);
               fclose(fh);	
               sprintf(buf,"/bin/cp -f %s %s",IniTmp,fname);
               system(buf);
               sync();
               remove(IniTmp);
               return OK;
            }
            j=0;
            while(buf[j]==' ')
               j++;
            if (strncmp(buf+j,key,len)==0) { //find key
               //find '='
               j+=len;
               while(buf[j]==' ' )
                  j++;
               if(buf[j]!='=')
                  goto not_match;
               fprintf(fh1,"%s=%s\n",key,val);
               len=strlen(buf);
               if(buf[len-1]!='\n') {
                  j=fgetc(fh);
                  while(j!='\n' && j!=EOF)
                     j=fgetc(fh);
               }
               goto save_rest;
            }
            else // section not match
not_match:
               fputs(buf,fh1);
         } //while 2
         // end of file
         goto append; //append key=val
      } //if
      else
         fputs(buf,fh1);
   } /* while */
   //section not found append the section
   if (sect[0] == '[')
      fprintf(fh1,"%s\n",sect);
   else
      fprintf(fh1,"[%s]\n",sect);
append:
   fprintf(fh1,"%s=%s\n",key,val);
exit0:

	fflush(fh1);
	fclose(fh1);
	sprintf(buf,"/bin/cp -f %s %s >/dev/null",IniTmp,fname);
	lockf(fd,F_ULOCK,0);
	fclose(fh);
	system(buf);
	sync();
	remove(IniTmp);
	return OK;
}

