#ifndef _H_CONST_H_
#define _H_CONST_H_
#include "portable.h"

enum{
    DEC,
    HEX
};

enum{
    IF_UP,
    IF_DOWN
};

enum{
    CONNECTION_UP,
    CONNECTION_DOWN
};

#define WEP_KEY_TYPE_64		5
#define WEP_KEY_TYPE_128	13

#define PCMCIA_BASIC_RATE   0xF

#define SYSCONF "/var/system.conf"
#define DEFCONF "/htdocs/system.conf"
#define _SH2C_
//#define _PC_TEST_
#define _LAN_BRIDGE_

#define BRG_LAN         "br0"
#define ETH_LAN         "eth0"

#define BRG_LAN2	"br0:1"
#define ETH_LAN2	"eth0:1"

#ifdef _LAN_BRIDGE_
#define LAN_ITF      BRG_LAN
#define LAN_ITF2	BRG_LAN2
#else
#define LAN_ITF      ETH_LAN
#define LAN_ITF2	ETH_LAN2
#endif

#define LOC_ITF		"lo"

#ifdef _PC_TEST_
#define ISL_LAN		"eth0:2"
#define ETH_WAN         "eth1"
#else
#define ISL_LAN		"eth2"
#define ETH_WAN         "eth1"
#endif /* _PC_TEST_ */
#define PPP_WAN		"ppp+"
#define PPP0_WAN	"ppp0"
#define PPP1_WAN	"ppp1"

enum{
    WIZ_AC_DIRECT,
    WIZ_AC_PPPOE,
    WIZ_AC_MODEM,
    WIZ_AC_NONE,
    WIZ_AC_NUM
};

#define setbit(a,i)   (((CHAR *)(a))[(i) / 8] |= (1 << (7 - (i) % 8)))
#define clrbit(a,i)   (((CHAR *)(a))[(i) / 8] &= (~(1 << (7 - (i) % 8))))
#define isset(a,i)    (((CHAR *)(a))[(i) / 8] & (1 << (7 - (i) % 8)))
#define isclr(a,i)    ((((CHAR *)(a))[(i) / 8] & (1 << (7 - (i) % 8))) == 0 )



#endif /* _H_CONST_H_ */

