#ifndef _H_VAR_H_
#define _H_VAR_H_

#include "h_const.h"
#include "h_msg.h"
#include <unistd.h>
//#include "wan.h"

extern char *get_err_msg(int msg_no);

extern char glb_errlog[50];
extern char option_s[];
extern char option_e[];
extern char option_sl[];
extern char str_brk[];
extern char str_checked[];
extern char str_enable[];
extern char str_disable[];
extern char str_html_space[];
extern char str_null[];
extern char str_enabled[];
extern char *conn_type_db[];
extern char *poe_type_db[];
extern char *dhcp_cl_db[];
extern char *dns_type_db[];
extern char *Connection_db[];
extern char *Connection_sys_rpt_db[];
extern char *IPDNSTypeDB[];
extern char *wan_type_db[];
extern char *if_status_db[];
extern char *Connection_status_db[];
extern char *dhcp_server_status_db[];
extern char *modem_speed_db[];
extern char *wiz_ac_method_db[];
extern char *pc_group_db[];
extern char *session_db[];
extern char str_poe_ac_list_head[];
extern char str_poe_ac_list_head_opt[];
extern char str_poe_ac_list_tail[];
extern char str_poe_ac_list_tail_opt[];
extern char *poe_ac_type_db[];

char *str_pcreserve_db(short reserve);
int char2hex(const char *str, int len, int *value);
CHAR *print_mac(BYTE *mac,CHAR sep);
char *str_pctype_db(short type);
void printf_haddr(char * buf, unsigned char * haddr, char separator);
void extract_mac(const char *str, unsigned char mac[6]);
int str_db_search(char **db, const char *str);
void extract_ip(char *ip, unsigned char dst[4]);
short check_hex(const char *str);         //ada
short check_mac(const char *str);          //ada
char get_hex(char *str);

int ErrlogIsSetted(void);
void cgi_fork_do();
int WriteConfToFlash(void);
#endif /* _H_VAR_H_ */
