#ifndef _UPGRADE_H_
#define _UPGRADE_H_

#include "portable.h"

#define	MEM_SIZE	(1024*1024)
#define	MEM_NUM		6 



//typedef unsigned long DWORD;
//typedef unsigned short WORD;
//typedef unsigned char  BYTE;
//typedef signed short INT16;
//typedef signed char  CHAR;

typedef struct  __attribute__((packed)){
	INT16 version_control;
	INT16 upgrade_control;
	BYTE  hw_id[32];
	INT16 hw_version;
	DWORD product_id;
	INT16 protocol_id;
	CHAR  function_id[6];
	INT16 fw_version;
	INT16 start_code_seg;////????
	INT16 code_size;////????
	CHAR  signature[7];
	INT16 control_no;
	INT16 download_flag;	
} PID_S;

#define PID_OFFSET 0x3FFC1
#define PID_SIGNATURE "aDmBlK="
#define PID_DOWNLOAD_FLAG 0x7700
#define PID_STRUCT_LEN (sizeof(PID_S))
#define PID_LEN (PID_STRUCT_LEN-2-2-7) //flash PID has no signature,control_no,download_flag

int check_updata(const char **data,int uptype);

int CheckPID(const PID_S *pImgPID , const PID_S *pMtdPID);
enum{
    CHECK_SUCCESS,
    CHECK_SIG_FAIL,
    CHECK_VER_FAIL,
    CHECK_HW_FAIL,
    CHECK_PRODUCT_FAIL,
    CHECK_FUNC_FAIL,
    CHECK_PROTO_FAIL,
    CHECK_ERROR
};

#define BIT_PCBA        0x0100
#define BIT_PROD_ID     0x0200
#define BIT_PROT_ID     0x0400
#define BIT_FUNC_ID     0x0800
 
enum{
	TFTP_UPGRADE,
	THTTP_UPGRADE
};

#endif //_UPGRADE_H_
