#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <crypt.h>

#include "nvram.h"
#include "default_cfg.h"
#include "rc.h"


#if 0

#include <stdarg.h>
void mBUG(char *format,...){
 va_list args;
    FILE *fp;

    fp = fopen("/var/cgitest","a+");
    if(!fp){
        return;
    }
    va_start(args,format);
    vfprintf(fp,format,args);
    va_end(args);
    fprintf(fp,"\n");
    fflush(fp);
    fclose(fp);
    system("/bin/chmod 777 /var/cgitest");

}
#endif

extern char *crypt(const char *key, const char *setting);

/* From local_passwd.c (C) Regents of Univ. of California blah blah */
static unsigned char itoa64[] =         /* 0 ... 63 => ascii - 64 */
        "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";

static void to64(register char *s, register long v, register int n) {
    while (--n >= 0) {
        *s++ = itoa64[v&0x3f];
        v >>= 6;
    }
}

char *crypt_password(const char *psw_org){
    char salt[3];
    char *cpw;

    (void) srandom( (int) time( (time_t*) 0 ) );
    to64( &salt[0], random(), 2 );
    cpw = crypt( psw_org, salt );
    return cpw;
}


int create_httpd_cfg()
{
	
        FILE *fp;
//	char *pt=nvram_get("wiz_language");
	
#if 0        
        /* We do not need multi-language  Argon 2003-12-03 */
	if(pt==NULL){
		system("/bin/ln -sf /www.eng /var/www");
		system("/bin/echo \"0\">/proc/language");
	}else if(strcmp(pt,"German")==0){
		system("/bin/ln -sf /www.deu /var/www");
		system("/bin/echo \"2\">/proc/language");
	}else if(strcmp(pt,"Italian")==0){
		system("/bin/ln -sf /www.ita /var/www");
		system("/bin/echo \"3\">/proc/language");
	}else if(strcmp(pt,"French")==0){
		system("/bin/ln -sf /www.fre /var/www");
		system("/bin/echo \"1\">/proc/language");
	}else{
		system("/bin/ln -sf /www.eng /var/www");
		system("/bin/echo \"0\">/proc/language");
	}
#endif /* 0 */     
        //mBUG("L<%d> http password is %s", __LINE__, nvram_get("http_password"));
	if(1/*strlen(nvram_get("http_password"))!=0*/){
		
	        if((fp=fopen(HTTPD_CONF,"w"))!=NULL){
                        //glb_dbg("will write to %s:%s to file %s"
                         //       ,HTTPD_CONF
			//	,nvram_safe_get("http_username")
			//	,nvram_safe_get("http_password"));
	        	fprintf(fp,"/:%s:%s\n"
					,nvram_safe_get("http_username")==NULL?"":nvram_safe_get("http_username")
					,nvram_safe_get("http_password")==NULL?"":nvram_safe_get("http_password")
					);/*crypt_password(nvram_safe_get("http_password")))*/; // for thttpd
		        fclose(fp);
		}
	}else
		unlink(HTTPD_CONF);	
			
	return 0;
}
int stop_httpd()
{
	system("/bin/killall mini_httpd >/dev/null 2>&1");
	system("/bin/killall httpd >/dev/null 2>&1"); //change for thttpd
	return 0;
}
int start_httpd()
{	
	create_httpd_cfg();
	//system("cp /etc/samba/passwd /var/passwd -f &>/dev/null");
	//SYSTEM("/sbin/thttpd");  // change for thttpd
	
	//SYSTEM("/sbin/httpd -p 80 -d /htdocs& ");
			
	SYSTEM("/sbin/httpd -p 80 -h /htdocs -c /var/htpasswd");
	//SYSTEM("/usr/sbin/thttpd -d /htdocs -c '*.cgi' -t %d&",
	//		atoi(nvram_safe_get("http_timeout"))*60);
			
return 0;
}
