#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <arpa/inet.h>
#include <ctype.h>
#include "nvram.h"
#include "rc.h"

#define EZIPUPDATE "/sbin/ez-ipupdate"


inline int start_ddns_update(void)
{
	char *enable,*user,*password,*host,*wan_ifname,*wild,*service;	
	FILE *fp;
	int tmp=0;
	
	system("killall "EZIPUPDATE);
	
	enable=nvram_safe_get("ddns_enable");	
	service=nvram_safe_get("ddns_service_provider");
	user=nvram_safe_get("ddns_user_name");
	password=nvram_safe_get("ddns_password");
	host=nvram_safe_get("ddns_host_name");
	wild=nvram_safe_get("ddns_use_wildcards");
	wan_ifname=nvram_safe_get("wan_ifname");
	
	if(*enable=='0')
		return 0;

	/* if update log is 1. bad authenticate
	 *		    2. nohost
	 *		    3. abuse
	 *		    4. the host is not managed by you ,
	 * we don't do update anymore */
	fp=fopen("/var/ddns_update.log","r");
	if(fp!=NULL){
		fscanf(fp,"%d",&tmp);
		fclose(fp);
		if(tmp==9||tmp==14||tmp==15||tmp==16)
			return 0;
	}
	
	if(*wild=='0'){		
		SYSTEM("%s -S %s -u \'%s\' -p \'%s\' -h %s -i %s -b /var/ddns.cache &"
				,EZIPUPDATE
				,service
				,user
				,password
				,host
				,wan_ifname);
		
	}else{
		SYSTEM("%s -S %s -u \'%s\' -p \'%s\' -h %s -i %s -w -b /var/ddns.cache &"
				,EZIPUPDATE
				,service
				,user
				,password
				,host
				,wan_ifname);
		}

	free(enable);
	free(service);
	free(user);
	free(password);
	free(host);
	free(wan_ifname);

	return 0;
}

