/*
 *  Sercomm ConFiGuration ManaGeR (scfgmgr) 
 *  
 *      +------------+    socket   +---------+-------+     +-------+	
 *	| CGI or AP  | <==========>| scfgmgr | nvram |<===>| flash |
 *	+------------+		   +---------+-------+     +-------+		
 *	    			     |
 *	    			     |create by scfgmgr
 *	+-------------+		+----V----+  
 *	| application |-------->|  conf	  |	
 *	+-------------+		+---------+
 *							released by Ron
 * 
 *	our socket communcation is similar packet
 *	
 *	+--------+--------------------------------+
 *	| header |	      payload		  |	 		
 *      +--------+--------------------------------+
 *      
 *      header format
 *      +-------------+----------------+
 *      | packet type | payload length |	
 *      +-------------+----------------+
 *      
 *      payload format 
 *      +-------+------+-------+------+--- ---+-------+-----------+
 *      | data1 | 0x00 | data2 | 0x00 | ----- | dataN | 0x00 0x00 |
 *      +-------+------+-------+------+--- ---+-------+-----------+
 *      data divide by 0x00
 *      data end by 0x00 0x00
 */

#ifndef _SCFGMGR_
#define _SCFGMGR_

/* define header type */
//#include "socket_header.h"

/* socket path */
#define SOCKET_PATH	"/var/scfgmgr_socket"

/* max wait time */
#define SOCKET_WAIT_TIME 10


#endif
